/* DUPLICATOR MYSQL SCRIPT CREATED ON : 2015-05-27 21:49:39 */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `hash` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_huge_itslider_images` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `slider_id` varchar(200) DEFAULT NULL,
  `description` text,
  `image_url` text,
  `sl_url` varchar(128) DEFAULT NULL,
  `sl_type` text NOT NULL,
  `link_target` text NOT NULL,
  `sl_stitle` text NOT NULL,
  `sl_sdesc` text NOT NULL,
  `sl_postlink` text NOT NULL,
  `ordering` int(11) NOT NULL,
  `published` tinyint(4) unsigned DEFAULT NULL,
  `published_in_sl_width` tinyint(4) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_huge_itslider_params` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 NOT NULL,
  `title` varchar(200) CHARACTER SET utf8 NOT NULL,
  `description` text CHARACTER SET utf8 NOT NULL,
  `value` varchar(200) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=127 DEFAULT CHARSET=latin1;

CREATE TABLE `wp_huge_itslider_sliders` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `sl_height` int(11) unsigned DEFAULT NULL,
  `sl_width` int(11) unsigned DEFAULT NULL,
  `pause_on_hover` text,
  `slider_list_effects_s` text,
  `description` text,
  `param` text,
  `sl_position` text NOT NULL,
  `ordering` int(11) NOT NULL,
  `published` text,
  `sl_loading_icon` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=563 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=200 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=87 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("4", "20150527_naturalremedies", "55663be904b1a9219150527214929", "20", "2015-05-27 21:49:39", "admin", "O:11:\"DUP_Package\":16:{s:2:\"ID\";i:4;s:4:\"Name\";s:24:\"20150527_naturalremedies\";s:4:\"Hash\";s:29:\"55663be904b1a9219150527214929\";s:8:\"NameHash\";s:54:\"20150527_naturalremedies_55663be904b1a9219150527214929\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:64:\"/home1/anton241/public_html/demobay.info/remedy/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://demobay.info/remedy/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"20150527_naturalremedies_55663be904b1a9219150527214929_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";s:66:\"20150527_naturalremedies_55663be904b1a9219150527214929_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:47:\"/home1/anton241/public_html/demobay.info/remedy\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:24:\"20150527_naturalremedies\";s:4:\"Hash\";s:29:\"55663be904b1a9219150527214929\";s:8:\"NameHash\";s:54:\"20150527_naturalremedies_55663be904b1a9219150527214929\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:64:\"/home1/anton241/public_html/demobay.info/remedy/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://demobay.info/remedy/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";s:68:\"20150527_naturalremedies_55663be904b1a9219150527214929_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":11:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:67:\"20150527_naturalremedies_55663be904b1a9219150527214929_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:58;}");

/* INSERT TABLE DATA: wp_huge_itslider_images */
INSERT INTO `wp_huge_itslider_images` VALUES("1", "", "1", "", "http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/e/natural_remedies_1432757336.jpg", "", "image", "on", "", "", "", "0", "1", NULL);
INSERT INTO `wp_huge_itslider_images` VALUES("2", "", "1", "", "http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/6/herbs_1432758070.jpg", "", "image", "on", "", "", "", "1", "1", NULL);
INSERT INTO `wp_huge_itslider_images` VALUES("3", "", "1", "", "http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/a/Basket_Flowers_1432710999.jpg", "", "image", "on", "", "", "", "2", "1", NULL);

/* INSERT TABLE DATA: wp_huge_itslider_params */
INSERT INTO `wp_huge_itslider_params` VALUES("89", "slider_crop_image", "Slider crop image", "Slider crop image", "resize");
INSERT INTO `wp_huge_itslider_params` VALUES("90", "slider_title_color", "Slider title color", "Slider title color", "000000");
INSERT INTO `wp_huge_itslider_params` VALUES("91", "slider_title_font_size", "Slider title font size", "Slider title font size", "13");
INSERT INTO `wp_huge_itslider_params` VALUES("92", "slider_description_color", "Slider description color", "Slider description color", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("93", "slider_description_font_size", "Slider description font size", "Slider description font size", "13");
INSERT INTO `wp_huge_itslider_params` VALUES("94", "slider_title_position", "Slider title position", "Slider title position", "right-top");
INSERT INTO `wp_huge_itslider_params` VALUES("95", "slider_description_position", "Slider description position", "Slider description position", "right-bottom");
INSERT INTO `wp_huge_itslider_params` VALUES("96", "slider_title_border_size", "Slider Title border size", "Slider Title border size", "0");
INSERT INTO `wp_huge_itslider_params` VALUES("97", "slider_title_border_color", "Slider title border color", "Slider title border color", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("98", "slider_title_border_radius", "Slider title border radius", "Slider title border radius", "4");
INSERT INTO `wp_huge_itslider_params` VALUES("99", "slider_description_border_size", "Slider description border size", "Slider description border size", "0");
INSERT INTO `wp_huge_itslider_params` VALUES("100", "slider_description_border_color", "Slider description border color", "Slider description border color", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("101", "slider_description_border_radius", "Slider description border radius", "Slider description border radius", "0");
INSERT INTO `wp_huge_itslider_params` VALUES("102", "slider_slideshow_border_size", "Slider border size", "Slider border size", "0");
INSERT INTO `wp_huge_itslider_params` VALUES("103", "slider_slideshow_border_color", "Slider border color", "Slider border color", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("104", "slider_slideshow_border_radius", "Slider border radius", "Slider border radius", "0");
INSERT INTO `wp_huge_itslider_params` VALUES("105", "slider_navigation_type", "Slider navigation type", "Slider navigation type", "1");
INSERT INTO `wp_huge_itslider_params` VALUES("106", "slider_navigation_position", "Slider navigation position", "Slider navigation position", "bottom");
INSERT INTO `wp_huge_itslider_params` VALUES("107", "slider_title_background_color", "Slider title background color", "Slider title background color", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("108", "slider_description_background_color", "Slider description background color", "Slider description background color", "000000");
INSERT INTO `wp_huge_itslider_params` VALUES("109", "slider_title_transparent", "Slider title has background", "Slider title has background", "on");
INSERT INTO `wp_huge_itslider_params` VALUES("110", "slider_description_transparent", "Slider description has background", "Slider description has background", "on");
INSERT INTO `wp_huge_itslider_params` VALUES("111", "slider_slider_background_color", "Slider slider background color", "Slider slider background color", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("112", "slider_dots_position", "slider dots position", "slider dots position", "top");
INSERT INTO `wp_huge_itslider_params` VALUES("113", "slider_active_dot_color", "slider active dot color", "", "ffffff");
INSERT INTO `wp_huge_itslider_params` VALUES("114", "slider_dots_color", "slider dots color", "", "000000");
INSERT INTO `wp_huge_itslider_params` VALUES("115", "slider_description_width", "Slider description width", "Slider description width", "70");
INSERT INTO `wp_huge_itslider_params` VALUES("116", "slider_description_height", "Slider description height", "Slider description height", "50");
INSERT INTO `wp_huge_itslider_params` VALUES("117", "slider_description_background_transparency", "slider description background transparency", "slider description background transparency", "70");
INSERT INTO `wp_huge_itslider_params` VALUES("118", "slider_description_text_align", "description text-align", "description text-align", "justify");
INSERT INTO `wp_huge_itslider_params` VALUES("119", "slider_title_width", "slider title width", "slider title width", "30");
INSERT INTO `wp_huge_itslider_params` VALUES("120", "slider_title_height", "slider title height", "slider title height", "50");
INSERT INTO `wp_huge_itslider_params` VALUES("121", "slider_title_background_transparency", "slider title background transparency", "slider title background transparency", "70");
INSERT INTO `wp_huge_itslider_params` VALUES("122", "slider_title_text_align", "title text-align", "title text-align", "right");
INSERT INTO `wp_huge_itslider_params` VALUES("123", "slider_title_has_margin", "title has margin", "title has margin", "on");
INSERT INTO `wp_huge_itslider_params` VALUES("124", "slider_description_has_margin", "description has margin", "description has margin", "on");
INSERT INTO `wp_huge_itslider_params` VALUES("125", "slider_show_arrows", "Slider show left right arrows", "Slider show left right arrows", "on");
INSERT INTO `wp_huge_itslider_params` VALUES("126", "loading_icon_type", "Slider loading icon type", "Slider loading icon type", "1");

/* INSERT TABLE DATA: wp_huge_itslider_sliders */
INSERT INTO `wp_huge_itslider_sliders` VALUES("1", "My First Slider", "375", "600", "on", "random", "4000", "1000", "center", "1", "300", "off");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://demobay.info/remedy", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://demobay.info/remedy", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "Natural Remedies", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "mail@yourmail.com", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:15:{i:0;s:39:\"ad-squares-widget/ad-squares-widget.php\";i:1;s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";i:2;s:25:\"duplicator/duplicator.php\";i:3;s:22:\"obox-mobile/mobile.php\";i:4;s:33:\"privacy-policy/privacy-policy.php\";i:5;s:23:\"slider-image/slider.php\";i:6;s:30:\"smart-youtube/smartyoutube.php\";i:7;s:41:\"social-share-boost/social-share-boost.php\";i:8;s:24:\"wordpress-seo/wp-seo.php\";i:9;s:34:\"wp-contact-form/wp-contactform.php\";i:10;s:27:\"wp-super-cache/wp-cache.php\";i:11;s:32:\"wpfree-images/pixabay-images.php\";i:12;s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";i:13;s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";i:14;s:26:\"youtube-widget/youtube.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("37", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("38", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("39", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("40", "recently_edited", "a:5:{i:0;s:102:\"/home1/anton241/public_html/demobay.info/remedy/wp-content/themes/gazette/includes/theme-functions.php\";i:1;s:83:\"/home1/anton241/public_html/demobay.info/remedy/wp-content/themes/gazette/index.php\";i:2;s:83:\"/home1/anton241/public_html/demobay.info/remedy/wp-content/themes/gazette/style.css\";i:3;s:84:\"/home1/anton241/public_html/demobay.info/remedy/wp-content/themes/gazette/footer.php\";i:4;s:0:\"\";}", "no");
INSERT INTO `wp_options` VALUES("41", "template", "gazette", "yes");
INSERT INTO `wp_options` VALUES("42", "stylesheet", "gazette", "yes");
INSERT INTO `wp_options` VALUES("43", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("44", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("45", "comment_registration", "1", "yes");
INSERT INTO `wp_options` VALUES("46", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("47", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("48", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("49", "db_version", "31535", "yes");
INSERT INTO `wp_options` VALUES("50", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("51", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("52", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("53", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("54", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("55", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("56", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("57", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("58", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("61", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("64", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("69", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_for_old_posts", "1", "yes");
INSERT INTO `wp_options` VALUES("71", "close_comments_days_old", "1", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("73", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("74", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("75", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("76", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("77", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("78", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_categories", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_text", "a:3:{i:1;a:0:{}i:3;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:394:\"<div class=\"AW-Form-1306470723\"></div>\r\n<script type=\"text/javascript\">(function(d, s, id) {\r\n    var js, fjs = d.getElementsByTagName(s)[0];\r\n    if (d.getElementById(id)) return;\r\n    js = d.createElement(s); js.id = id;\r\n    js.src = \"http://forms.aweber.com/form/23/1306470723.js\";\r\n    fjs.parentNode.insertBefore(js, fjs);\r\n    }(document, \"script\", \"aweber-wjs-5pbnfzm32\"));\r\n</script>\r\n\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("81", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("82", "uninstall_plugins", "a:1:{s:27:\"wp-super-cache/wp-cache.php\";s:23:\"wpsupercache_deactivate\";}", "no");
INSERT INTO `wp_options` VALUES("83", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("84", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("85", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("86", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "initial_db_version", "31535", "yes");
INSERT INTO `wp_options` VALUES("89", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:63:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:15:\"wpseo_bulk_edit\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:35:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("90", "widget_search", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("91", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("92", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "sidebars_widgets", "a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:4:{i:0;s:20:\"youtube_responsive-2\";i:1;s:14:\"recent-posts-2\";i:2;s:30:\"clickbank_ads_widget_version-2\";i:3;s:6:\"text-3\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("96", "mm_coming_soon", "false", "yes");
INSERT INTO `wp_options` VALUES("97", "cron", "a:16:{i:1432763606;a:1:{s:25:\"wpseo_ping_search_engines\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:0:{}}}}i:1432763760;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"d38bf3ceef616da487e3a5a67efee824\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:52;}}}}i:1432763788;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"c824bc7a784ee3d8f78d22b52f53879b\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:53;}}}}i:1432763819;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"a05c27d65e3068dce804d1d1ad40def4\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:54;}}}}i:1432763844;a:1:{s:14:\"mm_cron_hourly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1432763847;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"67a23b5262f56e030eab46a20e266de7\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:55;}}}}i:1432763892;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"1a89a2a2129300c1da6763ba0380ed1f\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:56;}}}}i:1432765289;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1432765310;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1432767444;a:2:{s:13:\"mm_cron_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:18:\"mm_cron_twicedaily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1432771200;a:1:{s:11:\"wp_cache_gc\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1432793654;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1432802192;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1433285844;a:1:{s:14:\"mm_cron_weekly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1435316244;a:1:{s:15:\"mm_cron_monthly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2635200;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("112", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("131", "recently_activated", "a:5:{s:44:\"featured-content-gallery/content-gallery.php\";i:1432756731;s:36:\"google-sitemap-generator/sitemap.php\";i:1432743126;s:40:\"mojo-marketplace-hg/mojo-marketplace.php\";i:1432737425;s:19:\"jetpack/jetpack.php\";i:1432737420;s:19:\"hgwalkme/walkme.php\";i:1432737415;}", "yes");
INSERT INTO `wp_options` VALUES("132", "ossdl_off_cdn_url", "http://demobay.info/remedy", "yes");
INSERT INTO `wp_options` VALUES("133", "ossdl_off_include_dirs", "wp-content,wp-includes", "yes");
INSERT INTO `wp_options` VALUES("134", "ossdl_off_exclude", ".php", "yes");
INSERT INTO `wp_options` VALUES("135", "ossdl_cname", "", "yes");
INSERT INTO `wp_options` VALUES("138", "jetpack_file_data", "a:1:{s:5:\"3.5.3\";a:48:{s:32:\"ec342dbdde40e6ce2c28b0b26f6b5531\";a:13:{s:4:\"name\";s:20:\"Spelling and Grammar\";s:11:\"description\";s:89:\"Check your spelling, style, and grammar with the After the Deadline proofreading service.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"6\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";s:7:\"feature\";s:0:\"\";}s:32:\"d0743f43156a9efc9ca36d3d144f096f\";a:13:{s:4:\"name\";s:8:\"Carousel\";s:11:\"description\";s:63:\"Transform standard image galleries into full-screen slideshows.\";s:14:\"jumpstart_desc\";s:79:\"brings your photos and images to life as full-size, easily navigable galleries.\";s:4:\"sort\";s:2:\"22\";s:20:\"recommendation_order\";s:2:\"12\";s:10:\"introduced\";s:3:\"1.5\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:17:\"Photos and Videos\";s:7:\"feature\";s:9:\"Jumpstart\";}s:32:\"ce2dce23309a4d03f9dd766d1d10fc3f\";a:13:{s:4:\"name\";s:16:\"Jetpack Comments\";s:11:\"description\";s:79:\"Let readers comment with WordPress.com, Twitter, Facebook, or Google+ accounts.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"20\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.4\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:6:\"Social\";s:7:\"feature\";s:0:\"\";}s:32:\"7cbc0fd668be49924cefb1a4e8161829\";a:13:{s:4:\"name\";s:12:\"Contact Form\";s:11:\"description\";s:44:\"Insert a contact form anywhere on your site.\";s:14:\"jumpstart_desc\";s:111:\"adds a button to your post and page editors, allowing you to build simple forms to help visitors stay in touch.\";s:4:\"sort\";s:2:\"15\";s:20:\"recommendation_order\";s:2:\"14\";s:10:\"introduced\";s:3:\"1.3\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:5:\"Other\";s:7:\"feature\";s:9:\"Jumpstart\";}s:32:\"bd694d7ae2dfa214372f51191799e845\";a:13:{s:4:\"name\";s:20:\"Custom Content Types\";s:11:\"description\";s:92:\"Organize and display different types of content on your site, separate from posts and pages.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"34\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"3.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";s:7:\"feature\";s:0:\"\";}s:32:\"b4cf1688653cefcafbfa062ee8c4b16d\";a:13:{s:4:\"name\";s:10:\"Custom CSS\";s:11:\"description\";s:57:\"Customize your site’s CSS without modifying your theme.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"2\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.7\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:10:\"Appearance\";s:7:\"feature\";s:0:\"\";}s:32:\"f896860ba2f925e07a64e45cad42ff8f\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"60ae7226c03943e30daabf78f9c33b42\";a:13:{s:4:\"name\";s:21:\"Enhanced Distribution\";s:11:\"description\";s:74:\"Share your public posts and comments to search engines and other services.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"5\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:6:\"Public\";s:11:\"module_tags\";s:7:\"Writing\";s:7:\"feature\";s:0:\"\";}s:32:\"fc39fea98498db540ce7d52c1c6aa566\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"028d9eb47b68caf97fa8af21af0516be\";a:13:{s:4:\"name\";s:19:\"Gravatar Hovercards\";s:11:\"description\";s:58:\"Enable pop-up business cards over commenters’ Gravatars.\";s:14:\"jumpstart_desc\";s:131:\"let commenters link their profiles to their Gravatar accounts, making it easy for your visitors to learn more about your community.\";s:4:\"sort\";s:2:\"11\";s:20:\"recommendation_order\";s:2:\"13\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:18:\"Social, Appearance\";s:7:\"feature\";s:9:\"Jumpstart\";}s:32:\"5a7a51e01fdff7d25db264070b5ff8e0\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:8:\"2.0.3 ??\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"22a6e8518f9be52017983c4c49181eee\";a:13:{s:4:\"name\";s:15:\"Infinite Scroll\";s:11:\"description\";s:46:\"Add support for infinite scroll to your theme.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"26\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:10:\"Appearance\";s:7:\"feature\";s:0:\"\";}s:32:\"c3713f40fab90487d1e7dad2579e067e\";a:13:{s:4:\"name\";s:8:\"JSON API\";s:11:\"description\";s:69:\"Allow applications to securely access your content through the cloud.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"19\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.9\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:6:\"Public\";s:11:\"module_tags\";s:19:\"Writing, Developers\";s:7:\"feature\";s:0:\"\";}s:32:\"4ace9d33cfbef8e5ac002214ba1b5b05\";a:13:{s:4:\"name\";s:14:\"Beautiful Math\";s:11:\"description\";s:85:\"Use LaTeX markup language in posts and pages for complex equations and other geekery.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"12\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";s:7:\"feature\";s:0:\"\";}s:32:\"253c5d7bfe48737523b88ea71bafc6be\";a:13:{s:4:\"name\";s:5:\"Likes\";s:11:\"description\";s:70:\"Give visitors an easy way to show their appreciation for your content.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"23\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:6:\"Social\";s:7:\"feature\";s:0:\"\";}s:32:\"3c5dbeeff87a60bbd6d26200124edab1\";a:13:{s:4:\"name\";s:6:\"Manage\";s:11:\"description\";s:76:\"Manage all your sites from a centralized place, https://wordpress.com/sites.\";s:14:\"jumpstart_desc\";s:151:\"helps you remotely manage plugins, turn on automated updates, and more from <a href=\"https://wordpress.com/plugins/\" target=\"_blank\">wordpress.com</a>.\";s:4:\"sort\";s:1:\"1\";s:20:\"recommendation_order\";s:1:\"3\";s:10:\"introduced\";s:3:\"3.4\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:35:\"Centralized Management, Recommended\";s:7:\"feature\";s:22:\"Recommended, Jumpstart\";}s:32:\"36453d700c9d1a1a82cd218f744492b0\";a:13:{s:4:\"name\";s:8:\"Markdown\";s:11:\"description\";s:51:\"Write posts or pages in plain-text Markdown syntax.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"31\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.8\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:7:\"Writing\";s:7:\"feature\";s:0:\"\";}s:32:\"c140ab3efac716eeb84e476c5b79c538\";a:13:{s:4:\"name\";s:12:\"Mobile Theme\";s:11:\"description\";s:64:\"Optimize your site with a mobile-friendly theme for smartphones.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"21\";s:20:\"recommendation_order\";s:2:\"11\";s:10:\"introduced\";s:3:\"1.8\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:31:\"Appearance, Mobile, Recommended\";s:7:\"feature\";s:11:\"Recommended\";}s:32:\"eb9e7e878720f8812366a1bc91cbdfa5\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"acb9a6e2cf10321eea8d4782ae2c0dd3\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"66c103669ce5a093f417d0d3001275f4\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"e071a7396e51424c0fb8e9b37719f60f\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"2cd17f35caf9abb385e8a36b4575b58b\";a:13:{s:4:\"name\";s:7:\"Monitor\";s:11:\"description\";s:88:\"Receive notifications from Jetpack if your site goes offline — and when it it returns.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"28\";s:20:\"recommendation_order\";s:2:\"10\";s:10:\"introduced\";s:3:\"2.6\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:11:\"Recommended\";s:7:\"feature\";s:11:\"Recommended\";}s:32:\"d81661d36e71c0030feba0e0fa9dcd85\";a:13:{s:4:\"name\";s:13:\"Notifications\";s:11:\"description\";s:84:\"Receive notification of site activity via the admin toolbar and your Mobile devices.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"13\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.9\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:5:\"Other\";s:7:\"feature\";s:0:\"\";}s:32:\"7d2d35ca8b9fd5d02bada85d2e203baa\";a:13:{s:4:\"name\";s:10:\"Omnisearch\";s:11:\"description\";s:66:\"Search your entire database from a single field in your Dashboard.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"16\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.3\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:10:\"Developers\";s:7:\"feature\";s:0:\"\";}s:32:\"1064bd6f6466265ef5c36ca39e98c97a\";a:13:{s:4:\"name\";s:6:\"Photon\";s:11:\"description\";s:66:\"Accelerate your site by loading images from the WordPress.com CDN.\";s:14:\"jumpstart_desc\";s:141:\"mirrors and serves your images from our free and fast image CDN, improving your site’s performance with no additional load on your servers.\";s:4:\"sort\";s:2:\"25\";s:20:\"recommendation_order\";s:1:\"1\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:42:\"Photos and Videos, Appearance, Recommended\";s:7:\"feature\";s:22:\"Recommended, Jumpstart\";}s:32:\"fb810210218d096c421f9a9d1e0d247b\";a:13:{s:4:\"name\";s:13:\"Post by Email\";s:11:\"description\";s:58:\"Publish posts by email, using any device and email client.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"14\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";s:7:\"feature\";s:0:\"\";}s:32:\"d0c62e1c24c98f5d5cafa8e099e40cb8\";a:13:{s:4:\"name\";s:7:\"Protect\";s:11:\"description\";s:70:\"Adds brute force protection to your login page. Formerly BruteProtect.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"1\";s:20:\"recommendation_order\";s:1:\"4\";s:10:\"introduced\";s:3:\"3.4\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:11:\"Recommended\";s:7:\"feature\";s:11:\"Recommended\";}s:32:\"daf66b46a3369c21a42c00ab2f5b9237\";a:13:{s:4:\"name\";s:9:\"Publicize\";s:11:\"description\";s:55:\"Share new posts on social media networks automatically.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"10\";s:20:\"recommendation_order\";s:1:\"7\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:19:\"Social, Recommended\";s:7:\"feature\";s:11:\"Recommended\";}s:32:\"69daaab11eae21a4f878645c438049ae\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"d3c51baf24c4ce072f0d6cec62d78883\";a:13:{s:4:\"name\";s:13:\"Related Posts\";s:11:\"description\";s:60:\"Display links to your related content under posts and pages.\";s:14:\"jumpstart_desc\";s:113:\"keep visitors engaged on your blog by highlighting relevant and new content at the bottom of each published post.\";s:4:\"sort\";s:2:\"29\";s:20:\"recommendation_order\";s:1:\"9\";s:10:\"introduced\";s:3:\"2.9\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:11:\"Recommended\";s:7:\"feature\";s:22:\"Recommended, Jumpstart\";}s:32:\"7389f7289cced40392bb2f87a439ce37\";a:13:{s:4:\"name\";s:7:\"Sharing\";s:11:\"description\";s:81:\"Allow visitors to share your content on Facebook, Twitter, and more with a click.\";s:14:\"jumpstart_desc\";s:116:\"Twitter, Facebook and Google+ buttons at the bottom of each post, making it easy for visitors to share your content.\";s:4:\"sort\";s:1:\"7\";s:20:\"recommendation_order\";s:1:\"6\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:3:\"1.2\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:19:\"Social, Recommended\";s:7:\"feature\";s:22:\"Recommended, Jumpstart\";}s:32:\"9e250606178972f2fdf4b931d44988fa\";a:13:{s:4:\"name\";s:16:\"Shortcode Embeds\";s:11:\"description\";s:77:\"Embed content from YouTube, Vimeo, SlideShare, and more, no coding necessary.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"3\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:3:\"1.2\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:46:\"Photos and Videos, Social, Writing, Appearance\";s:7:\"feature\";s:0:\"\";}s:32:\"2be8fdde96739fdd899116b131de1603\";a:13:{s:4:\"name\";s:16:\"WP.me Shortlinks\";s:11:\"description\";s:56:\"Enable WP.me-powered shortlinks for all posts and pages.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"8\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:6:\"Social\";s:7:\"feature\";s:0:\"\";}s:32:\"f4860b8ae19cfe3bdfed20ffa71255e6\";a:13:{s:4:\"name\";s:9:\"Site Icon\";s:11:\"description\";s:29:\"Add a site icon to your site.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"22\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"3.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:5:\"Other\";s:7:\"feature\";s:0:\"\";}s:32:\"ef867e6fd019bf90d9462d26a2ec94f3\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"014c15d5f50d27f9285b84ba3b81aa81\";a:13:{s:4:\"name\";s:22:\"Jetpack Single Sign On\";s:11:\"description\";s:62:\"Allow your users to log in using their WordPress.com accounts.\";s:14:\"jumpstart_desc\";s:97:\"lets you login to all your Jetpack-enabled sites with one click using your WordPress.com account.\";s:4:\"sort\";s:2:\"30\";s:20:\"recommendation_order\";s:1:\"5\";s:10:\"introduced\";s:3:\"2.6\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:10:\"Developers\";s:7:\"feature\";s:9:\"Jumpstart\";}s:32:\"44fc0241f637fe8b918a415e5ee14e80\";a:13:{s:4:\"name\";s:19:\"WordPress.com Stats\";s:11:\"description\";s:85:\"Monitor your stats with clear, concise reports and no additional load on your server.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"1\";s:20:\"recommendation_order\";s:1:\"2\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:32:\"WordPress.com Stats, Recommended\";s:7:\"feature\";s:11:\"Recommended\";}s:32:\"9c2dcba40e6122b747f409ad6b52d852\";a:13:{s:4:\"name\";s:13:\"Subscriptions\";s:11:\"description\";s:88:\"Allow users to subscribe to your posts and comments and receive notifications via email.\";s:14:\"jumpstart_desc\";s:126:\"give visitors two easy subscription options — while commenting, or via a separate email subscription widget you can display.\";s:4:\"sort\";s:1:\"9\";s:20:\"recommendation_order\";s:1:\"8\";s:10:\"introduced\";s:3:\"1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:6:\"Social\";s:7:\"feature\";s:9:\"Jumpstart\";}s:32:\"a679b3326090f7ea228b3af62449b205\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"b090ad159625cd22beda0092962ec1eb\";a:13:{s:4:\"name\";s:15:\"Tiled Galleries\";s:11:\"description\";s:73:\"Display your image galleries in a variety of sleek, graphic arrangements.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"24\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:17:\"Photos and Videos\";s:7:\"feature\";s:0:\"\";}s:32:\"e17e540b626bb6eba8f1b16c7dea935e\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"0a8f11b1bdf24e1e2027d9c3ba3fe709\";a:13:{s:4:\"name\";s:10:\"VaultPress\";s:11:\"description\";s:85:\"Protect your site with automatic backups and security scans. (Subscription required.)\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"32\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:5:\"0:1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:5:\"false\";s:4:\"free\";s:5:\"false\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"91fc6fa34d6f2b7a7b8ba9c0fe507933\";a:13:{s:4:\"name\";s:17:\"Site Verification\";s:11:\"description\";s:78:\"Verify your site or domain with Google Webmaster Tools, Pinterest, and others.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"33\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"3.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}s:32:\"561be512d01eac03766ebe39ca50cf1f\";a:13:{s:4:\"name\";s:10:\"VideoPress\";s:11:\"description\";s:68:\"Upload and embed videos right on your site. (Subscription required.)\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"27\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.5\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:5:\"false\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:17:\"Photos and Videos\";s:7:\"feature\";s:0:\"\";}s:32:\"845fee27ba3aa2749075ee8af1101f2a\";a:13:{s:4:\"name\";s:17:\"Widget Visibility\";s:11:\"description\";s:57:\"Specify which widgets appear on which pages of your site.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:2:\"17\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"2.4\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:10:\"Appearance\";s:7:\"feature\";s:0:\"\";}s:32:\"ed18321b2b897f0d3dbecbe78561e997\";a:13:{s:4:\"name\";s:21:\"Extra Sidebar Widgets\";s:11:\"description\";s:79:\"Add images, Twitter streams, your site’s RSS links, and more to your sidebar.\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:1:\"4\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:3:\"1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:18:\"Social, Appearance\";s:7:\"feature\";s:0:\"\";}s:32:\"6c07267dbe6a8eac481aff78df3c3134\";a:13:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:14:\"jumpstart_desc\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:20:\"recommendation_order\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";s:7:\"feature\";s:0:\"\";}}}", "yes");
INSERT INTO `wp_options` VALUES("139", "jetpack_available_modules", "a:1:{s:5:\"3.5.3\";a:36:{s:18:\"after-the-deadline\";s:3:\"1.1\";s:8:\"carousel\";s:3:\"1.5\";s:8:\"comments\";s:3:\"1.4\";s:12:\"contact-form\";s:3:\"1.3\";s:20:\"custom-content-types\";s:3:\"3.1\";s:10:\"custom-css\";s:3:\"1.7\";s:21:\"enhanced-distribution\";s:3:\"1.2\";s:19:\"gravatar-hovercards\";s:3:\"1.1\";s:15:\"infinite-scroll\";s:3:\"2.0\";s:8:\"json-api\";s:3:\"1.9\";s:5:\"latex\";s:3:\"1.1\";s:5:\"likes\";s:3:\"2.2\";s:6:\"manage\";s:3:\"3.4\";s:8:\"markdown\";s:3:\"2.8\";s:9:\"minileven\";s:3:\"1.8\";s:7:\"monitor\";s:3:\"2.6\";s:5:\"notes\";s:3:\"1.9\";s:10:\"omnisearch\";s:3:\"2.3\";s:6:\"photon\";s:3:\"2.0\";s:13:\"post-by-email\";s:3:\"2.0\";s:7:\"protect\";s:3:\"3.4\";s:9:\"publicize\";s:3:\"2.0\";s:13:\"related-posts\";s:3:\"2.9\";s:10:\"sharedaddy\";s:3:\"1.1\";s:10:\"shortcodes\";s:3:\"1.1\";s:10:\"shortlinks\";s:3:\"1.1\";s:9:\"site-icon\";s:3:\"3.2\";s:3:\"sso\";s:3:\"2.6\";s:5:\"stats\";s:3:\"1.1\";s:13:\"subscriptions\";s:3:\"1.2\";s:13:\"tiled-gallery\";s:3:\"2.1\";s:10:\"vaultpress\";s:5:\"0:1.2\";s:18:\"verification-tools\";s:3:\"3.0\";s:10:\"videopress\";s:3:\"2.5\";s:17:\"widget-visibility\";s:3:\"2.4\";s:7:\"widgets\";s:3:\"1.2\";}}", "yes");
INSERT INTO `wp_options` VALUES("141", "wpsupercache_gc_time", "1432707024", "yes");
INSERT INTO `wp_options` VALUES("142", "jetpack_security_report", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("147", "WPLANG", "", "yes");
INSERT INTO `wp_options` VALUES("154", "mm_master_aff", "hostgator", "yes");
INSERT INTO `wp_options` VALUES("155", "mm_install_date", "May 26, 2015", "yes");
INSERT INTO `wp_options` VALUES("156", "mm_cron", "a:4:{s:6:\"hourly\";a:0:{}s:5:\"daily\";a:1:{s:14:\"plugin_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:14:\"plugin_version\";s:2:\"el\";s:5:\"0.7.1\";}}s:7:\"monthly\";a:4:{s:11:\"php_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:11:\"php_version\";s:2:\"el\";s:6:\"5.4.38\";}s:12:\"plugin_count\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:12:\"plugin_count\";s:2:\"el\";i:8;}s:11:\"theme_count\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:11:\"theme_count\";s:2:\"el\";i:5;}s:13:\"current_theme\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:13:\"current_theme\";s:2:\"el\";s:7:\"gazette\";}}s:6:\"weekly\";a:1:{s:10:\"wp_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:10:\"wp_version\";s:2:\"el\";s:5:\"4.2.2\";}}}", "yes");
INSERT INTO `wp_options` VALUES("160", "jetpack_updates", "a:7:{s:7:\"plugins\";i:0;s:6:\"themes\";i:0;s:9:\"wordpress\";i:0;s:12:\"translations\";i:0;s:5:\"total\";i:0;s:10:\"wp_version\";s:5:\"4.2.2\";s:26:\"site_is_version_controlled\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("168", "allow_major_auto_core_updates", "true", "yes");
INSERT INTO `wp_options` VALUES("202", "theme_mods_twentyfifteen", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1432681081;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("203", "current_theme", "Gazette Edition", "yes");
INSERT INTO `wp_options` VALUES("204", "theme_mods_lifestyle_20", "a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1432681384;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";N;s:9:\"sidebar-3\";N;}}}", "yes");
INSERT INTO `wp_options` VALUES("205", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("207", "revlifestyle_ad_468", "<iframe width=\\\"560\\\" height=\\\"315\\\" src=\\\"https://www.youtube.com/embed/X1fVlYUxZlE?rel=0\\\" frameborder=\\\"0\\\" allowfullscreen></iframe>", "yes");
INSERT INTO `wp_options` VALUES("208", "revlifestyle_ad_120", "Enter 120x240 Banner Code Here", "yes");
INSERT INTO `wp_options` VALUES("209", "revlifestyle_adsense_468", "<a href=\\\"http://sheila57.fcraftplan.hop.clickbank.net\\\"> <img \r\nsrc=\\\"http://www.furniturecraftplans.com/images/banner-468x60.gif\\\" \r\nwidth=\\\"468\\\" height=\\\"60\\\"> </a>", "yes");
INSERT INTO `wp_options` VALUES("210", "revlifestyle_adsense_300", "<div class=\\\"AW-Form-1306470723\\\"></div>\r\n<script type=\\\"text/javascript\\\">(function(d, s, id) {\r\n    var js, fjs = d.getElementsByTagName(s)[0];\r\n    if (d.getElementById(id)) return;\r\n    js = d.createElement(s); js.id = id;\r\n    js.src = \\\"http://forms.aweber.com/form/23/1306470723.js\\\";\r\n    fjs.parentNode.insertBefore(js, fjs);\r\n    }(document, \\\"script\\\", \\\"aweber-wjs-5pbnfzm32\\\"));\r\n</script>", "yes");
INSERT INTO `wp_options` VALUES("211", "revlifestyle_video", "<iframe width=\\\"300\\\" height=\\\"250\\\" src=\\\"https://www.youtube.com/embed/X1fVlYUxZlE?rel=0\\\" frameborder=\\\"0\\\" allowfullscreen></iframe>", "yes");
INSERT INTO `wp_options` VALUES("212", "widget_calendar", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("213", "widget_nav_menu", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("214", "widget_mojo_widget", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("215", "widget_pages", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("217", "widget_tag_cloud", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("220", "theme_mods_gazette", "a:1:{i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("221", "woo_framework_version", "5.5.5", "yes");
INSERT INTO `wp_options` VALUES("223", "woo_options", "a:52:{s:18:\"woo_alt_stylesheet\";s:11:\"default.css\";s:8:\"woo_logo\";s:0:\"\";s:13:\"woo_texttitle\";s:4:\"true\";s:18:\"woo_custom_favicon\";s:0:\"\";s:20:\"woo_google_analytics\";s:0:\"\";s:18:\"woo_feedburner_url\";s:0:\"\";s:17:\"woo_feedburner_id\";s:0:\"\";s:14:\"woo_custom_css\";s:0:\"\";s:17:\"woo_show_carousel\";s:5:\"false\";s:21:\"woo_featured_category\";s:18:\"Select a category:\";s:16:\"woo_feat_entries\";s:16:\"Select a number:\";s:27:\"woo_slider_magazine_exclude\";s:4:\"true\";s:16:\"woo_slider_sfade\";s:5:\"false\";s:16:\"woo_slider_cfade\";s:5:\"false\";s:16:\"woo_slider_speed\";s:3:\"0.6\";s:18:\"woo_slider_timeout\";s:1:\"6\";s:24:\"woo_slider_content_speed\";s:3:\"0.6\";s:19:\"woo_carousel_height\";s:3:\"292\";s:8:\"woo_home\";s:5:\"false\";s:16:\"woo_blog_excerpt\";s:4:\"true\";s:19:\"woo_archive_excerpt\";s:4:\"true\";s:10:\"woo_author\";s:5:\"false\";s:14:\"woo_show_video\";s:5:\"false\";s:17:\"woo_exclude_video\";s:5:\"false\";s:18:\"woo_video_category\";s:18:\"Select a category:\";s:18:\"woo_wpthumb_notice\";s:0:\"\";s:22:\"woo_post_image_support\";s:4:\"true\";s:14:\"woo_pis_resize\";s:4:\"true\";s:17:\"woo_pis_hard_crop\";s:4:\"true\";s:10:\"woo_resize\";s:4:\"true\";s:12:\"woo_auto_img\";s:5:\"false\";s:20:\"woo_home_thumb_width\";s:3:\"100\";s:21:\"woo_home_thumb_height\";s:2:\"57\";s:15:\"woo_thumb_width\";s:3:\"100\";s:16:\"woo_thumb_height\";s:2:\"57\";s:16:\"woo_image_single\";s:5:\"false\";s:16:\"woo_single_width\";s:3:\"250\";s:17:\"woo_single_height\";s:3:\"180\";s:13:\"woo_rss_thumb\";s:5:\"false\";s:18:\"woo_ad_top_disable\";s:5:\"false\";s:18:\"woo_ad_top_adsense\";s:182:\"<a href=\"http://sheila57.acepublish.hop.clickbank.net\"><img src=\"http://www.varicoseveincures.com/images/468X60.jpg\" alt=\"How To Get Rid Of Varicose Veins Naturally.\" border=\"0\"></a>\";s:16:\"woo_ad_top_image\";s:40:\"http://www.woothemes.com/ads/468x60a.jpg\";s:14:\"woo_ad_top_url\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ads_rotate\";s:4:\"true\";s:14:\"woo_ad_image_1\";s:41:\"http://www.woothemes.com/ads/125x125a.jpg\";s:12:\"woo_ad_url_1\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_2\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_2\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_3\";s:41:\"http://www.woothemes.com/ads/125x125c.jpg\";s:12:\"woo_ad_url_3\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_4\";s:41:\"http://www.woothemes.com/ads/125x125d.jpg\";s:12:\"woo_ad_url_4\";s:24:\"http://www.woothemes.com\";}", "yes");
INSERT INTO `wp_options` VALUES("224", "woo_template", "a:56:{i:0;a:3:{s:4:\"name\";s:16:\"General Settings\";s:4:\"icon\";s:7:\"general\";s:4:\"type\";s:7:\"heading\";}i:1;a:6:{s:4:\"name\";s:16:\"Theme Stylesheet\";s:4:\"desc\";s:38:\"Please select your colour scheme here.\";s:2:\"id\";s:18:\"woo_alt_stylesheet\";s:3:\"std\";s:11:\"default.css\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:4:{i:0;s:11:\"default.css\";i:1;s:12:\"darkblue.css\";i:2;s:9:\"green.css\";i:3;s:13:\"lightblue.css\";}}i:2;a:5:{s:4:\"name\";s:11:\"Custom Logo\";s:4:\"desc\";s:63:\"Upload a logo for your theme, or specify an image URL directly.\";s:2:\"id\";s:8:\"woo_logo\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"upload\";}i:3;a:5:{s:4:\"name\";s:10:\"Text Title\";s:4:\"desc\";s:109:\"Enable if you want Blog Title and Tagline to be text-based. Setup title/tagline in WP -> Settings -> General.\";s:2:\"id\";s:13:\"woo_texttitle\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:4;a:5:{s:4:\"name\";s:14:\"Custom Favicon\";s:4:\"desc\";s:113:\"Upload a 16px x 16px <a href=\'http://www.faviconr.com/\'>ico image</a> that will represent your website\'s favicon.\";s:2:\"id\";s:18:\"woo_custom_favicon\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"upload\";}i:5;a:5:{s:4:\"name\";s:13:\"Tracking Code\";s:4:\"desc\";s:117:\"Paste your Google Analytics (or other) tracking code here. This will be added into the footer template of your theme.\";s:2:\"id\";s:20:\"woo_google_analytics\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:6;a:5:{s:4:\"name\";s:7:\"RSS URL\";s:4:\"desc\";s:51:\"Enter your preferred RSS URL. (Feedburner or other)\";s:2:\"id\";s:18:\"woo_feedburner_url\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:7;a:5:{s:4:\"name\";s:16:\"E-mail Subscribe\";s:4:\"desc\";s:60:\"Enter the URL to your preferred e-mail subscription service.\";s:2:\"id\";s:17:\"woo_feedburner_id\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:8;a:5:{s:4:\"name\";s:10:\"Custom CSS\";s:4:\"desc\";s:62:\"Quickly add some CSS to your theme by adding it to this block.\";s:2:\"id\";s:14:\"woo_custom_css\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:9;a:3:{s:4:\"name\";s:17:\"Homepage Carousel\";s:4:\"icon\";s:6:\"slider\";s:4:\"type\";s:7:\"heading\";}i:10;a:5:{s:4:\"name\";s:17:\"Display Carousel?\";s:4:\"desc\";s:68:\"Check this box if you wish to display the carousel on your homepage.\";s:2:\"id\";s:17:\"woo_show_carousel\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:11;a:6:{s:4:\"name\";s:17:\"Featured Category\";s:4:\"desc\";s:99:\"Select the category that you would like to have displayed in the featured section on your homepage.\";s:2:\"id\";s:21:\"woo_featured_category\";s:3:\"std\";s:18:\"Select a category:\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:5:{i:0;s:18:\"Select a category:\";i:1;s:22:\"About Natural Remedies\";i:2;s:9:\"Allergies\";i:3;s:21:\"Natural Remedies Tips\";i:4;s:9:\"Skin Care\";}}i:12;a:6:{s:4:\"name\";s:16:\"Featured Entries\";s:4:\"desc\";s:81:\"Select the number of entries that should appear in the Featured Article scroller.\";s:2:\"id\";s:16:\"woo_feat_entries\";s:3:\"std\";s:16:\"Select a Number:\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:20:{i:0;s:16:\"Select a number:\";i:1;s:1:\"1\";i:2;s:1:\"2\";i:3;s:1:\"3\";i:4;s:1:\"4\";i:5;s:1:\"5\";i:6;s:1:\"6\";i:7;s:1:\"7\";i:8;s:1:\"8\";i:9;s:1:\"9\";i:10;s:2:\"10\";i:11;s:2:\"11\";i:12;s:2:\"12\";i:13;s:2:\"13\";i:14;s:2:\"14\";i:15;s:2:\"15\";i:16;s:2:\"16\";i:17;s:2:\"17\";i:18;s:2:\"18\";i:19;s:2:\"19\";}}i:13;a:5:{s:4:\"name\";s:29:\"Featured Slider Exclude Posts\";s:4:\"desc\";s:49:\"Exclude the slider posts from posts below slider.\";s:2:\"id\";s:27:\"woo_slider_magazine_exclude\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:14;a:5:{s:4:\"name\";s:11:\"Slider Fade\";s:4:\"desc\";s:34:\"Slides will have a fade transition\";s:2:\"id\";s:16:\"woo_slider_sfade\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:15;a:5:{s:4:\"name\";s:12:\"Content Fade\";s:4:\"desc\";s:41:\"Slide Content will have a fade transition\";s:2:\"id\";s:16:\"woo_slider_cfade\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:16;a:6:{s:4:\"name\";s:16:\"Slide/Fade Speed\";s:4:\"desc\";s:70:\"The time in seconds it will take for the slide transition to complete.\";s:2:\"id\";s:16:\"woo_slider_speed\";s:3:\"std\";s:3:\"0.6\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:21:{i:0;s:3:\"0.0\";i:1;s:3:\"0.1\";i:2;s:3:\"0.2\";i:3;s:3:\"0.3\";i:4;s:3:\"0.4\";i:5;s:3:\"0.5\";i:6;s:3:\"0.6\";i:7;s:3:\"0.7\";i:8;s:3:\"0.8\";i:9;s:3:\"0.9\";i:10;s:3:\"1.0\";i:11;s:3:\"1.1\";i:12;s:3:\"1.2\";i:13;s:3:\"1.3\";i:14;s:3:\"1.4\";i:15;s:3:\"1.5\";i:16;s:3:\"1.6\";i:17;s:3:\"1.7\";i:18;s:3:\"1.8\";i:19;s:3:\"1.9\";i:20;s:3:\"2.0\";}}i:17;a:6:{s:4:\"name\";s:26:\"Slide/Fade Auto Start Time\";s:4:\"desc\";s:59:\"The time before the slides start to automatically automate.\";s:2:\"id\";s:18:\"woo_slider_timeout\";s:3:\"std\";s:1:\"6\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:10:{i:0;s:1:\"1\";i:1;s:1:\"2\";i:2;s:1:\"3\";i:3;s:1:\"4\";i:4;s:1:\"5\";i:5;s:1:\"6\";i:6;s:1:\"7\";i:7;s:1:\"8\";i:8;s:1:\"9\";i:9;s:2:\"10\";}}i:18;a:6:{s:4:\"name\";s:24:\"Content Slide/Fade Speed\";s:4:\"desc\";s:78:\"The time in seconds it will take for the slide content transition to complete.\";s:2:\"id\";s:24:\"woo_slider_content_speed\";s:3:\"std\";s:3:\"0.6\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:21:{i:0;s:3:\"0.0\";i:1;s:3:\"0.1\";i:2;s:3:\"0.2\";i:3;s:3:\"0.3\";i:4;s:3:\"0.4\";i:5;s:3:\"0.5\";i:6;s:3:\"0.6\";i:7;s:3:\"0.7\";i:8;s:3:\"0.8\";i:9;s:3:\"0.9\";i:10;s:3:\"1.0\";i:11;s:3:\"1.1\";i:12;s:3:\"1.2\";i:13;s:3:\"1.3\";i:14;s:3:\"1.4\";i:15;s:3:\"1.5\";i:16;s:3:\"1.6\";i:17;s:3:\"1.7\";i:18;s:3:\"1.8\";i:19;s:3:\"1.9\";i:20;s:3:\"2.0\";}}i:19;a:5:{s:4:\"name\";s:15:\"Carousel Height\";s:4:\"desc\";s:40:\"Adjust the defualt height of the slider.\";s:2:\"id\";s:19:\"woo_carousel_height\";s:3:\"std\";s:3:\"292\";s:4:\"type\";s:4:\"text\";}i:20;a:3:{s:4:\"name\";s:6:\"Layout\";s:4:\"icon\";s:6:\"layout\";s:4:\"type\";s:7:\"heading\";}i:21;a:5:{s:4:\"name\";s:26:\"Activate 1 Column Homepage\";s:4:\"desc\";s:134:\"This will activate the custom homepage which shows blog posts in one wider column, rather than the default two column blog post boxes.\";s:2:\"id\";s:8:\"woo_home\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:22;a:5:{s:4:\"name\";s:31:\"Show Excerpt in 1 Column layout\";s:4:\"desc\";s:69:\"Show the post excerpt instead of the post content in 1 column layout.\";s:2:\"id\";s:16:\"woo_blog_excerpt\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:23;a:5:{s:4:\"name\";s:20:\"Show Excerpt Archive\";s:4:\"desc\";s:62:\"Show the post excerpt instead of the post content in archives.\";s:2:\"id\";s:19:\"woo_archive_excerpt\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:24;a:5:{s:4:\"name\";s:20:\"Display author info?\";s:4:\"desc\";s:121:\"Display author info below single posts. Set this by editing your user in WP admin and adding text in \'Biographical Info\'.\";s:2:\"id\";s:10:\"woo_author\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:25;a:3:{s:4:\"name\";s:19:\"Homepage Video Area\";s:4:\"icon\";s:5:\"media\";s:4:\"type\";s:7:\"heading\";}i:26;a:5:{s:4:\"name\";s:14:\"Display Video?\";s:4:\"desc\";s:71:\"Check this box if you wish to display the video panel on your homepage.\";s:2:\"id\";s:14:\"woo_show_video\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:27;a:5:{s:4:\"name\";s:14:\"Exclude Video?\";s:4:\"desc\";s:77:\"Check this box if you wish to exclude the video posts from the homepage loop.\";s:2:\"id\";s:17:\"woo_exclude_video\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:28;a:6:{s:4:\"name\";s:14:\"Video Category\";s:4:\"desc\";s:94:\"Select the category that you would like to have displayed in the video panel on your homepage.\";s:2:\"id\";s:18:\"woo_video_category\";s:3:\"std\";s:18:\"Select a category:\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:5:{i:0;s:18:\"Select a category:\";i:1;s:22:\"About Natural Remedies\";i:2;s:9:\"Allergies\";i:3;s:21:\"Natural Remedies Tips\";i:4;s:9:\"Skin Care\";}}i:29;a:3:{s:4:\"name\";s:14:\"Dynamic Images\";s:4:\"icon\";s:5:\"image\";s:4:\"type\";s:7:\"heading\";}i:30;a:5:{s:4:\"name\";s:22:\"Dynamic Image Resizing\";s:4:\"desc\";s:0:\"\";s:2:\"id\";s:18:\"woo_wpthumb_notice\";s:3:\"std\";s:220:\"There are two alternative methods of dynamically resizing the thumbnails in the theme, <strong>WP Post Thumbnail</strong> or <strong>TimThumb - Custom Settings panel</strong>. We recommend using WP Post Thumbnail option.\";s:4:\"type\";s:4:\"info\";}i:31;a:6:{s:4:\"name\";s:17:\"WP Post Thumbnail\";s:4:\"desc\";s:170:\"Use WordPress post thumbnail to assign a post thumbnail. Will enable the <strong>Featured Image panel</strong> in your post sidebar where you can assign a post thumbnail.\";s:2:\"id\";s:22:\"woo_post_image_support\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:32;a:6:{s:4:\"name\";s:42:\"WP Post Thumbnail - Dynamic Image Resizing\";s:4:\"desc\";s:113:\"The post thumbnail will be dynamically resized using native WP resize functionality. <em>(Requires PHP 5.2+)</em>\";s:2:\"id\";s:14:\"woo_pis_resize\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:8:\"checkbox\";}i:33;a:6:{s:4:\"name\";s:29:\"WP Post Thumbnail - Hard Crop\";s:4:\"desc\";s:119:\"The post thumbnail will be cropped to match the target aspect ratio (only used if \'Dynamic Image Resizing\' is enabled).\";s:2:\"id\";s:17:\"woo_pis_hard_crop\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:11:\"hidden last\";s:4:\"type\";s:8:\"checkbox\";}i:34;a:5:{s:4:\"name\";s:32:\"TimThumb - Custom Settings Panel\";s:4:\"desc\";s:358:\"This will enable the <a href=\'http://code.google.com/p/timthumb/\'>TimThumb</a> (thumb.php) script which dynamically resizes images added through the <strong>custom settings panel below the post</strong>. Make sure your themes <em>cache</em> folder is writable. <a href=\'http://www.woothemes.com/2008/10/troubleshooting-image-resizer-thumbphp/\'>Need help?</a>\";s:2:\"id\";s:10:\"woo_resize\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:35;a:5:{s:4:\"name\";s:25:\"Automatic Image Thumbnail\";s:4:\"desc\";s:81:\"If no thumbnail is specifified then the first uploaded image in the post is used.\";s:2:\"id\";s:12:\"woo_auto_img\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:36;a:5:{s:4:\"name\";s:21:\"Thumbnails (homepage)\";s:4:\"desc\";s:109:\"Enter an integer value i.e. 100 for the desired size which will be used when dynamically creating the images.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:20:\"woo_home_thumb_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:100;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:21:\"woo_home_thumb_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:57;s:4:\"meta\";s:6:\"Height\";}}}i:37;a:5:{s:4:\"name\";s:20:\"Thumbnails (general)\";s:4:\"desc\";s:109:\"Enter an integer value i.e. 100 for the desired size which will be used when dynamically creating the images.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:15:\"woo_thumb_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:100;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:16:\"woo_thumb_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:57;s:4:\"meta\";s:6:\"Height\";}}}i:38;a:5:{s:4:\"name\";s:19:\"Disable Single Post\";s:4:\"desc\";s:74:\"Check this if you don\'t want to display the thumbnail on the single posts.\";s:2:\"id\";s:16:\"woo_image_single\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:39;a:5:{s:4:\"name\";s:17:\"Single Post Image\";s:4:\"desc\";s:109:\"Enter an integer value i.e. 100 for the desired size which will be used when dynamically creating the images.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:16:\"woo_single_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:250;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:17:\"woo_single_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:180;s:4:\"meta\";s:6:\"Height\";}}}i:40;a:5:{s:4:\"name\";s:25:\"Add thumbnail to RSS feed\";s:4:\"desc\";s:68:\"Add the the image uploaded via your Custom Settings to your RSS feed\";s:2:\"id\";s:13:\"woo_rss_thumb\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:41;a:3:{s:4:\"name\";s:21:\"Top Banner (468x60px)\";s:4:\"icon\";s:3:\"ads\";s:4:\"type\";s:7:\"heading\";}i:42;a:5:{s:4:\"name\";s:10:\"Disable Ad\";s:4:\"desc\";s:20:\"Disable the ad space\";s:2:\"id\";s:18:\"woo_ad_top_disable\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:43;a:5:{s:4:\"name\";s:12:\"Adsense code\";s:4:\"desc\";s:29:\"Enter your adsense code here.\";s:2:\"id\";s:18:\"woo_ad_top_adsense\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:44;a:5:{s:4:\"name\";s:30:\"Banner Ad Top - Image Location\";s:4:\"desc\";s:46:\"Enter the URL to the banner ad image location.\";s:2:\"id\";s:16:\"woo_ad_top_image\";s:3:\"std\";s:40:\"http://www.woothemes.com/ads/468x60a.jpg\";s:4:\"type\";s:4:\"text\";}i:45;a:5:{s:4:\"name\";s:27:\"Banner Ad Top - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:14:\"woo_ad_top_url\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:46;a:3:{s:4:\"name\";s:21:\"Sidebar Ads (125x125)\";s:4:\"icon\";s:3:\"ads\";s:4:\"type\";s:7:\"heading\";}i:47;a:5:{s:4:\"name\";s:15:\"Rotate banners?\";s:4:\"desc\";s:45:\"Check this to randomly rotate the banner ads.\";s:2:\"id\";s:14:\"woo_ads_rotate\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:48;a:5:{s:4:\"name\";s:29:\"Banner Ad #1 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_1\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125a.jpg\";s:4:\"type\";s:4:\"text\";}i:49;a:5:{s:4:\"name\";s:26:\"Banner Ad #1 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_1\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:50;a:5:{s:4:\"name\";s:29:\"Banner Ad #2 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_2\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:51;a:5:{s:4:\"name\";s:26:\"Banner Ad #2 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_2\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:52;a:5:{s:4:\"name\";s:29:\"Banner Ad #3 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_3\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125c.jpg\";s:4:\"type\";s:4:\"text\";}i:53;a:5:{s:4:\"name\";s:26:\"Banner Ad #3 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_3\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:54;a:5:{s:4:\"name\";s:29:\"Banner Ad #4 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_4\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125d.jpg\";s:4:\"type\";s:4:\"text\";}i:55;a:5:{s:4:\"name\";s:26:\"Banner Ad #4 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_4\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}}", "yes");
INSERT INTO `wp_options` VALUES("225", "woo_themename", "Gazette", "yes");
INSERT INTO `wp_options` VALUES("226", "woo_shortname", "woo", "yes");
INSERT INTO `wp_options` VALUES("227", "woo_manual", "http://www.woothemes.com/support/theme-documentation/gazette/", "yes");
INSERT INTO `wp_options` VALUES("228", "woo_custom_template", "a:2:{i:0;a:4:{s:4:\"name\";s:5:\"image\";s:5:\"label\";s:5:\"Image\";s:4:\"type\";s:6:\"upload\";s:4:\"desc\";s:19:\"Upload file here...\";}i:1;a:5:{s:4:\"name\";s:5:\"embed\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:10:\"Embed Code\";s:4:\"type\";s:8:\"textarea\";s:4:\"desc\";s:41:\"Enter the video embed code for your video\";}}", "yes");
INSERT INTO `wp_options` VALUES("236", "woo_alt_stylesheet", "default.css", "yes");
INSERT INTO `wp_options` VALUES("237", "woo_logo", "", "yes");
INSERT INTO `wp_options` VALUES("238", "woo_texttitle", "true", "yes");
INSERT INTO `wp_options` VALUES("239", "woo_custom_favicon", "", "yes");
INSERT INTO `wp_options` VALUES("240", "woo_google_analytics", "", "yes");
INSERT INTO `wp_options` VALUES("241", "woo_feedburner_url", "", "yes");
INSERT INTO `wp_options` VALUES("242", "woo_feedburner_id", "", "yes");
INSERT INTO `wp_options` VALUES("243", "woo_custom_css", "", "yes");
INSERT INTO `wp_options` VALUES("244", "woo_show_carousel", "false", "yes");
INSERT INTO `wp_options` VALUES("245", "woo_featured_category", "Select a category:", "yes");
INSERT INTO `wp_options` VALUES("246", "woo_feat_entries", "Select a number:", "yes");
INSERT INTO `wp_options` VALUES("247", "woo_slider_magazine_exclude", "true", "yes");
INSERT INTO `wp_options` VALUES("248", "woo_slider_sfade", "false", "yes");
INSERT INTO `wp_options` VALUES("249", "woo_slider_cfade", "false", "yes");
INSERT INTO `wp_options` VALUES("250", "woo_slider_speed", "0.6", "yes");
INSERT INTO `wp_options` VALUES("251", "woo_slider_timeout", "6", "yes");
INSERT INTO `wp_options` VALUES("252", "woo_slider_content_speed", "0.6", "yes");
INSERT INTO `wp_options` VALUES("253", "woo_carousel_height", "292", "yes");
INSERT INTO `wp_options` VALUES("254", "woo_home", "false", "yes");
INSERT INTO `wp_options` VALUES("255", "woo_blog_excerpt", "true", "yes");
INSERT INTO `wp_options` VALUES("256", "woo_archive_excerpt", "true", "yes");
INSERT INTO `wp_options` VALUES("257", "woo_author", "false", "yes");
INSERT INTO `wp_options` VALUES("258", "woo_show_video", "false", "yes");
INSERT INTO `wp_options` VALUES("259", "woo_exclude_video", "false", "yes");
INSERT INTO `wp_options` VALUES("260", "woo_video_category", "Select a category:", "yes");
INSERT INTO `wp_options` VALUES("261", "woo_wpthumb_notice", "", "yes");
INSERT INTO `wp_options` VALUES("262", "woo_post_image_support", "true", "yes");
INSERT INTO `wp_options` VALUES("263", "woo_pis_resize", "true", "yes");
INSERT INTO `wp_options` VALUES("264", "woo_pis_hard_crop", "true", "yes");
INSERT INTO `wp_options` VALUES("265", "woo_resize", "true", "yes");
INSERT INTO `wp_options` VALUES("266", "woo_auto_img", "false", "yes");
INSERT INTO `wp_options` VALUES("267", "woo_home_thumb_width", "100", "yes");
INSERT INTO `wp_options` VALUES("268", "woo_home_thumb_height", "57", "yes");
INSERT INTO `wp_options` VALUES("269", "woo_thumb_width", "100", "yes");
INSERT INTO `wp_options` VALUES("270", "woo_thumb_height", "57", "yes");
INSERT INTO `wp_options` VALUES("271", "woo_image_single", "false", "yes");
INSERT INTO `wp_options` VALUES("272", "woo_single_width", "250", "yes");
INSERT INTO `wp_options` VALUES("273", "woo_single_height", "180", "yes");
INSERT INTO `wp_options` VALUES("274", "woo_rss_thumb", "false", "yes");
INSERT INTO `wp_options` VALUES("275", "woo_ad_top_disable", "false", "yes");
INSERT INTO `wp_options` VALUES("276", "woo_ad_top_adsense", "<a href=\"http://sheila57.acepublish.hop.clickbank.net\"><img src=\"http://www.varicoseveincures.com/images/468X60.jpg\" alt=\"How To Get Rid Of Varicose Veins Naturally.\" border=\"0\"></a>", "yes");
INSERT INTO `wp_options` VALUES("277", "woo_ad_top_image", "http://www.woothemes.com/ads/468x60a.jpg", "yes");
INSERT INTO `wp_options` VALUES("278", "woo_ad_top_url", "http://www.woothemes.com", "yes");
INSERT INTO `wp_options` VALUES("279", "woo_ads_rotate", "true", "yes");
INSERT INTO `wp_options` VALUES("280", "woo_ad_image_1", "http://www.woothemes.com/ads/125x125a.jpg", "yes");
INSERT INTO `wp_options` VALUES("281", "woo_ad_url_1", "http://www.woothemes.com", "yes");
INSERT INTO `wp_options` VALUES("282", "woo_ad_image_2", "http://www.woothemes.com/ads/125x125b.jpg", "yes");
INSERT INTO `wp_options` VALUES("283", "woo_ad_url_2", "http://www.woothemes.com", "yes");
INSERT INTO `wp_options` VALUES("284", "woo_ad_image_3", "http://www.woothemes.com/ads/125x125c.jpg", "yes");
INSERT INTO `wp_options` VALUES("285", "woo_ad_url_3", "http://www.woothemes.com", "yes");
INSERT INTO `wp_options` VALUES("286", "woo_ad_image_4", "http://www.woothemes.com/ads/125x125d.jpg", "yes");
INSERT INTO `wp_options` VALUES("287", "woo_ad_url_4", "http://www.woothemes.com", "yes");
INSERT INTO `wp_options` VALUES("289", "widget_advert_125x125", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("290", "widget_woo_adwidget", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("291", "widget_woo_blogauthorinfo", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("292", "widget_woo_flickr", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("293", "widget_woo_tabs", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("294", "widget_woo_twitter", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("299", "widget_youtube_responsive", "a:2:{i:2;a:27:{s:5:\"title\";s:25:\"Best Natural Health Cures\";s:5:\"video\";s:43:\"https://www.youtube.com/watch?v=Uxn5G5kaq-A\";s:8:\"autohide\";i:2;s:8:\"autoplay\";i:0;s:7:\"cc_load\";i:0;s:7:\"cc_lang\";s:0:\"\";s:5:\"color\";s:3:\"red\";s:8:\"controls\";i:1;s:9:\"disablekb\";i:0;s:5:\"end_m\";s:1:\"0\";s:5:\"end_s\";s:1:\"0\";s:15:\"allowfullscreen\";i:0;s:14:\"iv_load_policy\";i:1;s:4:\"loop\";i:0;s:14:\"modestbranding\";i:1;s:9:\"suggested\";i:0;s:8:\"showinfo\";i:0;s:7:\"start_m\";s:1:\"0\";s:7:\"start_s\";s:1:\"0\";s:5:\"theme\";s:4:\"dark\";s:7:\"quality\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:5:\"style\";s:0:\"\";s:4:\"maxw\";s:0:\"\";s:3:\"w3c\";i:1;s:7:\"privacy\";i:0;s:5:\"wmode\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("313", "woo_custom_upload_tracking", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("322", "privacy_policy_sitename", "Craft Tips", "yes");
INSERT INTO `wp_options` VALUES("323", "privacy_policy_before_heading", "<h2>", "yes");
INSERT INTO `wp_options` VALUES("324", "privacy_policy_after_heading", "</h2>", "yes");
INSERT INTO `wp_options` VALUES("325", "privacy_policy_before_paragraph", "<p>", "yes");
INSERT INTO `wp_options` VALUES("326", "privacy_policy_after_paragraph", "</p>", "yes");
INSERT INTO `wp_options` VALUES("327", "privacy_policy_contact", "mail@yourmail.com", "yes");
INSERT INTO `wp_options` VALUES("328", "privacy_policy_title", "Privacy Policy", "yes");
INSERT INTO `wp_options` VALUES("329", "privacy_policy_slug", "privacy-policy", "yes");
INSERT INTO `wp_options` VALUES("330", "privacy_policy_pp_help", "1", "yes");
INSERT INTO `wp_options` VALUES("331", "privacy_policy_browser_help", "1", "yes");
INSERT INTO `wp_options` VALUES("332", "privacy_policy_credit", "1", "yes");
INSERT INTO `wp_options` VALUES("369", "duplicator_version_plugin", "0.5.22", "yes");
INSERT INTO `wp_options` VALUES("414", "ClickBankWEC3", "a:15:{s:5:\"title\";s:14:\"Related eBooks\";s:4:\"name\";s:8:\"sheila57\";s:15:\"keywordbytitle2\";s:5:\"Title\";s:8:\"keywords\";s:0:\"\";s:8:\"adformat\";s:1:\"1\";s:6:\"width2\";s:4:\"100%\";s:5:\"width\";s:4:\"100%\";s:6:\"height\";s:3:\"220\";s:3:\"pos\";s:3:\"Top\";s:9:\"bordstyle\";s:1:\"1\";s:9:\"bordcolor\";s:6:\"CCCCCC\";s:9:\"linkcolor\";s:6:\"0000FF\";s:9:\"runplugin\";s:1:\"1\";s:8:\"homepage\";s:1:\"1\";s:8:\"onlypost\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("416", "wpseo", "a:24:{s:14:\"blocking_files\";a:0:{}s:26:\"ignore_blog_public_warning\";b:0;s:31:\"ignore_meta_description_warning\";b:0;s:20:\"ignore_page_comments\";b:0;s:16:\"ignore_permalink\";b:0;s:11:\"ignore_tour\";b:1;s:15:\"ms_defaults_set\";b:0;s:23:\"theme_description_found\";s:0:\"\";s:21:\"theme_has_description\";b:0;s:19:\"tracking_popup_done\";b:1;s:7:\"version\";s:5:\"2.1.1\";s:10:\"seen_about\";b:1;s:11:\"alexaverify\";s:0:\"\";s:12:\"company_logo\";s:0:\"\";s:12:\"company_name\";s:0:\"\";s:17:\"company_or_person\";s:0:\"\";s:20:\"disableadvanced_meta\";b:1;s:12:\"googleverify\";s:0:\"\";s:8:\"msverify\";s:0:\"\";s:11:\"person_name\";s:0:\"\";s:12:\"website_name\";s:0:\"\";s:22:\"alternate_website_name\";s:0:\"\";s:12:\"yandexverify\";s:0:\"\";s:14:\"yoast_tracking\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("417", "seo_woo_use_third_party_data", "true", "yes");
INSERT INTO `wp_options` VALUES("418", "wpseo_permalinks", "a:13:{s:15:\"cleanpermalinks\";b:0;s:24:\"cleanpermalink-extravars\";s:0:\"\";s:29:\"cleanpermalink-googlecampaign\";b:0;s:31:\"cleanpermalink-googlesitesearch\";b:0;s:15:\"cleanreplytocom\";b:0;s:10:\"cleanslugs\";b:1;s:14:\"hide-feedlinks\";b:0;s:12:\"hide-rsdlink\";b:0;s:14:\"hide-shortlink\";b:0;s:16:\"hide-wlwmanifest\";b:0;s:18:\"redirectattachment\";b:0;s:17:\"stripcategorybase\";b:0;s:13:\"trailingslash\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("419", "wpseo_titles", "a:60:{s:10:\"title_test\";i:0;s:17:\"forcerewritetitle\";b:0;s:9:\"separator\";s:7:\"sc-dash\";s:5:\"noodp\";b:0;s:6:\"noydir\";b:0;s:15:\"usemetakeywords\";b:0;s:16:\"title-home-wpseo\";s:42:\"%%sitename%% %%page%% %%sep%% %%sitedesc%%\";s:18:\"title-author-wpseo\";s:41:\"%%name%%, Author at %%sitename%% %%page%%\";s:19:\"title-archive-wpseo\";s:38:\"%%date%% %%page%% %%sep%% %%sitename%%\";s:18:\"title-search-wpseo\";s:63:\"You searched for %%searchphrase%% %%page%% %%sep%% %%sitename%%\";s:15:\"title-404-wpseo\";s:35:\"Page not found %%sep%% %%sitename%%\";s:19:\"metadesc-home-wpseo\";s:0:\"\";s:21:\"metadesc-author-wpseo\";s:0:\"\";s:22:\"metadesc-archive-wpseo\";s:0:\"\";s:18:\"metakey-home-wpseo\";s:0:\"\";s:20:\"metakey-author-wpseo\";s:0:\"\";s:22:\"noindex-subpages-wpseo\";b:0;s:20:\"noindex-author-wpseo\";b:0;s:21:\"noindex-archive-wpseo\";b:1;s:14:\"disable-author\";b:0;s:12:\"disable-date\";b:0;s:10:\"title-post\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-post\";s:0:\"\";s:12:\"metakey-post\";s:0:\"\";s:12:\"noindex-post\";b:0;s:13:\"showdate-post\";b:0;s:16:\"hideeditbox-post\";b:0;s:10:\"title-page\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-page\";s:0:\"\";s:12:\"metakey-page\";s:0:\"\";s:12:\"noindex-page\";b:0;s:13:\"showdate-page\";b:0;s:16:\"hideeditbox-page\";b:0;s:16:\"title-attachment\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:19:\"metadesc-attachment\";s:0:\"\";s:18:\"metakey-attachment\";s:0:\"\";s:18:\"noindex-attachment\";b:0;s:19:\"showdate-attachment\";b:0;s:22:\"hideeditbox-attachment\";b:0;s:18:\"title-wooframework\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-wooframework\";s:0:\"\";s:20:\"metakey-wooframework\";s:0:\"\";s:20:\"noindex-wooframework\";b:0;s:21:\"showdate-wooframework\";b:0;s:24:\"hideeditbox-wooframework\";b:0;s:18:\"title-tax-category\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-category\";s:0:\"\";s:20:\"metakey-tax-category\";s:0:\"\";s:24:\"hideeditbox-tax-category\";b:0;s:20:\"noindex-tax-category\";b:0;s:18:\"title-tax-post_tag\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-post_tag\";s:0:\"\";s:20:\"metakey-tax-post_tag\";s:0:\"\";s:24:\"hideeditbox-tax-post_tag\";b:0;s:20:\"noindex-tax-post_tag\";b:0;s:21:\"title-tax-post_format\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:24:\"metadesc-tax-post_format\";s:0:\"\";s:23:\"metakey-tax-post_format\";s:0:\"\";s:27:\"hideeditbox-tax-post_format\";b:0;s:23:\"noindex-tax-post_format\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("420", "wpseo_social", "a:21:{s:9:\"fb_admins\";a:0:{}s:12:\"fbconnectkey\";s:32:\"931452f294ceb028a3b213a97436b44e\";s:13:\"facebook_site\";s:0:\"\";s:13:\"instagram_url\";s:0:\"\";s:12:\"linkedin_url\";s:0:\"\";s:11:\"myspace_url\";s:0:\"\";s:16:\"og_default_image\";s:0:\"\";s:18:\"og_frontpage_title\";s:0:\"\";s:17:\"og_frontpage_desc\";s:0:\"\";s:18:\"og_frontpage_image\";s:0:\"\";s:9:\"opengraph\";b:1;s:10:\"googleplus\";b:0;s:13:\"pinterest_url\";s:0:\"\";s:15:\"pinterestverify\";s:0:\"\";s:14:\"plus-publisher\";s:0:\"\";s:7:\"twitter\";b:1;s:12:\"twitter_site\";s:0:\"\";s:17:\"twitter_card_type\";s:7:\"summary\";s:11:\"youtube_url\";s:0:\"\";s:15:\"google_plus_url\";s:0:\"\";s:10:\"fbadminapp\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("421", "wpseo_rss", "a:2:{s:9:\"rssbefore\";s:0:\"\";s:8:\"rssafter\";s:53:\"The post %%POSTLINK%% appeared first on %%BLOGLINK%%.\";}", "yes");
INSERT INTO `wp_options` VALUES("422", "wpseo_internallinks", "a:10:{s:20:\"breadcrumbs-404crumb\";s:25:\"Error 404: Page not found\";s:23:\"breadcrumbs-blog-remove\";b:0;s:20:\"breadcrumbs-boldlast\";b:0;s:25:\"breadcrumbs-archiveprefix\";s:12:\"Archives for\";s:18:\"breadcrumbs-enable\";b:0;s:16:\"breadcrumbs-home\";s:4:\"Home\";s:18:\"breadcrumbs-prefix\";s:0:\"\";s:24:\"breadcrumbs-searchprefix\";s:16:\"You searched for\";s:15:\"breadcrumbs-sep\";s:7:\"&raquo;\";s:23:\"post_types-post-maintax\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("423", "wpseo_xml", "a:16:{s:22:\"disable_author_sitemap\";b:1;s:22:\"disable_author_noposts\";b:1;s:16:\"enablexmlsitemap\";b:1;s:16:\"entries-per-page\";i:1000;s:38:\"user_role-administrator-not_in_sitemap\";b:0;s:31:\"user_role-editor-not_in_sitemap\";b:0;s:31:\"user_role-author-not_in_sitemap\";b:0;s:36:\"user_role-contributor-not_in_sitemap\";b:0;s:35:\"user_role-subscriber-not_in_sitemap\";b:0;s:30:\"post_types-post-not_in_sitemap\";b:0;s:30:\"post_types-page-not_in_sitemap\";b:0;s:36:\"post_types-attachment-not_in_sitemap\";b:1;s:38:\"post_types-wooframework-not_in_sitemap\";b:0;s:34:\"taxonomies-category-not_in_sitemap\";b:0;s:34:\"taxonomies-post_tag-not_in_sitemap\";b:0;s:37:\"taxonomies-post_format-not_in_sitemap\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("426", "ssb_4_installed", "1", "yes");
INSERT INTO `wp_options` VALUES("427", "ssb_option", "a:21:{s:10:\"show_pages\";s:1:\"1\";s:10:\"show_posts\";s:1:\"1\";s:12:\"show_excerpt\";s:1:\"1\";s:10:\"hide_in_id\";s:0:\"\";s:8:\"show_top\";s:1:\"1\";s:19:\"show_button_fb_like\";s:1:\"1\";s:20:\"show_button_fb_share\";s:1:\"1\";s:16:\"show_button_twtr\";s:1:\"1\";s:17:\"show_button_gplus\";s:1:\"1\";s:20:\"show_button_pintrest\";s:1:\"1\";s:20:\"show_button_linkedin\";s:1:\"1\";s:20:\"width_button_fb_like\";s:2:\"86\";s:21:\"width_button_fb_share\";s:3:\"135\";s:17:\"width_button_twtr\";s:2:\"90\";s:18:\"width_button_gplus\";s:2:\"68\";s:21:\"width_button_pintrest\";s:2:\"47\";s:20:\"width_button_stumble\";s:2:\"75\";s:19:\"width_button_tumblr\";s:2:\"85\";s:21:\"width_button_linkedin\";s:2:\"64\";s:20:\"width_button_scoopit\";s:2:\"90\";s:17:\"width_button_xing\";s:2:\"56\";}", "yes");
INSERT INTO `wp_options` VALUES("455", "duplicator_settings", "a:10:{s:7:\"version\";s:6:\"0.5.22\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("457", "_transient_random_seed", "fd47eb59ac774aaffcfa4c3930797d4d", "yes");
INSERT INTO `wp_options` VALUES("458", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-4.2.2.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-4.2.2.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-4.2.2-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-4.2.2-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"4.2.2\";s:7:\"version\";s:5:\"4.2.2\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"4.1\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1432756784;s:15:\"version_checked\";s:5:\"4.2.2\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("462", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1432756784;s:7:\"checked\";a:5:{s:7:\"gazette\";s:6:\"2.10.0\";s:12:\"lifestyle_20\";s:3:\"1.0\";s:13:\"twentyfifteen\";s:3:\"1.2\";s:14:\"twentyfourteen\";s:3:\"1.4\";s:14:\"twentythirteen\";s:3:\"1.5\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("466", "duplicator_ui_view_state", "a:1:{s:14:\"dup-wpnotice01\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("467", "_transient_timeout_plugin_slugs", "1432843188", "no");
INSERT INTO `wp_options` VALUES("468", "_transient_plugin_slugs", "a:15:{i:0;s:39:\"ad-squares-widget/ad-squares-widget.php\";i:1;s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";i:2;s:25:\"duplicator/duplicator.php\";i:3;s:23:\"slider-image/slider.php\";i:4;s:22:\"obox-mobile/mobile.php\";i:5;s:33:\"privacy-policy/privacy-policy.php\";i:6;s:30:\"smart-youtube/smartyoutube.php\";i:7;s:41:\"social-share-boost/social-share-boost.php\";i:8;s:24:\"wordpress-seo/wp-seo.php\";i:9;s:34:\"wp-contact-form/wp-contactform.php\";i:10;s:32:\"wpfree-images/pixabay-images.php\";i:11;s:27:\"wp-super-cache/wp-cache.php\";i:12;s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";i:13;s:26:\"youtube-widget/youtube.php\";i:14;s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";}", "no");
INSERT INTO `wp_options` VALUES("479", "_site_transient_timeout_available_translations", "1432767005", "yes");
INSERT INTO `wp_options` VALUES("480", "_site_transient_available_translations", "a:56:{s:2:\"ar\";a:8:{s:8:\"language\";s:2:\"ar\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:57:37\";s:12:\"english_name\";s:6:\"Arabic\";s:11:\"native_name\";s:14:\"العربية\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/ar.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:2;s:3:\"ara\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:2:\"az\";a:8:{s:8:\"language\";s:2:\"az\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-02 03:57:09\";s:12:\"english_name\";s:11:\"Azerbaijani\";s:11:\"native_name\";s:16:\"Azərbaycan dili\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/az.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:2;s:3:\"aze\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Davam\";}}s:5:\"bg_BG\";a:8:{s:8:\"language\";s:5:\"bg_BG\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:9:\"Bulgarian\";s:11:\"native_name\";s:18:\"Български\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/bg_BG.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bg\";i:2;s:3:\"bul\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:22:\"Продължение\";}}s:5:\"bs_BA\";a:8:{s:8:\"language\";s:5:\"bs_BA\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-25 18:55:51\";s:12:\"english_name\";s:7:\"Bosnian\";s:11:\"native_name\";s:8:\"Bosanski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/bs_BA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bs\";i:2;s:3:\"bos\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:2:\"ca\";a:8:{s:8:\"language\";s:2:\"ca\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-24 05:23:15\";s:12:\"english_name\";s:7:\"Catalan\";s:11:\"native_name\";s:7:\"Català\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/ca.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ca\";i:2;s:3:\"cat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"cy\";a:8:{s:8:\"language\";s:2:\"cy\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-25 12:05:08\";s:12:\"english_name\";s:5:\"Welsh\";s:11:\"native_name\";s:7:\"Cymraeg\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/cy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cy\";i:2;s:3:\"cym\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Parhau\";}}s:5:\"da_DK\";a:8:{s:8:\"language\";s:5:\"da_DK\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 18:34:01\";s:12:\"english_name\";s:6:\"Danish\";s:11:\"native_name\";s:5:\"Dansk\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/da_DK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"da\";i:2;s:3:\"dan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Forts&#230;t\";}}s:5:\"de_CH\";a:8:{s:8:\"language\";s:5:\"de_CH\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:20:\"German (Switzerland)\";s:11:\"native_name\";s:17:\"Deutsch (Schweiz)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/de_CH.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Fortfahren\";}}s:5:\"de_DE\";a:8:{s:8:\"language\";s:5:\"de_DE\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 19:07:46\";s:12:\"english_name\";s:6:\"German\";s:11:\"native_name\";s:7:\"Deutsch\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/de_DE.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Fortfahren\";}}s:2:\"el\";a:8:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-10 21:13:03\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Συνέχεια\";}}s:5:\"en_GB\";a:8:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_AU\";a:8:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_CA\";a:8:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"eo\";a:8:{s:8:\"language\";s:2:\"eo\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:9:\"Esperanto\";s:11:\"native_name\";s:9:\"Esperanto\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/eo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eo\";i:2;s:3:\"epo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Daŭrigi\";}}s:5:\"es_PE\";a:8:{s:8:\"language\";s:5:\"es_PE\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-25 13:39:01\";s:12:\"english_name\";s:14:\"Spanish (Peru)\";s:11:\"native_name\";s:17:\"Español de Perú\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/es_PE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_MX\";a:8:{s:8:\"language\";s:5:\"es_MX\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-24 16:03:38\";s:12:\"english_name\";s:16:\"Spanish (Mexico)\";s:11:\"native_name\";s:19:\"Español de México\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/es_MX.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_ES\";a:8:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-18 10:50:06\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/es_ES.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"es\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CL\";a:8:{s:8:\"language\";s:5:\"es_CL\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-04 19:47:01\";s:12:\"english_name\";s:15:\"Spanish (Chile)\";s:11:\"native_name\";s:17:\"Español de Chile\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/es_CL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"eu\";a:8:{s:8:\"language\";s:2:\"eu\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:6:\"Basque\";s:11:\"native_name\";s:7:\"Euskara\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/eu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eu\";i:2;s:3:\"eus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Jarraitu\";}}s:5:\"fa_IR\";a:8:{s:8:\"language\";s:5:\"fa_IR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-16 10:01:41\";s:12:\"english_name\";s:7:\"Persian\";s:11:\"native_name\";s:10:\"فارسی\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/fa_IR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:2:\"fi\";a:8:{s:8:\"language\";s:2:\"fi\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-15 10:49:37\";s:12:\"english_name\";s:7:\"Finnish\";s:11:\"native_name\";s:5:\"Suomi\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/fi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fi\";i:2;s:3:\"fin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Jatka\";}}s:5:\"fr_FR\";a:8:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-29 17:08:38\";s:12:\"english_name\";s:15:\"French (France)\";s:11:\"native_name\";s:9:\"Français\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/fr_FR.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"fr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:2:\"gd\";a:8:{s:8:\"language\";s:2:\"gd\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 17:37:43\";s:12:\"english_name\";s:15:\"Scottish Gaelic\";s:11:\"native_name\";s:9:\"Gàidhlig\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.0/gd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"gd\";i:2;s:3:\"gla\";i:3;s:3:\"gla\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"Lean air adhart\";}}s:5:\"gl_ES\";a:8:{s:8:\"language\";s:5:\"gl_ES\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:8:\"Galician\";s:11:\"native_name\";s:6:\"Galego\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/gl_ES.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gl\";i:2;s:3:\"glg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:3:\"haz\";a:8:{s:8:\"language\";s:3:\"haz\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 15:20:27\";s:12:\"english_name\";s:8:\"Hazaragi\";s:11:\"native_name\";s:15:\"هزاره گی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1.5/haz.zip\";s:3:\"iso\";a:1:{i:2;s:3:\"haz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"he_IL\";a:8:{s:8:\"language\";s:5:\"he_IL\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 19:32:58\";s:12:\"english_name\";s:6:\"Hebrew\";s:11:\"native_name\";s:16:\"עִבְרִית\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/he_IL.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"he\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"להמשיך\";}}s:2:\"hr\";a:8:{s:8:\"language\";s:2:\"hr\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-21 12:07:28\";s:12:\"english_name\";s:8:\"Croatian\";s:11:\"native_name\";s:8:\"Hrvatski\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/hr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hr\";i:2;s:3:\"hrv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:5:\"hu_HU\";a:8:{s:8:\"language\";s:5:\"hu_HU\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:43:50\";s:12:\"english_name\";s:9:\"Hungarian\";s:11:\"native_name\";s:6:\"Magyar\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/hu_HU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hu\";i:2;s:3:\"hun\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Tovább\";}}s:5:\"id_ID\";a:8:{s:8:\"language\";s:5:\"id_ID\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 07:07:32\";s:12:\"english_name\";s:10:\"Indonesian\";s:11:\"native_name\";s:16:\"Bahasa Indonesia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/id_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"id\";i:2;s:3:\"ind\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Lanjutkan\";}}s:5:\"is_IS\";a:8:{s:8:\"language\";s:5:\"is_IS\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-18 23:48:51\";s:12:\"english_name\";s:9:\"Icelandic\";s:11:\"native_name\";s:9:\"Íslenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/is_IS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"is\";i:2;s:3:\"isl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Áfram\";}}s:5:\"it_IT\";a:8:{s:8:\"language\";s:5:\"it_IT\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-23 17:17:36\";s:12:\"english_name\";s:7:\"Italian\";s:11:\"native_name\";s:8:\"Italiano\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/it_IT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"it\";i:2;s:3:\"ita\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"ja\";a:8:{s:8:\"language\";s:2:\"ja\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-15 08:57:03\";s:12:\"english_name\";s:8:\"Japanese\";s:11:\"native_name\";s:9:\"日本語\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/ja.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ja\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"続ける\";}}s:5:\"ko_KR\";a:8:{s:8:\"language\";s:5:\"ko_KR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:57:22\";s:12:\"english_name\";s:6:\"Korean\";s:11:\"native_name\";s:9:\"한국어\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/ko_KR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ko\";i:2;s:3:\"kor\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"계속\";}}s:5:\"lt_LT\";a:8:{s:8:\"language\";s:5:\"lt_LT\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:10:\"Lithuanian\";s:11:\"native_name\";s:15:\"Lietuvių kalba\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/lt_LT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lt\";i:2;s:3:\"lit\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Tęsti\";}}s:5:\"my_MM\";a:8:{s:8:\"language\";s:5:\"my_MM\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 15:57:42\";s:12:\"english_name\";s:17:\"Myanmar (Burmese)\";s:11:\"native_name\";s:15:\"ဗမာစာ\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.1.5/my_MM.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"my\";i:2;s:3:\"mya\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:54:\"ဆက်လက်လုပ်ေဆာင်ပါ။\";}}s:5:\"nb_NO\";a:8:{s:8:\"language\";s:5:\"nb_NO\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-04 08:01:04\";s:12:\"english_name\";s:19:\"Norwegian (Bokmål)\";s:11:\"native_name\";s:13:\"Norsk bokmål\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/nb_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nb\";i:2;s:3:\"nob\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsett\";}}s:5:\"nl_NL\";a:8:{s:8:\"language\";s:5:\"nl_NL\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:59:29\";s:12:\"english_name\";s:5:\"Dutch\";s:11:\"native_name\";s:10:\"Nederlands\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/nl_NL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nn_NO\";a:8:{s:8:\"language\";s:5:\"nn_NO\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:19:\"Norwegian (Nynorsk)\";s:11:\"native_name\";s:13:\"Norsk nynorsk\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/nn_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nn\";i:2;s:3:\"nno\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Hald fram\";}}s:3:\"oci\";a:8:{s:8:\"language\";s:3:\"oci\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-25 19:53:10\";s:12:\"english_name\";s:7:\"Occitan\";s:11:\"native_name\";s:7:\"Occitan\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.2.2/oci.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"oc\";i:2;s:3:\"oci\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Contunhar\";}}s:5:\"pl_PL\";a:8:{s:8:\"language\";s:5:\"pl_PL\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-09 10:15:05\";s:12:\"english_name\";s:6:\"Polish\";s:11:\"native_name\";s:6:\"Polski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/pl_PL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pl\";i:2;s:3:\"pol\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Kontynuuj\";}}s:2:\"ps\";a:8:{s:8:\"language\";s:2:\"ps\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-29 22:19:48\";s:12:\"english_name\";s:6:\"Pashto\";s:11:\"native_name\";s:8:\"پښتو\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.1.5/ps.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ps\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"دوام\";}}s:5:\"pt_PT\";a:8:{s:8:\"language\";s:5:\"pt_PT\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-27 09:25:14\";s:12:\"english_name\";s:21:\"Portuguese (Portugal)\";s:11:\"native_name\";s:10:\"Português\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/pt_PT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_BR\";a:8:{s:8:\"language\";s:5:\"pt_BR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:44:19\";s:12:\"english_name\";s:19:\"Portuguese (Brazil)\";s:11:\"native_name\";s:20:\"Português do Brasil\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/pt_BR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pt\";i:2;s:3:\"por\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"ro_RO\";a:8:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-21 15:14:01\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuă\";}}s:5:\"ru_RU\";a:8:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продолжить\";}}s:5:\"sk_SK\";a:8:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 09:29:23\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Pokračovať\";}}s:5:\"sl_SI\";a:8:{s:8:\"language\";s:5:\"sl_SI\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 16:25:46\";s:12:\"english_name\";s:9:\"Slovenian\";s:11:\"native_name\";s:13:\"Slovenščina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.1.5/sl_SI.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sl\";i:2;s:3:\"slv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Nadaljujte\";}}s:2:\"sq\";a:8:{s:8:\"language\";s:2:\"sq\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-05 22:47:02\";s:12:\"english_name\";s:8:\"Albanian\";s:11:\"native_name\";s:5:\"Shqip\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/sq.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sq\";i:2;s:3:\"sqi\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Vazhdo\";}}s:5:\"sr_RS\";a:8:{s:8:\"language\";s:5:\"sr_RS\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 16:55:54\";s:12:\"english_name\";s:7:\"Serbian\";s:11:\"native_name\";s:23:\"Српски језик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/sr_RS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sr\";i:2;s:3:\"srp\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Настави\";}}s:5:\"sv_SE\";a:8:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 07:08:28\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Fortsätt\";}}s:2:\"th\";a:8:{s:8:\"language\";s:2:\"th\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 15:16:26\";s:12:\"english_name\";s:4:\"Thai\";s:11:\"native_name\";s:9:\"ไทย\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/th.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"th\";i:2;s:3:\"tha\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"ต่อไป\";}}s:5:\"tr_TR\";a:8:{s:8:\"language\";s:5:\"tr_TR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 07:01:28\";s:12:\"english_name\";s:7:\"Turkish\";s:11:\"native_name\";s:8:\"Türkçe\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/tr_TR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tr\";i:2;s:3:\"tur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Devam\";}}s:5:\"ug_CN\";a:8:{s:8:\"language\";s:5:\"ug_CN\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 16:45:38\";s:12:\"english_name\";s:6:\"Uighur\";s:11:\"native_name\";s:9:\"Uyƣurqə\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.1.5/ug_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ug\";i:2;s:3:\"uig\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:26:\"داۋاملاشتۇرۇش\";}}s:2:\"uk\";a:8:{s:8:\"language\";s:2:\"uk\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-24 15:09:07\";s:12:\"english_name\";s:9:\"Ukrainian\";s:11:\"native_name\";s:20:\"Українська\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/uk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uk\";i:2;s:3:\"ukr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продовжити\";}}s:5:\"zh_CN\";a:8:{s:8:\"language\";s:5:\"zh_CN\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:15:\"Chinese (China)\";s:11:\"native_name\";s:12:\"简体中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/zh_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"继续\";}}s:5:\"zh_TW\";a:8:{s:8:\"language\";s:5:\"zh_TW\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-29 06:37:03\";s:12:\"english_name\";s:16:\"Chinese (Taiwan)\";s:11:\"native_name\";s:12:\"繁體中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/zh_TW.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}}", "yes");
INSERT INTO `wp_options` VALUES("481", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1432767341", "yes");
INSERT INTO `wp_options` VALUES("482", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"5194\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"3255\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"3192\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"2717\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"2496\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1992\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1897\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1831\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1779\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1763\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1729\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1721\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1613\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:4:\"1413\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:4:\"1354\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:4:\"1289\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:4:\"1208\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:4:\"1160\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:4:\"1146\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:4:\"1015\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"971\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"926\";}s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";s:3:\"921\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"888\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"862\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"852\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"800\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"786\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"758\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"735\";}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";s:3:\"734\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"730\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"693\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"684\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"679\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"668\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"642\";}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";s:3:\"641\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"639\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"637\";}}", "yes");
INSERT INTO `wp_options` VALUES("483", "_site_transient_timeout_theme_roots", "1432758360", "yes");
INSERT INTO `wp_options` VALUES("484", "_site_transient_theme_roots", "a:5:{s:7:\"gazette\";s:7:\"/themes\";s:12:\"lifestyle_20\";s:7:\"/themes\";s:13:\"twentyfifteen\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("486", "ws_widget__ad_squares_configured", "0", "yes");
INSERT INTO `wp_options` VALUES("487", "ws_widget__ad_squares_notices", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("488", "ws_widget__ad_squares_options", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("490", "mobile_custom_footer", "<a href=\"http://www.plrblogs.com/\">PLR Blogs</a>", "yes");
INSERT INTO `wp_options` VALUES("491", "mobile_force", "no", "yes");
INSERT INTO `wp_options` VALUES("492", "mobile_custom_logo", "", "yes");
INSERT INTO `wp_options` VALUES("493", "mobile_custom_background", "", "yes");
INSERT INTO `wp_options` VALUES("494", "mobile_app_icon", "http://demobay.info/remedy/wp-content/plugins/obox-mobile//admin/images/iphone_ico.png", "yes");
INSERT INTO `wp_options` VALUES("495", "mobile_license_key", "", "yes");
INSERT INTO `wp_options` VALUES("497", "smart_youtube", "a:25:{s:5:\"posts\";s:2:\"on\";s:8:\"comments\";s:3:\"off\";s:3:\"img\";s:3:\"off\";s:5:\"width\";i:425;s:6:\"height\";i:344;s:7:\"widthhq\";i:480;s:8:\"heighthq\";i:295;s:9:\"widthside\";i:150;s:10:\"heightside\";i:125;s:3:\"rel\";i:1;s:5:\"color\";s:5:\"blank\";s:6:\"border\";i:0;s:4:\"link\";s:2:\"on\";s:5:\"valid\";s:3:\"off\";s:6:\"search\";s:3:\"off\";s:4:\"info\";s:2:\"on\";s:3:\"ann\";s:2:\"on\";s:8:\"template\";s:7:\"{video}\";s:8:\"autoplay\";i:0;s:7:\"privacy\";i:0;s:5:\"wtext\";s:0:\"\";s:6:\"wtitle\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:6:\"iframe\";s:2:\"on\";s:11:\"dark_player\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("501", "smart_youtube_pro", "a:34:{s:5:\"posts\";s:2:\"on\";s:8:\"comments\";s:3:\"off\";s:3:\"img\";s:3:\"off\";s:5:\"width\";i:425;s:6:\"height\";i:344;s:7:\"widthhq\";i:480;s:8:\"heighthq\";i:295;s:9:\"widthside\";i:200;s:10:\"heightside\";i:167;s:3:\"rel\";i:1;s:4:\"link\";s:2:\"on\";s:5:\"valid\";s:3:\"off\";s:6:\"search\";s:3:\"off\";s:4:\"info\";s:2:\"on\";s:3:\"ann\";s:2:\"on\";s:8:\"template\";s:7:\"{video}\";s:8:\"autoplay\";i:0;s:14:\"autoplay_first\";i:0;s:7:\"privacy\";i:0;s:5:\"wtext\";s:0:\"\";s:6:\"wtitle\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:6:\"iframe\";s:2:\"on\";s:4:\"http\";s:3:\"off\";s:3:\"www\";s:3:\"off\";s:4:\"loop\";i:0;s:5:\"thumb\";s:3:\"off\";s:8:\"colorbox\";s:3:\"off\";s:14:\"colorbox_theme\";i:1;s:7:\"excerpt\";s:3:\"not\";s:8:\"logoless\";s:2:\"on\";s:7:\"wiziapp\";s:3:\"off\";s:7:\"ogimage\";s:3:\"off\";s:5:\"theme\";s:4:\"dark\";}", "yes");
INSERT INTO `wp_options` VALUES("506", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1432756786;s:7:\"checked\";a:15:{s:39:\"ad-squares-widget/ad-squares-widget.php\";s:6:\"110709\";s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";s:3:\"1.8\";s:25:\"duplicator/duplicator.php\";s:6:\"0.5.22\";s:23:\"slider-image/slider.php\";s:5:\"2.7.4\";s:22:\"obox-mobile/mobile.php\";s:5:\"1.1.7\";s:33:\"privacy-policy/privacy-policy.php\";s:3:\"1.1\";s:30:\"smart-youtube/smartyoutube.php\";s:3:\"4.3\";s:41:\"social-share-boost/social-share-boost.php\";s:3:\"4.3\";s:24:\"wordpress-seo/wp-seo.php\";s:5:\"2.1.1\";s:34:\"wp-contact-form/wp-contactform.php\";s:3:\"1.6\";s:32:\"wpfree-images/pixabay-images.php\";s:3:\"2.3\";s:27:\"wp-super-cache/wp-cache.php\";s:5:\"1.4.4\";s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";s:5:\"1.8.7\";s:26:\"youtube-widget/youtube.php\";s:3:\"1.1\";s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";s:5:\"1.0.1\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:12:{s:39:\"ad-squares-widget/ad-squares-widget.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"13627\";s:4:\"slug\";s:17:\"ad-squares-widget\";s:6:\"plugin\";s:39:\"ad-squares-widget/ad-squares-widget.php\";s:11:\"new_version\";s:6:\"110709\";s:3:\"url\";s:48:\"https://wordpress.org/plugins/ad-squares-widget/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/ad-squares-widget.110709.zip\";}s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"53172\";s:4:\"slug\";s:30:\"clickbank-ads-clickbank-widget\";s:6:\"plugin\";s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";s:11:\"new_version\";s:3:\"1.8\";s:3:\"url\";s:61:\"https://wordpress.org/plugins/clickbank-ads-clickbank-widget/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/clickbank-ads-clickbank-widget.zip\";}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"22600\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"0.5.22\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.0.5.22.zip\";}s:23:\"slider-image/slider.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"49075\";s:4:\"slug\";s:12:\"slider-image\";s:6:\"plugin\";s:23:\"slider-image/slider.php\";s:11:\"new_version\";s:5:\"2.7.4\";s:3:\"url\";s:43:\"https://wordpress.org/plugins/slider-image/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/slider-image.2.7.4.zip\";}s:30:\"smart-youtube/smartyoutube.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"1584\";s:4:\"slug\";s:13:\"smart-youtube\";s:6:\"plugin\";s:30:\"smart-youtube/smartyoutube.php\";s:11:\"new_version\";s:3:\"4.3\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/smart-youtube/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/smart-youtube.zip\";}s:41:\"social-share-boost/social-share-boost.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"41523\";s:4:\"slug\";s:18:\"social-share-boost\";s:6:\"plugin\";s:41:\"social-share-boost/social-share-boost.php\";s:11:\"new_version\";s:3:\"4.3\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/social-share-boost/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/social-share-boost.4.3.zip\";}s:24:\"wordpress-seo/wp-seo.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"5899\";s:4:\"slug\";s:13:\"wordpress-seo\";s:6:\"plugin\";s:24:\"wordpress-seo/wp-seo.php\";s:11:\"new_version\";s:5:\"2.1.1\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/wordpress-seo/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/wordpress-seo.2.1.1.zip\";}s:34:\"wp-contact-form/wp-contactform.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"337\";s:4:\"slug\";s:15:\"wp-contact-form\";s:6:\"plugin\";s:34:\"wp-contact-form/wp-contactform.php\";s:11:\"new_version\";s:3:\"1.6\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/wp-contact-form/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/wp-contact-form.1.6.zip\";}s:27:\"wp-super-cache/wp-cache.php\";O:8:\"stdClass\":7:{s:2:\"id\";s:4:\"1221\";s:4:\"slug\";s:14:\"wp-super-cache\";s:6:\"plugin\";s:27:\"wp-super-cache/wp-cache.php\";s:11:\"new_version\";s:5:\"1.4.4\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/wp-super-cache/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/wp-super-cache.1.4.4.zip\";s:14:\"upgrade_notice\";s:99:\"Security release fixing an XSS bug in the settings page, and fix for fatal error in output handler.\";}s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"32977\";s:4:\"slug\";s:23:\"youtube-channel-gallery\";s:6:\"plugin\";s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";s:11:\"new_version\";s:5:\"1.8.7\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/youtube-channel-gallery/\";s:7:\"package\";s:72:\"https://downloads.wordpress.org/plugin/youtube-channel-gallery.1.8.7.zip\";}s:26:\"youtube-widget/youtube.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"2713\";s:4:\"slug\";s:14:\"youtube-widget\";s:6:\"plugin\";s:26:\"youtube-widget/youtube.php\";s:11:\"new_version\";s:3:\"1.1\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/youtube-widget/\";s:7:\"package\";s:57:\"https://downloads.wordpress.org/plugin/youtube-widget.zip\";}s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"46160\";s:4:\"slug\";s:25:\"youtube-widget-responsive\";s:6:\"plugin\";s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";s:11:\"new_version\";s:5:\"1.0.1\";s:3:\"url\";s:56:\"https://wordpress.org/plugins/youtube-widget-responsive/\";s:7:\"package\";s:68:\"https://downloads.wordpress.org/plugin/youtube-widget-responsive.zip\";}}}", "yes");
INSERT INTO `wp_options` VALUES("507", "duplicator_package_active", "O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:24:\"20150527_naturalremedies\";s:4:\"Hash\";s:29:\"55663be904b1a9219150527214929\";s:8:\"NameHash\";s:54:\"20150527_naturalremedies_55663be904b1a9219150527214929\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:64:\"/home1/anton241/public_html/demobay.info/remedy/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://demobay.info/remedy/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"20150527_naturalremedies_55663be904b1a9219150527214929_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:47:\"/home1/anton241/public_html/demobay.info/remedy\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:24:\"20150527_naturalremedies\";s:4:\"Hash\";s:29:\"55663be904b1a9219150527214929\";s:8:\"NameHash\";s:54:\"20150527_naturalremedies_55663be904b1a9219150527214929\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:64:\"/home1/anton241/public_html/demobay.info/remedy/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://demobay.info/remedy/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":11:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:30;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:58;}", "yes");
INSERT INTO `wp_options` VALUES("510", "wpseo_taxonomy_meta", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("518", "_transient_timeout_wpseo_sitemap_cache_1_1", "1432844052", "no");
INSERT INTO `wp_options` VALUES("519", "_transient_wpseo_sitemap_cache_1_1", "<sitemapindex xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n<sitemap>\n<loc>http://demobay.info/remedy/post-sitemap.xml</loc>\n<lastmod>2015-05-27T20:12:53+00:00</lastmod>\n</sitemap>\n<sitemap>\n<loc>http://demobay.info/remedy/page-sitemap.xml</loc>\n<lastmod>2015-05-27T14:47:39+00:00</lastmod>\n</sitemap>\n<sitemap>\n<loc>http://demobay.info/remedy/category-sitemap.xml</loc>\n<lastmod>2015-05-27T20:12:53+00:00</lastmod>\n</sitemap>\n<sitemap>\n<loc>http://demobay.info/remedy/post_tag-sitemap.xml</loc>\n<lastmod>2015-05-27T20:12:53+00:00</lastmod>\n</sitemap>\n</sitemapindex>", "no");
INSERT INTO `wp_options` VALUES("521", "_site_transient_timeout_browser_5478e3e0419836dcd5380bc1b9b2c7a6", "1433362529", "yes");
INSERT INTO `wp_options` VALUES("522", "_site_transient_browser_5478e3e0419836dcd5380bc1b9b2c7a6", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"38.0\";s:10:\"update_url\";s:23:\"http://www.firefox.com/\";s:7:\"img_src\";s:50:\"http://s.wordpress.org/images/browsers/firefox.png\";s:11:\"img_src_ssl\";s:49:\"https://wordpress.org/images/browsers/firefox.png\";s:15:\"current_version\";s:2:\"16\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("523", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1432800931", "no");
INSERT INTO `wp_options` VALUES("524", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1432800931", "no");
INSERT INTO `wp_options` VALUES("525", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1432757731", "no");
INSERT INTO `wp_options` VALUES("526", "_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "1432800932", "no");
INSERT INTO `wp_options` VALUES("527", "_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt: Why Awe?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45102\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"http://ma.tt/2015/05/why-awe/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:436:\"<blockquote><p>In the great balancing act of our social lives, between the gratification of self-interest and a concern for others, fleeting experiences of awe redefine the self in terms of the collective, and orient our actions toward the needs of those around us.</p></blockquote>\n<p>The New York Times answers <a href=\"http://www.nytimes.com/2015/05/24/opinion/sunday/why-do-we-experience-awe.html\">Why Do We Experience Awe?</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 May 2015 16:48:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: My Struggle to Learn How the WordPress REST API Works\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44319\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wptavern.com/my-struggle-to-learn-how-the-wordpress-rest-api-works\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3087:\"<p>Earlier today, I watched a <a href=\"http://wptavern.com/learn-how-to-utilize-the-wp-rest-api-with-rachel-baker\">free presentation</a> on how to use the WordPress REST API by Rachael Baker via <a href=\"http://wpsessions.com\">WPSessions</a>. If you missed it, you can <a href=\"http://wpsessions.com/sessions/utilizing-the-wp-rest-api/\">watch the recording</a> for $9.</p>\n<p>As I watched the presentation, it was clear that no matter how many tutorials I read, WordCamp sessions I attend, and videos I watch, I won&#8217;t be able to grasp the API until I use products built with it. I&#8217;m not a developer and the REST API is developer centric technology.</p>\n<h2>What I Think the REST API Is</h2>\n<p>Based on what I&#8217;ve learned so far, I&#8217;ve figured out that the API provides a series of end points which are specific parts of WordPress. These end points can be connected to and manipulated through the REST API.</p>\n<p>It&#8217;s this API that opens up a slew of new opportunities for application developers to send and receive data. This is what allows a developer to build an app that connects to WordPress with minimal code.</p>\n<h2>Learning Custom Post Types</h2>\n<p>In 2010, there <a href=\"https://wordpress.org/support/topic/styling-individual-pagesposts\">were a lot of requests</a> for <a href=\"http://www.nathanrice.net/blog/wordpress-2-8-and-the-body_class-function/\">tutorials</a> on how to give specific posts a unique style. When <a href=\"https://codex.wordpress.org/Post_Types\">Custom Post Types</a> were introduced in WordPress 3.0, I was excited because I thought they would provide the ability to create custom styles for posts.</p>\n<p>Looking back, some of the requests are due to the <a href=\"http://codex.wordpress.org/Migrating_Plugins_and_Themes_to_2.7#Post_Classes\">post_class() function</a> added in WordPress 2.7 that provides the ability to use CSS to style a post. It took a few years to rewire my brain to not think of Custom Post Types this way.</p>\n<p>When I described how long it took to figure out Custom Post Types on Twitter, Justin Tadlock responded, that end users should have never been introduced to the term <em>post type</em>.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/jeffr0\">@jeffr0</a> End users should\'ve never heard the term \"post type\". We devs did a poor job with that. We should\'ve said \"forums,\" \"e-commerce,\"&#8230;</p>\n<p>&mdash; Justin Tadlock (@justintadlock) <a href=\"https://twitter.com/justintadlock/status/603287148863819776\">May 26, 2015</a></p></blockquote>\n<p></p>\n<h2>Reviewing Products Helps Connect the Dots</h2>\n<p>I didn&#8217;t fully comprehend Custom Post Types until I reviewed several WordPress products that utilized them. After awhile, I was able to connect the dots between what I saw in the WordPress backend and what appeared on the front end.</p>\n<p>I think the same thing will happen when the REST API is added to WordPress core. I&#8217;ll be able to connect the dots and figure out how it works by reviewing products that use it.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 May 2015 02:02:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Replace the BuddyPress Mystery Man with Unique, Colorful Identicons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=39298\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/replace-the-buddypress-mystery-man-with-unique-colorful-identicons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3665:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/buddypress-identicons-featured.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/buddypress-identicons-featured.jpg?resize=752%2C377\" alt=\"buddypress-identicons-featured\" class=\"aligncenter size-full wp-image-44341\" /></a></p>\n<p>Nothing makes a BuddyPress site seem more active or more colorful than when members upload their own unique avatars. Unfortunately, not all users have the motivation to follow through with adding a profile picture. You could use a plugin to <a href=\"http://wptavern.com/add-avatar-upload-to-buddypress-registration\" target=\"_blank\">add avatar upload to registration</a>, or even <a href=\"http://wptavern.com/new-plugin-forces-buddypress-users-to-upload-a-profile-photo\" target=\"_blank\">force BuddyPress users to upload a profile photo</a> before accessing other pages. However, this may seem a bit heavy handed for some social networks.</p>\n<p>The <a href=\"https://wordpress.org/plugins/buddypress-identicons/\" target=\"_blank\">BuddyPress Identicons</a> plugin is one alternative that will bring some color to the members directory without troubling users to upload a profile photo. By default, those who haven&#8217;t uploaded an image will have the mystery man avatar assigned. Too many of these can turn your directories into a sea of grey and white and give the impression that members are not invested in the community. BuddyPress Identicons replaces the mystery man with GitHub-style identicons.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/buddypress-identicons.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/buddypress-identicons.jpg?resize=644%2C404\" alt=\"buddypress-identicons\" class=\"aligncenter size-full wp-image-44322\" /></a></p>\n<p>BuddyPress developer <a href=\"http://henrywright.me/\" target=\"_blank\">Henry Wright</a>, the plugin&#8217;s creator, was inspired by <a href=\"https://github.com/blog/1586-identicons\" target=\"_blank\">GitHub&#8217;s implementation of identicons</a>, which the social network added in 2013 for users who do not have a Gravatar. The idea is based on <a href=\"https://github.com/donpark/identicon\" target=\"_blank\">Don Park&#8217;s original Java and Canvas implementations</a> for creating unique identicons.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/henry-identicon.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/henry-identicon.jpg?resize=229%2C163\" alt=\"henry-identicon\" class=\"alignright size-full wp-image-44338\" /></a>BuddyPress Identicons are uniquely generated from a hash of the member&#8217;s username. The implementation will not look exactly how it does on GitHub, as the logic used to generate the identicon is somewhat different. In fact, this plugin allows for a few customizations to better fit your social network. You can set the background to transparent in the BuddyPress settings menu and also adjust the image size by <a href=\"https://wordpress.org/plugins/buddypress-identicons/faq/\" target=\"_blank\">defining the constants in your bp-custom.php file</a>.</p>\n<p>The plugin is compatible with both WordPress multisite and bbPress. After testing it on a BuddyPress site, I can confirm that it works as advertised. If you&#8217;ve been frustrated by a lack of unique avatars on your social network, the <a href=\"https://wordpress.org/plugins/buddypress-identicons/\" target=\"_blank\">BuddyPress Identicons</a> plugin provides an instant fix. Simply install it from WordPress.org, activate it, and all of your mystery men will be transformed into unique, colorful identicons.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 26 May 2015 23:04:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Postcard Project Discontinued, iOS and Android Apps Now Open Source\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44282\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/postcard-project-discontinued-ios-and-android-apps-now-open-source\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6094:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/postcard-share.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/postcard-share.jpg?resize=316%2C531\" alt=\"postcard-share\" class=\"alignright size-full wp-image-44291\" /></a>Kyle Newsome, creator of <a href=\"http://www.postcardsocial.net/\" target=\"_blank\">Postcard</a>, announced over the weekend that the project will be discontinued. The free social sharing app for iOS <a href=\"http://wptavern.com/own-your-content-postcard-social-sharing-app-launches-with-wordpress-integration\" target=\"_blank\">launched in February of 2014</a> with the aim to make it easy to share content from your phone to multiple social networks, including your own website.</p>\n<p>Postcard&#8217;s chief selling point was the idea of owning your own content. Instead of posting content directly on Facebook or Twitter, for example, you could set your own website as the “host” network and direct all the traffic there.</p>\n<p>Newsome also built a free WordPress <a href=\"https://wordpress.org/plugins/postcard-social/\" target=\"_blank\">plugin</a> as a companion to the app to allow users to host and archive their data. He intended it to help users make sure their websites didn&#8217;t go stale as they regularly posted short form content to social networks.</p>\n<p>Unfortunately, the idea did not catch on as Newsome hoped it would and he was unable to keep up with the maintenance.</p>\n<p>&#8220;I&#8217;ve fallen behind on maintenance and, due to some sweeping new policy changes in Facebook&#8217;s platform as of May 2015, the live iOS and Android development versions are broken and it&#8217;s been the final kick in my ass necessary to admit Postcard is unsustainable,&#8221; he said.</p>\n<p>Despite making progress on the Android version last month, he was ultimately unable to get it ready for release on the Android market.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Android version making progress. It is very real. <a href=\"http://t.co/7nYYtnHZpm\">pic.twitter.com/7nYYtnHZpm</a></p>\n<p>&mdash; Postcard (@postcardsocial) <a href=\"https://twitter.com/postcardsocial/status/458338905772023808\">April 21, 2014</a></p></blockquote>\n<p></p>\n<p>In <a href=\"http://postcardsocial.net/posts/2015-05-25-post-mortem\" target=\"_blank\">Postcard&#8217;s post mortem</a>, Newsome identified changes to external services and their APIs as one of the primary factors for discontinuing the project.</p>\n<blockquote><p>Postcard was an interesting project for me. It started from a frustration with ever changing policies and lack of standardization in social media and ironically will be shutting down for exactly the same reasons. I really have to say that social media management is a tough thing to tackle for any single developer. It&#8217;s hard enough to depend on code that you didn&#8217;t write yourself and it&#8217;s even harder to depend multiple on APIs. It takes a lot of maintenance just to stand still.</p></blockquote>\n<p>Keeping the WordPress plugin updated was also a challenge, and Newsome was discouraged at the prospect of having to rebuild it in the near future.</p>\n<p>&#8220;The WordPress plugin also got stale as a major update and even a new forthcoming JSON API made the custom work I had done seem like a large investment made in something soon to be obsolete,&#8221; he said.</p>\n<p>Additionally, he found that the costs of maintaining the app, both financially and in terms of time spent, were unsustainable, as the app only pulled in a total of $750 over the past year. This barely covered the app store licensing fees.</p>\n<h3>Postcard Mobile Apps Now Open Source</h3>\n<p>Newsome has no intention of maintaining or developing the mobile apps or the <a href=\"https://wordpress.org/plugins/postcard-social/\" target=\"_blank\">WordPress plugin</a> anymore. The apps are now available on GitHub under the MIT license with broken/partial functionality:</p>\n<ul>\n<li><strong>iOS:</strong> <a href=\"http://github.com/bitwit/postcard-ios\" target=\"_blank\">github.com/bitwit/postcard-ios</a></li>\n<li><strong>Android:</strong> <a href=\"http://github.com/bitwit/postcard-android\" target=\"_blank\">github.com/bitwit/postcard-android</a></li>\n</ul>\n<p>All the code is available to any developer who wants to take the original Postcard idea and run with it or modify it to suit another purpose.</p>\n<p>&#8220;I don&#8217;t want to be that developer who never admits their project is over when it&#8217;s over,&#8221; Newsome said. &#8220;Both myself and my users deserve better.&#8221;</p>\n<p>He hoped that Postcard would fundamentally change how people use social networks, but the idea of having your WordPress site as the host network for your social content never really caught on. Since many people do not host and maintain their own websites, the golden feature of this app probably went unused by the majority of those who tried it. The ability to broadcast the same content to multiple networks was likely the more popular feature. In the end, the Postcard iOS app was downloaded just 6,000 times.</p>\n<p>Postcard&#8217;s failure may be an indication that people are still not ready for decentralized social networking, where you host your own data and distribute it to third-party social networks at will. Given that the project was powered by a one-person team (a developer who is otherwise employed), Postcard had little chance of being able to keep pace with the development burden of external networks and their changing APIs.</p>\n<p>Newsome may not have launched it with enough resources, or it may not have been the right approach or the right time. Multiple factors combined ultimately spelled Postcard&#8217;s doom, but if any interested parties have the vision and time to revive it or fork it, Newsome is happy to assist in any small way. You can contact him directly via the <a href=\"http://bitwit.ca/blog/2015-05-25-postcard-post-mortem/\" target=\"_blank\">Postcard post mortem blog</a> or on <a href=\"http://www.twitter.com/kylnew\" target=\"_blank\">Twitter</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 26 May 2015 17:18:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Matt: Best of Thelonious Monk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45097\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://ma.tt/2015/05/best-of-thelonious-monk/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:556:\"<blockquote><p>Monk was the master of the single note, perfectly selected, timed, and struck so that it would have a symphonic amplitude. The asymptote of his music is a punctuated silence, which is why he was especially sensitive to his drummers and dependent on them to organize the music’s forward motion.</p></blockquote>\n<p><a href=\"http://www.newyorker.com/culture/richard-brody/the-best-of-thelonious-monk\">The New Yorker reviews the 15 CD set, The Best of Thelonious Monk</a>, which sounds like a lovely set of music to spend a weekend with.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 26 May 2015 16:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: WordPress + Japan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45095\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"http://ma.tt/2015/05/wordpress-japan/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:407:\"<p>Did you know that WordPress users in Japan have meetups dedicated just to eating crab in the Fukui prefecture? WP Tavern has <a href=\"http://wptavern.com/community-translation-and-wapuu-how-japan-is-shaping-wordpress-history\">has a fantastic article on Community, Translation, and Wapuu: How Japan is Shaping WordPress History</a>. There is so much that is quotable, just check out the entire thing!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 25 May 2015 22:53:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Matt: Bosworth says Be Kind\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45093\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"http://ma.tt/2015/05/bosworth-says-be-kind/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:361:\"<p>Andrew Bosworth, one of the early engineers and leaders at Facebook <a href=\"http://boz.com/articles/be-kind.html\">tells the story about how he almost got fired in the early days despite being a top engineer</a>. &#8220;If I was a good engineer, why would it be hard to work with me? Of course that question was the very foundation of my problem.&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 24 May 2015 23:45:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"Andrew Nacin: Smarter algorithms, smarter defaults\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"http://nacin.com/?p=4329\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://nacin.com/2015/05/24/smart-algorithms-defaults/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:961:\"<blockquote><p>Instead of showing the user an alert that something might not work, maybe we can build a smarter algorithm. Instead of asking the user to make a choice up front, maybe we can set a smart default and see if there is high demand after launch for more customization.</p></blockquote>\n<p>— <a href=\"http://www.rebeccarolfe.com/\">Rebecca Rolfe</a> on the Google Chrome team, interviewed in <a href=\"http://www.refinery29.com/female-white-hat-hackers-google-chrome\">The Badass Women of Chrome&#8217;s Security Team</a> in Refinery29.</p>\n<p>(More on making <a href=\"http://nacin.com/2011/12/18/in-open-source-learn-to-decide/\">decisions</a>, <a href=\"http://nacin.com/2013/07/01/firefox-makes-a-decision-removes-an-option/\">not options</a>.)</p>\n<p class=\"share-sfc-stc\"><a href=\"http://twitter.com/share?url=http%3A%2F%2Fwp.me%2FpQEdq-17P&count=vertical&related=nacin&text=Smarter algorithms, smarter defaults\" class=\"twitter-share-button\"></a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 24 May 2015 23:11:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Matt: Soaring SV Housing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://ma.tt/2015/05/soaring-sv-housing/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:277:\"<blockquote><p>Talent is leaving Silicon Valley because of high real estate costs. Today, the median price for a home just exceeded $1 million.</p></blockquote>\n<p><a href=\"http://www.cnbc.com/id/102697372\">Why one in four Silicon Valley homebuyers wants to leave</a>. Yep.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 24 May 2015 01:38:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: TC on Apple Watch\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45087\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://ma.tt/2015/05/tc-on-apple-watch/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"<p>The John Biggs article on <a href=\"http://techcrunch.com/2015/05/16/why-im-still-wearing-my-apple-watch/\">Why I’m Still Wearing My Apple Watch</a> almost perfectly describes how I&#8217;m feeling about the watch right now. It is a very personal device, I&#8217;ve gotten attached to the little fellow, and I should probably start selling all my mechanical watches.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 23 May 2015 00:55:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"WPTavern: Cover: A Minimalist Blogging Theme for WordPress, Featuring Support for Aesop Story Engine\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44165\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"http://wptavern.com/cover-a-minimalistic-blogging-theme-for-wordpress-featuring-support-for-aesop-story-engine\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3410:\"<p>If you&#8217;re looking to bring your blog&#8217;s design back to the bare bones of pure content without distractions, then the new <a href=\"https://wordpress.org/themes/cover/\" target=\"_blank\">Cover</a> theme may be a good option. Cover brings blogging minimalism to a new level. After less than a month on WordPress.org, it has already been downloaded more than 2,500 times.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/cover.png\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/cover.png?resize=880%2C660\" alt=\"cover\" class=\"aligncenter size-full wp-image-44244\" /></a></p>\n<p>Cover was created by new WordPress.org theme author <a href=\"http://eichefam.net/\" target=\"_blank\">Paul Eiche</a> and is based on the popular <a href=\"http://underscores.me/\" target=\"_blank\">Underscores starter theme</a> maintained by Automattic.</p>\n<p>The theme&#8217;s simple, single-column design is accented by support for full-width featured images. It was bundled with <a href=\"http://fortawesome.github.io/Font-Awesome/\" target=\"_blank\">Font Awesome</a> to allow users to easily add scalable vector icons to any content or social menu. Cover incorporates the lightweight <a href=\"https://github.com/WickyNilliams/headroom.js\" target=\"_blank\">Headroom.js</a> script for hiding your header until it&#8217;s needed. It also includes <a href=\"https://github.com/Prinzhorn/skrollr\" target=\"_blank\">skrollr.js</a>, a stand-alone parallax scrolling library for mobile (Android + iOS) and desktop.</p>\n<p>Cover&#8217;s widgets and menus are optional and hidden behind an full-screen overlay triggered by the hamburger icon. This keeps the focus on your content while offering plenty of space for unlimited widgets in the overlay.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/cover-overlay.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/cover-overlay.jpg?resize=965%2C669\" alt=\"Cover\'s overlay for widgets and menus\" class=\"size-full wp-image-44265\" /></a>Cover&#8217;s overlay for widgets and menus\n<p>Cover supports one regular navigation menu, one for social media, and an additional social menu in the footer. If you&#8217;re using Jetpack’s Infinite Scrolling module, the theme will actually detect whether or not the footer social menu is present and respond accordingly.</p>\n<p>The theme was built to make a nice accompaniment to sites using the <a href=\"https://wordpress.org/plugins/aesop-story-engine/\" target=\"_blank\">Aesop Story Engine</a> plugin, although it&#8217;s not required. When used with the plugin, content can expand to full-width when using components such as images, galleries, maps, etc.</p>\n<p>If you&#8217;re a developer wanting to modify the theme, you&#8217;ll find that Cover&#8217;s stylesheet is compressed. It was built with Sass and the /sass directory includes all the necessary components for compiling the stylesheet.</p>\n<p>Cover is a beautifully responsive theme that presents your website in a bold way on any device. Its minimalist design supports your content instead of upstaging it with the clutter of widgets and navigation. Check out a <a href=\"http://eichefam.net/projects/cover/\" target=\"_blank\">live demo</a> on the theme&#8217;s project page to see it in action. <a href=\"https://wordpress.org/themes/cover/\" target=\"_blank\">Cover</a> is available for free on WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 May 2015 23:15:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"WPTavern: Hello Security Plugin Aims to Educate WordPress Users on Web Security Best Practices\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44205\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://wptavern.com/hello-security-plugin-aims-to-educate-wordpress-users-on-web-security-best-practices\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4532:\"<p><a href=\"https://wordpress.org/plugins/hello-security/\">Hello Security</a> is a new plugin developed by <a href=\"https://profiles.wordpress.org/m_butcher/\">Michele Butcher</a> that displays security tips and reminders in the WordPress backend. It&#8217;s a fork of Hello Dolly and Butcher&#8217;s first plugin submitted to the <a href=\"https://wordpress.org/plugins/\">plugin directory</a>.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/HelloSecurityTips.png\"><img class=\"size-full wp-image-44216\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/HelloSecurityTips.png?resize=478%2C159\" alt=\"Hello Security Tips\" /></a>Hello Security Tips\n<p>Security best practices include PASSWORD is never a good password, backup all the things, and only give users the access they need. A full list of the tips used is located <a href=\"https://github.com/mlbanddrb/hello-security/blob/master/hello-security.php\">within the hello-security.php file</a>.</p>\n<h2>Inspiration, Motivation, and Determination</h2>\n<p>For years, Butcher has avoided learning how to code. Thanks to a WordCamp session and inspirational members of the WordPress community, she now has a plugin of her own. In this short interview, we find out what held her back from developing plugins sooner and who inspired her to go through the process.</p>\n<p><strong>What held you back from writing your first plugin?</strong></p>\n<p>For the longest time, I didn&#8217;t want to learn how to code. I was a firm believer in that there&#8217;s a plugin for everything. Once I was motivated enough to create one, I didn&#8217;t know what to create first.</p>\n<p>I have ideas for the types of plugins I want to make but I always find three plugins with similar functionality. The first WordPress plugin I&#8217;ve ever looked at the code for is Better WP Security, developed by <a href=\"https://profiles.wordpress.org/chriswiegman/\">Chris Wiegman</a> that eventually turned into iThemes Security.</p>\n<p>I knew I would have to dig deep into learning code before I could write a plugin that large. I discovered the best way to learn code is to jump in and read actively developed code. Once I became comfortable reading code, I started to get ideas on plugins to create.</p>\n<p><strong>What motivated you enough to go through with creating and releasing your first plugin?</strong></p>\n<p>I subconsciously kept telling myself to <em>just make something</em>. I eventually decided to get into plugin development and taking the first step was the hardest. I bounced ideas off of friends for a long time before I jumped in and just made one.</p>\n<p>At WordCamp North Canton, I attended <a href=\"https://northcanton.wordcamp.org/2015/session/introduction-to-plugin-development/\">Topher DeRosia&#8217;s session, </a>Introduction to WordPress Plugin Development. After the session was over, I realized I didn&#8217;t have to make something that has thousands of lines of code. I brainstormed ideas, thinking how I could use Hello Dolly.</p>\n<p><strong>What inspired you to write Hello Security?</strong></p>\n<p>The first idea that came to mind in using Hello Dolly was not security related. I initially thought of doing something fun like Hello Jovi (Bon Jovi lyrics) or Hello Marvel where I use awesome one liners from the various Marvel movies. Iron Man quotes alone would have given me at least 30 lines to work with.</p>\n<p>I decided against doing something fun and make something that could be useful. Many of the quotes in Hello Security are things I say at all of my talks, tell every client after I clean their site, and mention to everyone who is getting into WordPress.</p>\n<p>Hello Security is there to help those who are either new to WordPress or might not know how or why they should keep their site secure. It is a way to be proactive before something bad happens. Wiegman and DeRosia inspired me the most and I&#8217;m glad they did.</p>\n<h2>Informing Without Overwhelming</h2>\n<p>Hello Security is a good plugin that educates users on best practices related to web security without overwhelming them with information. I tested Hello Security on WordPress 4.2.2 and didn&#8217;t experience any issues. It&#8217;s available for free on <a href=\"https://wordpress.org/plugins/hello-security/\">WordPress.org</a> and <a href=\"https://github.com/mlbanddrb/hello-security\">GitHub.</a> Butcher encourages those who want to see a security tip added to submit a <a href=\"https://github.com/mlbanddrb/hello-security\">pull request on GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 May 2015 21:24:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WPTavern: How WordPress Business Owners are Benefiting from Publicly Sharing Revenue Stats\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44207\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://wptavern.com/how-wordpress-business-owners-are-benefiting-from-publicly-sharing-revenue-stats\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4890:\"<p>In light of <a href=\"http://wptavern.com/automattic-acquires-woocommerce\" target=\"_blank\">Automattic&#8217;s recent acquisition of WooCommerce</a> (and all of WooThemes), estimated to be in the range of $30M, WordPress business owners have been infused with a fresh perspective of the value and potential in creating strong GPL-licensed products.</p>\n<p>Automattic&#8217;s acquisition of Woo, colloquially referred to as the &#8220;WooMattic&#8221; deal, is the company&#8217;s first major purchase within the WordPress ecosystem since BuddyPress in 2007.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Perhaps most interesting: Woo is Automattic\'s first acquisition of a WP ecosystem product since BuddyPress (2007) <a href=\"http://t.co/AJ1CIPS9Nc\">http://t.co/AJ1CIPS9Nc</a></p>\n<p>&mdash; Andrew Nacin (@nacin) <a href=\"https://twitter.com/nacin/status/601087179624947713\">May 20, 2015</a></p></blockquote>\n<p></p>\n<p>The business model that brought WooCommerce to success is a free base product with a marketplace of commercial extensions. This revenue model currently drives the success of many of the top products in the WordPress ecosystem and is also proving to be effective for new businesses looking to quickly establish a user base.</p>\n<p>This morning, WordPress developer Scott Bolinger published a compilation of <a href=\"http://scottbolinger.com/2015-wordpress-revenue-statistics/\" target=\"_blank\">2015 WordPress business revenue statistics</a> based on publicly available transparency reports and figures submitted by business owners. The resource includes each company&#8217;s business model, description, and monthly/yearly revenue.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wordpress-business-revenue.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wordpress-business-revenue.png?resize=1025%2C921\" alt=\"wordpress-business-revenue\" class=\"aligncenter size-full wp-image-44219\" /></a></p>\n<p>Bolinger is planning to use this information in an upcoming presentation and will be keeping the resource up to date with new submissions and figures as they roll in.</p>\n<p>Transparency reports from WordPress businesses, ranging from small to large, have been popping up frequently over the past year, as owners are surprisingly eager to share their progress and receive feedback from the community. These kinds of reports are not unique to the WordPress ecosystem, but they do seem to complement the spirit of adventure that is common among open source product developers.</p>\n<p>Zack Katz, co-founder of <a href=\"http://wptavern.com/gravityview-is-now-public-on-github\" target=\"_blank\">GravityView</a>, remarked on his motivation to share the company&#8217;s revenue publicly.</p>\n<p>&#8220;I think sharing revenue humanizes GravityView: we&#8217;re not a nameless corporation where you put in money and somehow good products and customer service come out,&#8221; he said. &#8220;Our customers are part of an interaction: their purchase of a support license directly allows us to develop the product and help them do great things with their websites.&#8221;</p>\n<p>Katz hopes that the resource will be inspirational for WordPress entrepreneurs who are just getting started.</p>\n<blockquote><p>The WordPress community is slowly realizing that businesses don&#8217;t have to be cutthroat black boxes to succeed. As more people and businesses share and open up, we&#8217;re redefining what it means to be a business in the WordPress ecosystem. I think this leads to lower barriers to entry for others to participate. By sharing GravityView&#8217;s numbers and some of the things I&#8217;ve learned, I hope others are better informed and inspired to join our community.</p></blockquote>\n<p>Nick Haskins, founder of Aesop Interactive, is currently in the midst of <a href=\"http://wptavern.com/lasso-frontend-editing-plugin-for-wordpress-now-available-on-github\" target=\"_blank\"> active experimentation with his products and business model</a> and recently published a <a href=\"http://aesopinteractive.com/jan-april-2015-report/\" target=\"_blank\">transparency report</a> for his 15-month old company. He believes that these kinds of reports are important for demonstrating the types of products and pricing models that can be successful.</p>\n<p>&#8220;I think for Aesopinteractive it&#8217;s showing that you can still abide by WordPress theme best practices, and be successful at selling WordPress themes as add-ons at $129 each with 3-5 options and no functionality,&#8221; Haskins said.</p>\n<p>&#8220;Plus, I really hope it motivates other &#8216;small timers&#8217; to share numbers as well, and be held accountable for our growth. It&#8217;s a lot like sharing your goals publicly, and letting people hold you accountable for it. Sink or swim, the lessons will be valuable either way.&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 May 2015 20:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: WPWeekly Episode 193 – WooMattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=44199&preview_id=44199\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wptavern.com/wpweekly-episode-193-woomattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3179:\"<p>In this episode of WordPress Weekly, <a href=\"http://marcuscouch.com/\">Marcus Couch</a> and I break down Automattic&#8217;s acquisition of WooThemes and discuss the future of WooCommerce. We discuss how the Japanese WordPress community influences WordPress development. Last but not least, we debate the merits of using an honor system for commercial plugins.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/automattic-acquires-woocommerce\">Automattic Acquires WooThemes</a><br />\n<a href=\"http://wptavern.com/wordpress-org-is-testing-international-theme-and-plugin-directories\">WordPress.org is Testing International Theme and Plugin Directories</a><br />\n<a href=\"http://wptavern.com/community-translation-and-wapuu-how-japan-is-shaping-wordpress-history\">Community, Translation, and Wapuu: How Japan is Shaping WordPress History</a><br />\n<a href=\"http://wptavern.com/lasso-frontend-editing-plugin-for-wordpress-now-available-on-github\">Lasso Frontend Editing Plugin for WordPress Now Available on GitHub</a><br />\n<a href=\"http://wptavern.com/cpanels-site-software-addon-disables-wordpress-auto-updates\">cPanel’s Site Software Addon Disables WordPress Auto Updates</a><br />\n<a href=\"http://wptavern.com/all-sessions-from-loopconf-now-available-on-youtube\">All Sessions from LoopConf Now Available on YouTube</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/simply-pinterest/\">Simply Pinterest</a> adds a Pin It button call to action over each image in your post to prompt visitors to Pin your content. You can customize how the plugin is applied to your site with counts, colors and many other settings.</p>\n<p>I wanted to highlight this plugin because it’s the first from Terry Ann Swallow. Terry has been active in WordPress since 2006 but this is her first plugin, and it’s good. We often forget to recognize first time plugin contributors, and I want to recognize Terry and wish her well with this plugin and many more to follow.</p>\n<p><a href=\"https://wordpress.org/plugins/new-facebook-comments/\">New Facebook Comments</a> makes it simple to add the Facebook comments system to WordPress. You can also insert the comment box as a shortcode into any post, page or theme.</p>\n<p><a href=\"https://wordpress.org/plugins/simple-project-managment/\">Simple Project Manager</a> lets you manage projects, clients, tasks, and create invoices in PDF format. It also gives you the ability to run reports about projects, clients, tasks and invoices.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, May 27th 4:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #193:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 May 2015 16:15:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Undercover UberX\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45059\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2015/05/undercover-uberx/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:337:\"<p>Emily Guendelsberger <a href=\"http://citypaper.net/uberdriver/\">went undercover as an UberX driver in Philadelphia and wrote about the experience, particularly the economics of it</a>. It&#8217;s a pretty fascinating and gripping <a href=\"http://longreads.com/\">longread</a>, both in its content and it&#8217;s just well-written.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 May 2015 05:29:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Hookr Enters Beta with New UI and Support for 800+ Plugins and Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44167\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://wptavern.com/hookr-enters-beta-with-new-ui-and-support-for-800-plugins-and-themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9212:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/hookr-featured.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/hookr-featured.jpg?resize=1025%2C464\" alt=\"hookr-featured\" class=\"aligncenter size-full wp-image-44175\" /></a></p>\n<p>Last April, <a href=\"https://twitter.com/explodybits\" target=\"_blank\">Christopher Sanford</a> launched <a href=\"http://hookr.io/\" target=\"_blank\">Hookr</a>, a WordPress hook/API reference for developers. He initially wrote the parser/indexer for his own use, to improve efficiency in his work, and was inspired to make it a public resource.</p>\n<p>&#8220;I have been professionally working with WordPress since 2.8, but most of which I would describe as &#8216;superficial development,\'&#8221; Sanford said. &#8220;It wasn&#8217;t until later, roughly WordPress 3.5, that a large-scale WordPress project came along.</p>\n<p>&#8220;I found myself spending an obscene amount of time either digging through code within my IDE, or performing countless Google searches, in order to uncover/understand various hooks, functions, constants etc. So, I wrote a plugin that would index the application/site it was installed within&#8211; this was the first iteration of Hookr.&#8221;</p>\n<p>As a developer whose career is not based in the WordPress ecosystem, Sanford didn&#8217;t know what to expect when he tested the waters with his new public resource for developers. After several months in alpha, the traffic and feedback were enough to convince him to invest in performance improvements and an overhaul of the UI.</p>\n<p>&#8220;The alpha version of the site was truly alpha &#8211; the UI was a complete afterthought, there were many UI bugs/hiccups, the navigation was not cohesive; it was a hot mess,&#8221; Sanford said. &#8220;Prior to the beta, I had not updated hookr.io for months, which was purposeful. I wanted to see if the traffic would completely level-off, or if it would remain consistent, with the latter being the determining factor as to whether or not I would continue with the project.&#8221;</p>\n<h2>Hookr Beta Adds UI/UX Improvements and Support for 800+ Plugins and Themes</h2>\n<p>Sanford was surprised and encouraged to find that usage of the site was solid and continued to grow. He spent the next three months fixing issues, rewriting core parts of the parser, and refining the UI to focus on features that people actually needed. The site has now entered beta with a slew of noteworthy improvements:</p>\n<ul>\n<li>UI/UX overhaul, with emphasis on responsiveness and fewest number of clicks</li>\n<li>Hookr.io is now twice as fast with half the download payload (mobile first)</li>\n<li>Themes have been introduced to the index &#8211; (current count: 62)</li>\n<li>Hundreds of plugins added to the index (current count: 827)</li>\n<li>5 of the latest versions of each plugin and theme (previously included a single version for each plugin)</li>\n<li>Usage examples that users can cut and paste</li>\n<li>Annotated source code</li>\n</ul>\n<p><a href=\"http://hookr.io/all/#index=a\" target=\"_blank\">Index screens</a> are infinitely-scrollable and filterable, which cuts down on a lot of clicking through endless pagination. <a href=\"http://hookr.io/4.1.1/filters/get_search_form/\" target=\"_blank\">Hook details</a> have been refined to follow a format similar to PHP&#8217;s detail pages and include annotated code signatures and descriptions.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/hookr-annotated-descriptions.png\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/hookr-annotated-descriptions.png?resize=1025%2C701\" alt=\"hookr-annotated-descriptions\" class=\"aligncenter size-full wp-image-44177\" /></a></p>\n<p>In addition to the basic info about the file and lines where the code/object is defined, Hookr has also been updated to display any related hook callbacks sharing the same tag name or signature.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/hookr-relations.png\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/hookr-relations.png?resize=1025%2C701\" alt=\"hookr-relations\" class=\"aligncenter size-full wp-image-44179\" /></a></p>\n<p>Usage examples for every action, filter, function, and constant can now be easily copied. Users can also quickly view source code with Hookr&#8217;s new hyperlinked and annotated source code blocks.</p>\n<h2>To Rebrand or Not to Rebrand?</h2>\n<p>Many of those in search of a comprehensive hook/API reference find Hookr to be easier to use than the official <a href=\"https://developer.wordpress.org/reference/\" target=\"_blank\">WordPress.org code reference</a>. Sanford has experienced friction from creating what some perceive to be a competing resource.</p>\n<blockquote><p>There were several people that have/had an issue with the resource even existing. For the sake of full-disclosure, my career is outside the WordPress ecosystem; it is simply a platform I use (and love), not a lifestyle. </p>\n<p>My experience with the &#8216;community&#8217; has been mostly positive; many people love the resource, while others are indifferent. I wrote Hookr to aid legit designers/developers/agencies, not hobbyists masquerading as designers/developers who have no skill besides martyrdom and nothing positive to contribute.</p></blockquote>\n<p>The Hookr name has also proven to be controversial, as a few vocal opponents find it to be off-putting and offensive. Sanford said that he is very much torn over rebranding the site but is open to the idea.</p>\n<p>&#8220;The WordPress market is saturated &#8211; it is hard to make any sort of impact, hence the name,&#8221; he said. &#8220;The name is short, controversial, relevant, and memorable &#8211; either people love or hate it, of course. It was never the intent to insult, offend, or alienate any demographic.</p>\n<p>&#8220;If people are uncomfortable saying &#8220;Hookr&#8221; in an open forum, then maybe it&#8217;s time to put my personal ethos aside for the betterment of the resource. That being said, I am on the fence in regards to renaming/rebranding Hookr. If I do, it&#8217;s only to remove the initial barrier/stigma and promote usage.&#8221;</p>\n<p>As the site is still in beta, Sanford is still collecting feedback from users but is concentrating on features, fixes, and SEO. If he decides to rebrand, it will likely happen as the site moves out of beta.</p>\n<h2>The Future of the Hookr.io Resource</h2>\n<p>After streamlining the design, removing a few features that no one used, and refining those that worked, Sanford reports that so far users are enjoying the beta version of Hookr.</p>\n<p>&#8220;The feedback I have received has been exceedingly positive,&#8221; he said. &#8220;The usage has effectively doubled.&#8221; User suggestions regarding the search functionality are shaping the roadmap for the next iteration of the resource.</p>\n<p>&#8220;The current search implementation is more or less a filter mechanism, which is effective once you&#8217;ve drilled-down to the relevant index,&#8221; Sanford said. &#8220;However, numerous users have asked for a traditional &#8216;global&#8217; keyword search that spans core, plugins, and themes. The global search, along with a few other features, will be released within the next month or so.&#8221;</p>\n<p>While Sanford is committed to keeping the resource free for anyone to use, he is exploring a few long term options for monetization.</p>\n<p>&#8220;Cluttering the interface with ads is not something I want to do, but never say never,&#8221; he said. &#8220;However, there is another opportunity for monetization.&#8221;</p>\n<p>In the future, Sanford is looking at the possibility of establishing the infrastructure to offer Hookr (SaaS) for commercial theme and plugin developers.</p>\n<blockquote><p>When I released Hookr Alpha, a few people inquired about using it to augment the documentation of their premium plugin/theme. I wasn&#8217;t confident that it was a true &#8216;value-add.&#8217; Over the course of a year, I&#8217;ve refined the parser and data objects to a point of viability. </p>\n<p>The Hookr Parser analyzes source code, which is then reconciled against the inline documentation describing it; often times, the inline documentation is either missing or is erroneous. <a href=\"https://twitter.com/TheJeffMatson\" target=\"_blank\">Jeff Matson</a> and I discussed these issues and decided that Hookr would be invaluable if it could identify these issues, which it now does.</p></blockquote>\n<p>A SaaS model for monetization would allow Sanford to offer developers pre-generated documentation with their themes/plugins. He is also exploring the possibility of offering the raw data in JSON, XML, CSV, etc. to vendors to implement an API microsite.</p>\n<p>For the time being, Sanford will continue investing time into improving Hookr as a reference and refining features according to user feedback. If you use <a href=\"http://hookr.io/\" target=\"_blank\">Hookr.io</a> regularly, feel free to offer your suggestions in the comments and <a href=\"http://twitter.com/hookr_io\" target=\"_blank\">follow the project on Twitter</a> for all the latest updates.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 21 May 2015 20:05:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Matt: William Zinsser Obit\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45066\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"http://ma.tt/2015/05/william-zinsser-obit/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:515:\"<blockquote><p>Mr. Zinsser was a prolific author, editor and teacher, but it was his role as an arbiter of good writing that resonated widely and deeply.</p></blockquote>\n<p>The <a href=\"http://www.nytimes.com/2015/05/13/arts/william-zinsser-author-of-on-writing-well-dies-at-92.html\">New York Times obituary of William Zinsser is touching and fascinating</a>. Clear writing and clear thinking go hand in hand, and Zinnsser&#8217;s work <em>On Writing Well</em> did more than any other to help me hone my mind.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 21 May 2015 04:41:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"WPTavern: Happy Joe Partners with WebDevStudios, SiteGround and Announces Dates for WordPress BootCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44114\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:112:\"http://wptavern.com/happy-joe-partners-with-webdevstudios-siteground-and-announces-dates-for-wordpress-bootcamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6025:\"<p><a href=\"https://www.happyjoe.org/\">Happy Joe</a>, a 501 c3 non-profit organization that helps U.S. veterans with entrepreneurship and employment opportunities <strong>using WordPress,</strong> has announced a new round of sponsorships and dates to upcoming boot camps.</p>\n<p>When I <a href=\"http://wptavern.com/happy-joe-uses-wordpress-to-train-and-help-veterans-find-careers-in-web-technology\">talked to James Dalman</a>, founder of Happy Joe in late 2014, he emphasized how important financial assistance is to the organization, &#8220;We need people to help fund the training and mentoring of our veterans. We have a lot of people who are sharing the story and mission of Happy Joe and we are <strong>VERY</strong> appreciative of that. However, we need sponsorships and donations to make a true difference.&#8221;</p>\n<h2>New Sponsors</h2>\n<p><a href=\"http://webdevstudios.com/\">WebDevStudios</a> is <a href=\"http://webdevstudios.com/2015/05/19/webdevstudios-partners-with-happy-joe/\">partnering with Happy Joe</a> as a <a href=\"http://www.happyjoe.org/partners/\">Hero Partner</a> which is the highest financial contributing level available. Considering the number of military veterans that work at WebDevStudios, the organizations are a perfect match. The agency will also volunteer their time and expertise at upcoming <a href=\"http://www.happyjoe.org/wp-bootcamp/\">WP BootCamps</a> across the United States.</p>\n<p>I asked Brad Williams, founder of WebDevStudios and a military veteran, what it means to be able to help veterans through Happy Joe.</p>\n<blockquote><p>I’m very excited to officially support Happy Joe and their efforts to help Veterans find jobs. As a Veteran myself, I know the struggles trying to find work after leaving the Service, so knowing we are doing something to help ease that process makes me extremely proud.</p></blockquote>\n<p><a href=\"https://www.siteground.com/\">SiteGround,</a> a webhosting company based in Bulgaria, is also <a href=\"http://www.happyjoe.org/corporate-partnerships/\">partnering with Happy Joe</a> and will provide business mentoring, career development, training resources, and work opportunities to military veterans and their families.</p>\n<p>The company is also providing free hosting for three months to all WP BootCamp attendees. Dalman hints that the partnership may one day lead to the first WP BootCamp in Europe.</p>\n<h2>Upcoming WP BootCamps</h2>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/WPBootCamp.png\"><img class=\"size-full wp-image-33462\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/WPBootCamp.png?resize=639%2C200\" alt=\"WordPress Boot Camp\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/vamcmag/3098352208/\">MizGingerSnaps</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a>\n<p><a href=\"http://www.happyjoe.org/wp-bootcamp/\">WP BootCamps</a> are events tailored to the military community and help veterans of the Armed Forces to set up resume style websites on WordPress so that they can be seen as technology relevant. Veterans are also shown how to launch or build a very successful business or career in the WordPress marketplace.</p>\n<p>Dalman has released a schedule of upcoming camps with the first taking place on July 11th and 12th on <a href=\"http://godaddy.com/\">GoDaddy&#8217;s</a> Sunnyvale, CA campus.</p>\n<ul>\n<li>Sunnyvale, CA : July 11 &amp; 12</li>\n<li>Las Vegas, NV : July 25-26</li>\n<li>Seattle, WA : Aug 15 &amp; 16</li>\n<li>San Diego, CA : September 12 &amp; 13</li>\n<li>Austin, TX (WordCamp Austin) : Oct 16</li>\n<li>Fayetteville, North Carolina : Dates TBA</li>\n<li>Norfolk, Virginia : Dates TBA</li>\n<li>Tampa, FL : Dates TBA</li>\n</ul>\n<p>Presentations will include, <em>Discovering Opportunities in WordPress, Starting Off Right with WordPress, Finding the Perfect (and Paying) Clients, Winning An Agency Interview, Skills Companies Pay MORE For</em> and more by the following presenters:</p>\n<ul>\n<li><a href=\"https://twitter.com/perezbox\">Tony Perez</a>, CEO and Founder of <a href=\"https://sucuri.net/\">Sucuri Security</a>, USMC Veteran</li>\n<li><a href=\"https://twitter.com/dremeda\">Dre Armeda</a>, VP of Operations at <a href=\"http://webdevstudios.com/\">WebDevStudios</a> , US Navy Veteran</li>\n<li><a href=\"https://twitter.com/lisasabinwilson\">Lisa Sabin Wilson</a>, COO at <a href=\"http://webdevstudios.com/\">WebDevStudios</a>, Author of <a href=\"http://www.amazon.com/Lisa-Sabin-Wilson/e/B002BLY54I/ref=ntt_athr_dp_pel_1\">WordPress for Dummies</a></li>\n<li><a href=\"https://twitter.com/cdils\">Carrie Dils</a>, CEO at <a href=\"http://www.carriedils.com/\">Carrie Dils</a> and <a href=\"http://officehours.fm/\">Office Hours</a> , Veteran Spouse</li>\n<li><a href=\"https://twitter.com/bobwp\">Bob Dunn</a>, CEO and Founder of <a href=\"http://bobwp.com/\">BobWP</a></li>\n<li><a href=\"https://twitter.com/jamesdalman\">James Dalman</a>, CEO and Founder at <a href=\"http://happyjoe.org/\">Happy Joe</a>, US Army Veteran</li>\n</ul>\n<p>There are a limited amount of tickets available but only those who meet the following criteria are able to attend.</p>\n<ul>\n<li>All Active Duty Service Members</li>\n<li>Military Veterans from any branch of service, regardless of era served</li>\n<li>Military Spouse or Military Caregiver</li>\n<li>Service Dogs</li>\n<li>Non-Military People wanting to work with veterans (limited seating)</li>\n</ul>\n<p>You&#8217;ll need to show proof of military service via an Active Duty Card, Retirement Card, DD Form 214 from you, your spouse, or family member. Tickets have yet to go on sale but Dalman expects this information to be available in the next few weeks.</p>\n<p>As we approach <a href=\"http://en.wikipedia.org/wiki/Memorial_Day\">Memorial Day</a> in the US, take some time to remember and thank those who honorably serve or served in the military. Consider <a href=\"https://www.happyjoe.org/donate/\">supporting an organization</a> like Happy Joe that works year round to give back to veterans.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 21 May 2015 03:52:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: Learn How to Utilize the WP REST API with Rachel Baker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43136\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wptavern.com/learn-how-to-utilize-the-wp-rest-api-with-rachel-baker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5264:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/building.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/building.jpg?resize=1024%2C526\" alt=\"photo credit: shenamt - cc\" class=\"size-full wp-image-23698\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/shenamt/6906784503/\">shenamt</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a>\n<p>One trend at recent WordCamps is that any session on the <a href=\"https://github.com/WP-API/WP-API\" target=\"_blank\">WP REST API</a> will undoubtedly pack the room with attendees eager to learn more about using it. This was certainly the case at WordCamp London 2015 where more than 200 people crammed into a small room to hear <a href=\"http://wptavern.com/jack-lenox-on-building-themes-with-the-wp-rest-api\" target=\"_blank\">Jack Lenox’s presentation on Building Themes with the WP REST API</a>.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/rachel-baker.jpeg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/rachel-baker.jpeg?resize=140%2C140\" alt=\"rachel-baker\" class=\"alignright size-full wp-image-44126\" /></a>If you&#8217;re a developer who is ready to learn more about getting started with the API, you will not want to miss WPSessions&#8217; upcoming free live event. <a href=\"https://twitter.com/rachelbaker\" target=\"_blank\">Rachel Baker</a>, lead engineer at <a href=\"http://thewirecutter.com/\" target=\"_blank\">The Wirecutter</a> and formerly a senior engineer at <a href=\"http://10up.com/\" target=\"_blank\">10up</a>, will be presenting on <a href=\"http://wpsessions.com/sessions/utilizing-the-wp-rest-api/\" target=\"_blank\">Utilizing the WP REST API</a> on Tuesday, May 26, 2015.</p>\n<p>Baker is one of the lead developers on the <a href=\"https://github.com/WP-API/WP-API\" target=\"_blank\">WP-API project</a> and is fully in tune with where it&#8217;s headed, as well as all the changes in the latest <a href=\"http://wptavern.com/wp-rest-api-version-2-0-beta-1-released\" target=\"_blank\">2.0 beta release</a>. The topics she plans to cover will help developers dive in and start extending 2.0.</p>\n<p>&#8220;The content is driven by wanting to dig deeper with a more technical audience from the overview presentations you see at WordCamps and wanting to show off how easy it is to extend our version 2.0,&#8221; Baker said. &#8220;This course is only 30-40 minutes, but if it goes well Brian would like to add more.&#8221;</p>\n<p>She plans to cover the following topics:</p>\n<ul>\n<li>Installing the WP REST API</li>\n<li>Consuming core endpoints</li>\n<li>Creating custom endpoints</li>\n<li>Manipulating and Extending API results</li>\n<li>Preparing for future inclusion in WordPress core</li>\n</ul>\n<p>&#8220;It is targeted at developers who are interested in seeing how they can use and customize the API,&#8221; Baker said. &#8220;Front-end and full-stack developers will see how to add additional fields to the existing endpoint responses. Plugin developers will see a demonstration of how to add their own endpoints. If you are interested in using the WP REST API, or have used version 1.x, you will want to see how version 2.0 works.&#8221;</p>\n<p>Baker&#8217;s session will essentially be a crash course in getting started, covering all the basics and more. While there has been a great deal of excitement surrounding the API and what it means for the future of WordPress, many developers are still getting a grasp on how they can incorporate it into real world projects. John James Jacoby made an interesting observation in his <a href=\"http://jaco.by/2015/05/14/loopconf/\" target=\"_blank\">recap of LoopConf</a>:</p>\n<blockquote><p>So many mentions of the REST API, but not a lot of truly practical usages yet – everyone is building WordPress minus WordPress instead of replacing existing piecemeal AJAX calls or iteratively improving WordPress itself.</p></blockquote>\n<p>Baker is planning to include practical examples in her presentation. One of her main objectives is to help developers get going with the 2.0 beta version so they can offer feedback as they continue to work with it.</p>\n<p>&#8220;I can think of many practical uses, from powering interactions in a plugin like <a href=\"https://wordpress.org/plugins/custom-contact-forms/\" target=\"_blank\">Custom Contact Forms</a> to providing an API for a mobile app like <a href=\"https://storycorps.me/\" target=\"_blank\">StoryCorps.me</a>,&#8221; Baker said.</p>\n<p>&#8220;Our community is hearing that the WP REST API is going to <em>change WordPress</em> and they haven’t seen that happen. I don’t see the WP REST API as changing WordPress. I see the WP REST API as a WordPress feature that makes it easier to interact with your site’s data.&#8221;</p>\n<p>Those who haven&#8217;t been able to attend a session on the API in person have an excellent opportunity to see <a href=\"http://wpsessions.com/sessions/utilizing-the-wp-rest-api/\" target=\"_blank\">Baker&#8217;s WPSessions presentation</a> live for free on Tuesday, May 26th at 3pm EST (<a href=\"http://www.timeanddate.com/worldclock/fixedtime.html?iso=20150526T19&p1=1440&ah=1\" target=\"_blank\">UTC-4</a>). It will also be recorded and available after the event for $9.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 20 May 2015 21:43:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"WPTavern: WordPress Trainer Morten Rand-Hendriksen on Common Pain Points, Roadblocks, and Advice for New Users\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43952\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"http://wptavern.com/wordpress-trainer-morten-rand-hendriksen-on-common-pain-points-roadblocks-and-advice-for-new-users\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9380:\"<p>The WordPress community is filled with resources to learn about WordPress but finding them can be difficult. WordPress is developed around the clock and locating material that keeps pace can also be a challenge.</p>\n<p><a href=\"http://www.lynda.com/\">Lynda.com</a> is an online learning center devoted to teaching topics such as, business, technology, design, and photography. For more than five years, <a href=\"http://mor10.com/\">Morten Rand-Hendriksen</a> has taught and maintained the <i><a href=\"http://www.lynda.com/WordPress-tutorials/WordPress-Essential-Training/154417-2.html\">WordPress Essential Training</a></i> course on Lynda.com. The course has been viewed by more than 100,000 individuals and to celebrate, Lynda.com is making it<a href=\"http://www.lynda.com/articles/wordpress-training-100000-views\"> available for free</a> for one month.</p>\n<p>By maintaining a WordPress training course, Hendriksen is in a unique position to see trends. He&#8217;s also had to keep up with and monitor the vast changes to WordPress that have occurred in the last five years. In the following short interview, Hendriksen describes common pain points users experience with WordPress and shares advice for new users.</p>\n<h2>Short Interview with Hendriksen</h2>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/wordpress-swag.jpg\"><img class=\"size-full wp-image-17801\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/wordpress-swag.jpg?resize=1024%2C441\" alt=\"photo credit: Huasonic - cc\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/huasonic/3008912290/\">Huasonic</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc/2.0/\">cc</a>\n<p><strong>Which aspects of WordPress do users have the most trouble with?</strong></p>\n<p>Based on course feedback and a myriad of emails and questions on Twitter, the hangups people encounter when using WordPress fall into three main categories:</p>\n<ol>\n<li>Installation and migration</li>\n<li>User interface and feature changes</li>\n<li>Theme and plugin inconsistencies</li>\n</ol>\n<h3>Installation and Migration</h3>\n<p>More and more users create local installs to experiment before launching their sites, and they&#8217;re creating quite advanced sites on their local computers. When it comes time to migrate these sites, they often get stuck.</p>\n<p>I think this is partially due to lack of official and understandable documentation about migration, and partially because the general level of technical know-how necessary to build a local install is decreasing. Thanks to tools like MAMP/WAMP, BitNami, and ServerPress, more advanced skills like migration and external hosting become bigger steps up than they were previously.</p>\n<h3><strong>User Interface and Feature Changes</strong></h3>\n<p>As WordPress evolves, user interface changes are fairly common but in most cases, they are left unaddressed in release documentation. Recent examples include the removal of <a href=\"https://wordpress.org/support/topic/major-problems-with-image-editing-in-wp-39?replies=12\">Advanced Image Options</a> and <a href=\"http://wptavern.com/how-to-restore-the-link-title-attribute-removed-in-wordpress-4-2\">Link Title</a> from the editor modals. When changes like these are encountered by existing users, their first response is to assume they are doing something wrong or there is something wrong with their install.</p>\n<p>In my opinion, this is justifiable: In other software and in most other situations in the physical world, when a feature is removed or altered in such a way it is not easily found, this change is clearly addressed.</p>\n<p>In WordPress, it is usually only the large feature changes that are explained while the smaller ones are left for the user to discover on their own. When these features are part of the user&#8217;s workflow, that becomes a problem. This is further exacerbated when meta-conversations in the advanced community go public providing confusing and often contradictory information for new users.</p>\n<h3><strong>Theme and Plugin Inconsistencies</strong></h3>\n<p>The final grouping is the most obvious one. As the theme and plugin landscape becomes more diversified, users often feel overwhelmed and confused about what solutions to choose and how to use them. A search for membership plugins, business themes, or booking calendars returns hundreds if not thousands of widely different solutions that often have little in common.</p>\n<p>Meanwhile, you can find blog posts and lists claiming that pretty much every one of them is the best one and the rest are inferior copies. On top of that, more and more themes and plugins are released as freemium offerings or shells that lead the user to a third-party service.</p>\n<p>All of this comes together to produce a confusing and frustrating user experience that leaves many users feeling like they are not smart enough to use the application or that they made a wrong choice in going with WordPress.</p>\n<p>These are all issues that could be resolved by creating consistent user experiences and by theme and plugin developer communities becoming more mindful of what kind of experiences they provide for the user when they ship freemium solutions or third-party up-sells.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WordPressRoadBlocks.png\"><img class=\"size-full wp-image-44073\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WordPressRoadBlocks.png?resize=650%2C200\" alt=\"WordPress Road Blocks\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/23559988@N05/2931537231\">Haven bridge road block</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-nd/2.0/\">(license)</a>\n<p><strong>Are there more roadblocks to overcome than there were five years ago?</strong></p>\n<p>The answer to this question is both yes and no. WordPress has more roadblocks for the beginner, but for the more experienced user there are also more opportunities. I think one of the major challenges we are facing as a community is that WordPress is becoming too advanced for its core user base. The appeal of click-and-publish services like WIX and SquareSpace is that they do not require an in-depth understanding of the underpinnings of the application for it to work.</p>\n<p>In striving to become a full-fledged CMS for advanced developers and large publications, <span class=\"pullquote alignleft\">WordPress has let itself drift away from its core philosophy of democratizing publishing by adding the very level of complexity it originally aimed to remove.</span> Combined with the theme and plugin issues described above and a lack of modern tools that users expect such as, drag-and-drop design tools and front-end editing, I see new users respond the same way to WordPress today that they did to Drupal five years ago.</p>\n<p>On the plus side, these roadblocks are more like speed bumps than fortified walls. With patience and access to well-crafted and easy to understand training materials, I stand by my claim that anyone, regardless of previous experience, can learn to build a great website with WordPress. What has changed is the level of complexity, both in use and in what you can produce.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/WordPressAdviceForNewUsers.png\"><img class=\"size-full wp-image-44085\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/WordPressAdviceForNewUsers.png?resize=612%2C237\" alt=\"WordPress Advice For New Users\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/99329675@N02/11064947983\">What You Need To Know About Food Poisoning</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-sa/2.0/\">(license)</a>\n<p><strong>What advice do you have for those new to WordPress?</strong></p>\n<p>My number one piece of advice for new and existing WordPress users is to always remember that WordPress is just a tool that makes it easy for you to put content in a database and your visitors to retrieve that content. When learning a new tool as technically advanced as WordPress, it is easy to get so caught up in the tool itself, that you forget what you wanted to do in the first place. Whatever your goals and intentions were when you picked up WordPress for the first time, make sure you remember them and keep working toward them.</p>\n<p>When learning WordPress, whether you are teaching yourself, learning from books or videos, or going to class, remember that every person in the community, even <a href=\"http://nacin.com/\">Andrew Nacin</a>, was at some point in time where you are now: <strong>Just trying to figure it all out</strong>. While every person&#8217;s path to learning is different, they all have one thing in common: <strong>They all learn from each other.</strong></p>\n<p>So reach out online, in person, through Twitter, Facebook groups, Meetups, WordCamps, and beyond, and find like-minded people who want to learn with you or help you on your way. When you meet someone who is just starting out, help them get their footing and invite them into the community.</p>\n<p>Finally, remember that WordPress is not an island. The web community is a rich ecosystem with many differing solutions based on the same core technology. Learning how the web works gives you the power to use WordPress to move beyond its borders and it&#8217;s beyond those borders where true magic is found.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 20 May 2015 19:21:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: WordPress.org is Testing International Theme and Plugin Directories\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44068\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://wptavern.com/wordpress-org-is-testing-international-theme-and-plugin-directories\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3751:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/flags.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/flags.jpg?resize=1020%2C500\" alt=\"flags\" class=\"aligncenter size-full wp-image-16697\" /></a></p>\n<p>WordPress.org is making strides towards fully localizing the project&#8217;s official theme and plugin directories. Dion Hulse <a href=\"https://make.wordpress.org/polyglots/2015/05/20/hi-everyone-as-some-of-you-are-aware/\" target=\"_blank\">posted</a> this morning that he has enabled localized theme directories for all Rosetta sites. For example, the Romanian themes directory is available at: <a href=\"https://ro.wordpress.org/themes/\" target=\"_blank\">ro.wordpress.org/themes/</a>.</p>\n<p>Theme filters, directory sub-navigation, info and download buttons, and other aspects of the details page are all translated. Description and titles are not yet translated, but Hulse says the plan is to add those in the near future.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/romanian-themes.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/romanian-themes.png?resize=1025%2C677\" alt=\"romanian-themes\" class=\"aligncenter size-full wp-image-44080\" /></a></p>\n<p>Those who are interested in helping translate the interface for the localized theme directories are encouraged to visit the <a href=\"https://translate.wordpress.org/projects/meta/themes\" target=\"_blank\">meta translation project page</a>. The process for contributing is the same that is used with WordPress&#8217; other Rosetta translations.</p>\n<p>Localized plugin directories are being actively tested at /plugins/ and the sites are also <a href=\"https://translate.wordpress.org/projects/meta/plugins\" target=\"_blank\">available for contributions from translators</a>. Check out <a href=\"https://ro.wordpress.org/plugins/\" target=\"_blank\">ro.wordpress.org/plugins/</a> to see the Romanian plugin directory as an example.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/romanian-plugins.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/romanian-plugins.png?resize=1025%2C685\" alt=\"romanian-plugins\" class=\"aligncenter size-full wp-image-44079\" /></a></p>\n<p>As the localized theme and plugin directories are new, there are still a few missing pieces and likely a good number of bugs that will need to be resolved. You can help by reporting them on Hulse&#8217;s <a href=\"https://make.wordpress.org/polyglots/2015/05/20/hi-everyone-as-some-of-you-are-aware/\" target=\"_blank\">announcement</a> on the make.wordperss.org/polyglots blog or by opening a ticket on <a href=\"https://meta.trac.wordpress.org/newticket?component=Theme%20Directory\" target=\"_blank\">meta.trac</a>.</p>\n<p>In <a href=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\" target=\"_blank\">Matt Mullenweg&#8217;s 2014 State of the Word address</a>, he highlighted the importance of internationalization improvements for connecting and growing the global WordPress community. Localized directories for plugins and themes on WordPress.org are part of this larger effort and make the project&#8217;s website easier to navigate for non-English speaking users.</p>\n<p>In the future, translation of WordPress&#8217; development handbooks, the codex, and other documentation could also play a large part towards inspiring international developers to make more extensions, products for the marketplace, and contributions back to the project. Growing WordPress&#8217; market share outside of English-speaking countries will be facilitated by having all basic WordPress resources available in other languages.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 20 May 2015 18:37:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"Post Status: Automattic has acquired WooThemes, makers of WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=12682\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://poststatus.com/automattic-acquired-woocommerce-woothemes/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:21325:\"<p>This acquisition is an important milestone for <a href=\"https://automattic.com\">Automattic</a>, validation for the bootstrapped <a href=\"http://woothemes.com\">WooThemes</a>, and will be hugely impactful on the WordPress economy as a whole.</p>\n<h3>The history of WooThemes and WooCommerce</h3>\n<p>WooThemes <a href=\"http://www.woothemes.com/about/\">was started</a> in 2008 as one of the first commercial WordPress theme shops. It quickly became popular and paved the way for hundreds of shops to follow in their footsteps.</p>\n<p>With the leadership of Adii Pienaar and co-founders Mark Forrester and Magnus Jepson, WooThemes did a ton of interesting things over the years, and dominated the market with a handful of other shops. They <a href=\"http://www.woothemes.com/2011/09/woocommerce-has-arrived/\">launched WooCommerce in September 2011</a>, in the middle of the commercial theme heyday.</p>\n<p>WooCommerce&#8217;s origins are a hot mess and a long story. WooThemes worked for a long time to develop, with partners, their own eCommerce solution. After numerous failed attempts and false starts, they hired <a href=\"http://mikejolley.com/\">Mike Jolley</a> and <a href=\"http://jameskoster.co.uk/\">Jay Koster</a> full time, and forked JigoShop after acquisition negotiations broke down. Jigoshop is a product that Mike and Jay built as freelancers for JigoWatt, but has since been sold off to another consulting company.</p>\n<p>Mike and Jay were, and are, the heart of that eCommerce plugin &#8212; the one we know today as WooCommerce. Under their stewardship, and dozens of other full time and part time contributors &#8212; mixed in with outstanding marketing, perfect timing, and a lack of modern competition &#8212; WooCommerce took the WordPress world by storm.</p>\n<p>They pioneered the extension model for paid add-ons. They put all doubters to rest over and over again. They made mistakes. But they kept at it, kept working, kept making it better. And soon enough, they took the eCommerce world by storm too.</p>\n<p>In a short period of four years, WooCommerce has gone from a struggling concept, to a fork, to a remarkable open source commercial software success story.</p>\n<p>I&#8217;ve had the privilege of following WooThemes since around the time they started, and have gotten to know the project and their team even more closely since the very early days of WooCommerce&#8217;s launch. In this post, I bring my analysis of the company based on those years of my watching them grow and interacting with them, and hope to share what the acquisition by Automattic may mean for the future.</p>\n<h3>Why WooCommerce is attractive</h3>\n<p>On the surface, it may seem to many that Automattic was the obvious choice to acquire WooCommerce.</p>\n<p>After all, they need eCommerce support for <a href=\"https://wordpress.com\">WordPress.com</a>. As Matt Mullenweg shared with me, they, &#8220;have a ton of demand,&#8221; for eCommerce from WordPress.com users. Acquiring WooCommerce gives Automattic access to the largest single group of eCommerce stores in the world.</p>\n<h4>One of many options</h4>\n<p>But Mark Forrester and Magnus Jepson &#8212; co-founders and owners of WooThemes &#8212; could have gone many other routes.</p>\n<p>WooCommerce is big enough, and has enough brand power, to have attracted significant venture capital investments, as well as suitors from well outside the WordPress space &#8212; suitors like MasterCard, eBay/Paypal, Amazon, or Yahoo.</p>\n<p>There are 1.2+ million active installs of WooCommerce. They have a nearly <a href=\"http://trends.builtwith.com/shop\">20% eCommerce marketshare</a> of the top one million websites, and over 24% eCommerce marketshare of all websites.</p>\n<p><img class=\"aligncenter size-full wp-image-12685\" src=\"https://poststatus.com/wp-content/uploads/2015/05/woocommerce-builtwith-top-million.png\" alt=\"woocommerce-builtwith-top-million\" width=\"631\" height=\"499\" /></p>\n<p>The plugin has had rapid growth over its short four year existence, making it a ripe target for the right buyer.</p>\n<h4>A natural fit</h4>\n<p>WooCommerce&#8217;s popularity has largely been due to the fact that it&#8217;s available on WordPress. WordPress makes WooCommerce an attractive choice for websites that need bolt-on eCommerce.</p>\n<p>One of WooCommerce&#8217;s greatest opportunities for growth is for customers that are eCommerce first, other-parts-of-the-website second. It&#8217;s gaining ground quickly as both WooCommerce and WordPress gain further respect for usage on websites of all sizes and scopes.</p>\n<p>All of these factors make WooCommerce an attractive choice for Automattic. Automattic&#8217;s team knows, understands, and contributes greatly to the WordPress project. A shared reliance on WordPress core makes a WooCommerce and WordPress.com integration simpler. And 55 talented, eCommerce focused employees makes for an inviting addition to Automattic&#8217;s relatively small workforce.</p>\n<h3>18% growth in Automattic employees</h3>\n<p>Bringing 55 new people on at once swells Automattic&#8217;s ranks by around 18%, bringing them to over 360 people. Recruiting is not easy. This gain of talented people, in a single fell swoop, should not be underestimated.</p>\n<p>But there may be some challenges integrating the two teams. This is, by far, the most people brought under the Automattic umbrella in a single acquisition.</p>\n<h4>Team integration</h4>\n<p>WooThemes&#8217; theme division and team members will join Automattic&#8217;s theme team, and it&#8217;s my understanding that WooThemes support will join the Happiness team at Automattic as well.</p>\n<p>WooThemes has long battled a significant support burden, even before WooCommerce came along. With the demands of supporting eCommerce software that can conflict with nearly infinite plugins, themes, and hosting environments makes support expensive. As long as WooCommerce offers paid self-hosted products, this support will need to be managed.</p>\n<p>WooCommerce will certainly benefit from the developer resources at Automattic. Matt told me, &#8220;lots of folks at Automattic [are] interested in working on eCommerce.&#8221; From code audits, to fresh eyes, to more seasoned developers, Automattic&#8217;s team will be able to have an immediate impact on the WooCommerce product line.</p>\n<h4>Merging management</h4>\n<p>One aspect I don&#8217;t know much about yet is in regard to WooThemes&#8217; middle management. Mark and Magnus own the company, but there is a four person leadership team beyond them:</p>\n<ul>\n<li>Joel Bronkowski, Chief Business Development Officer</li>\n<li>Warren Holmes, Chief Marketing Officer</li>\n<li>Matty Cohen, Chief Product Officer</li>\n<li>Michael Krapf, Chief Happiness Officer</li>\n</ul>\n<p>Furthermore, there are product leads for WooCommerce, Sensei, themes, and other elements of WooThemes&#8217; business. As a company, WooThemes is probably as hierarchical as Automattic with six times fewer people.</p>\n<p>I anticipate some managers may merge into other Automattic teams under new roles, or play a part in sub-teams of sorts, which is (I believe) how Jetpack works now that it&#8217;s such a big team.</p>\n<h4>Already distributed</h4>\n<p>WooThemes is already distributed across five continents and perfectly accustomed to remote work. While they have an office (WooHQ) in Cape Town, South Africa, it&#8217;s a &#8220;come as you please&#8221; environment, similar to Automattic&#8217;s San Francisco space.</p>\n<p>Joining Automattic will be a much cleaner culture fit than other potential buyers would have been. Some team members will naturally leave or integrate to other roles, but the overall gain is a huge win for both organizations.</p>\n<h3>The likely end of &#8220;WooThemes&#8221; as a name</h3>\n<p>WooThemes is a staple brand of the WordPress ecosystem. They&#8217;ve been around since 2008 and probably have the biggest single brand presence after WordPress itself; I&#8217;d argue the name is more well-known than Automattic, or even perhaps ThemeForest.</p>\n<p>For all practical purposes, I believe the name WooThemes will be retired.</p>\n<p>WooThemes has previously considered a name change to reflect the change in their business focus, but have not done it. Under the umbrella of Automattic and WordPress.com, there is really no need to carry on the WooThemes brand.</p>\n<p>I&#8217;m told the decision to change the name of the website hasn&#8217;t been officially made yet, but it makes no sense to me to keep WooThemes. I&#8217;d expect the website we see at WooThemes.com to before long be simply <a href=\"http://woocommerce.com\">WooCommerce.com</a>.</p>\n<p>They better keep Hiro, the Woo Ninja though. I love that little guy.</p>\n<h3>The WooCommerce business model</h3>\n<p>The WooCommerce business model is built largely on paid extensions that offer additional eCommerce functionality, updates, and support.</p>\n<h4>The current extension model</h4>\n<p>WooThemes lists a whopping 346 paid and free extensions on their website, about 150 of which link to third party sites. The remaining 200 or so extensions are either developed in house or in partnership with third party developers, but sold on WooThemes&#8217; website. There are also dozens, if not hundreds more, distributed plugins by other vendors that are not listed.</p>\n<p>Companies like <a href=\"https://www.skyverge.com/\">SkyVerge</a> and <a href=\"http://prospress.com/\">Prospress</a> have built their businesses on WooCommerce extension development. If the model were to change drastically, it could have a great deal of impact on them and similar companies or solo developers.</p>\n<p>Third party developers have been told that life will be business as usual. In an email to strategic partners, Joel Bronkowski said, &#8220;There are no plans to mess with the magic sauce strategy that has brought us this far.&#8221;</p>\n<h4>A conflict of ideology</h4>\n<p>However, the model of paid plugins is also counter to Matt Mullenweg&#8217;s often stated beliefs for what commercialization in the WordPress plugin space should look like.</p>\n<p>I asked him to explain how his mindset has changed in regard to paid plugins that charge for support and updates. Paid Automattic plugins, like Akismet and VaultPress, are based on SaaS models.</p>\n<p>He says that his view has not changed. He told me that one goal with WooCommerce will be to determine, &#8220;what services provide the most value to people over a long period of time.&#8221; He also noted that such a question is due to the fact that many WordPress product sales are one-time.</p>\n<p>I found his sentiment curious. He didn&#8217;t directly answer the question about paid plugins, which isn&#8217;t too surprising. It&#8217;s impossible to imagine Automattic doing away with paid extensions in the short term, but there are serious threats to third party developers in the longer term, I believe.</p>\n<h4>Expansion of partnerships with larger corporations</h4>\n<p>WooCommerce has spent a lot of time doing business development over the last couple of years. Last summer, their leadership team <a href=\"http://www.woothemes.com/2014/07/woocommerce-journey-irce-2014/\">went to Chicago</a> for a big eCommerce conference and had a whole new world opened up to them.</p>\n<p>Joel told me they, &#8220;still have a lot to figure out in terms of the road ahead, but [we are] incredibly excited about what this means for us in terms of product development, partner opportunities and for WordPress powered eCommerce.&#8221;</p>\n<p>Under the wing of Automattic and in the future WordPress.com, I think WooCommerce will be able to further leverage their position in the eCommerce market with big payment companies and other potential corporate entities.</p>\n<h4>Potential changes to the business model</h4>\n<p>I would guess that a gradual change in business model will occur over the next several years, especially in regard to extensions. <span class=\"pullquote alignright\">WooCommerce has a dismal 17% renewal rate for extension purchases.</span> This is a number that needs to improve, or something should change.</p>\n<p>It may make sense &#8212; and I&#8217;m shocked I&#8217;m saying it &#8212; to make WooCommerce more like Jetpack.</p>\n<p>If I were at Automattic, I would encourage the two teams to brainstorm and evolve together. I think a model where a credit card is connected to WordPress.com, and extensions (free and paid) can be easily activated from within the admin makes sense. It would require a lot of change to existing UIs and development infrastructure, but it could also drastically improve what is often a convoluted method for site management with so many add-ons being independently managed.</p>\n<p>If we take the potential even further: imagine the VaultPress model of instant syncing, data tracking, and backups being heavily integrated into eCommerce stores. Such a system could be part of a monthly fee.</p>\n<p>Extensions also don&#8217;t have to be piecemeal, or the &#8220;nickel and dime&#8221; method. Automattic could make WooCommerce a tiered payment plan, where certain levels unlock particular functionality. Or they could buyout all third party paid extensions they care about and make the entire product free or part of a single package.</p>\n<p>The point is that Automattic purchasing WooCommerce gives them an incredible amount of flexibility in terms of how to move forward. WooCommerce store owners should be prepared for a lot of potential change.</p>\n<p>As a bootstrapped company, WooThemes had to turn a profit. Automattic has to make the company more valuable, but does not need to care about cash day to day. Their stated goal is to make products people want to use. <span class=\"pullquote alignright\">A very small number of people at Automattic really consider profits and losses regularly. That mindset, when applied to WooCommerce, could bring about significant change indeed.</span></p>\n<h4>Bringing WooCommerce to WordPress.com</h4>\n<p>An important concern over the next year or two will be how to bring WooCommerce to WordPress.com. There is little question that it will happen.</p>\n<p>Matt Mullenweg highlighted the demand from the general WordPress.com userbase, and hosted WooCommerce would be a great answer to Squarespace&#8217;s eCommerce add-on, and the likes of Shopify and BigCartel.</p>\n<p>Furthermore, I&#8217;m sure a number of WordPress.com VIP customers will be clamoring for WooCommerce. Automattic&#8217;s Vice President of Platform Services, Paul Maiorana, said, &#8220;VIP tends to follow the same trends as the broader WP community. Initially blogs, then CMS, now everything.&#8221; He is excited about being able to offer a more catered eCommerce experience &#8220;in house to better service those customers.&#8221;</p>\n<p>A hosted version of WooCommerce will be a very compelling upsell for WordPress.com if they are able to pull it off well. This too, will not be easy. But they are starting with a heck of a head start, given the WooCommerce brand name, team, and existing plugin infrastructure.</p>\n<h3>What the acquisition means for other WooThemes products</h3>\n<p>WooThemes makes more than WooCommerce, however nearly all of their products today at least integrate with WooCommerce.</p>\n<p>WooThemes&#8217; themes will be integrated into WordPress.com&#8217;s theme offering. Eleven themes are <a href=\"https://theme.wordpress.com/?theme_shop=woothemes\">already listed there</a> from an existing partnership that goes back to early 2011.</p>\n<p>The <a href=\"http://www.woothemes.com/products/sensei/\">Sensei courseware plugin</a> will also continue to be developed and maintained. Regarding Sensei, Matt Mullenweg said, &#8220;their team is passionate about it, which is kind of the criteria for what Automattic works on.&#8221;</p>\n<p>There is a lot of potential in the course space, and I actually think this could be a nice win for Automattic in this acquisition, especially if Sensei gets additional resources and attention.</p>\n<p>WooThemes has other active free plugins that I doubt will change much. WooSlider is their only other paid plugin, but I don&#8217;t think it makes up a considerable amount of revenue.</p>\n<p>I wouldn&#8217;t be surprised if both WooSlider and Sensei core become free plugins.</p>\n<h3>WooThemes&#8217; revenue and the acquisition price</h3>\n<p>Everyone wants to know: how much was WooThemes making, and how much was the acquisition for?</p>\n<p><a href=\"http://recode.net/2015/05/19/wordpress-parent-automattic-buys-woocommerce-a-shopping-tool-for-web-publishers/\">Re/code&#8217;s Peter Kafka</a> has sources that say the acquisition was for, &#8220;more than $30 million in cash and stock.&#8221; I believe this to be a reasonable amount and I don&#8217;t think he&#8217;d make the claim without some confidence.</p>\n<p>I don&#8217;t know what the terms of the deal were. I&#8217;ve tried all day to find out. The best I can do is tell you what I know, what I think I know, and guess right along with everyone else. Sounds fun, right?</p>\n<p>I&#8217;m quite confident that WooThemes&#8217; revenues were around $9-$10 million in 2013. I also know that they have had positive trajectory month over month growth for some time, and I have reason to believe one of their more recent record months well exceeded $1 million in revenue.</p>\n<p>If we extrapolate the 2013 numbers with 10-20% growth, we can presume that their gross revenues are somewhere in the neighborhood of $15 million annually.</p>\n<p>Based on some feedback from people I trust, a 2x multiple of expected 2015 revenues isn&#8217;t out of the question. In typical proprietary software and product situations, that would be a low multiplier.</p>\n<p>But in this case, WooThemes&#8217; sends a lot of money directly to third party developers, and spends a great deal of money on development and support. Furthermore, WooCommerce isn&#8217;t proprietary, it&#8217;s open source; which while I love and advocate for it, it simply would be difficult to valuate the same as proprietary software.</p>\n<p>Additionally, I could be naive, but in the case of Automattic I&#8217;d rather more stock than cash. They are destined for an IPO (someday) that will likely put them well beyond their latest <a href=\"http://ma.tt/2014/05/new-funding-for-automattic/\">$1.16 billion valuation</a>, and today&#8217;s stock could be worth many times what it is now in the years to come.</p>\n<p>Lastly, I don&#8217;t think Re/code would run a number they pulled out of thin air. I think they got that from somewhere &#8212; perhaps a VC source.</p>\n<h3>Good for both sides, but not without consequences</h3>\n<p>I firmly believe WooThemes could&#8217;ve continued to grow WooCommerce to be worth $100 million or more. But it would&#8217;ve likely been a long and challenging road.</p>\n<p>Under the Automattic umbrella, they have a great shot to continue making an awesome eCommerce product without some of their current burdens and with some outstanding new resources.</p>\n<p>Meanwhile, especially if the $30-$35 million price is correct, I think Automattic got a steal. It&#8217;s a brilliant way into a huge market with a major player.</p>\n<p>There are potential downsides to this purchase. For one, it makes Automattic further feel like a vacuum that inevitably sucks up the best talent, agencies, and products once they showcase their potential for success.</p>\n<p>WooThemes was the bastion all other bootstrapped WordPress products stood behind. Knowing it&#8217;s possible to do something as big as WooThemes was doing, without funding and starting from nothing, is awesome.</p>\n<p>Seeing them snatched up by Automattic around the time they&#8217;ve become nearly ubiquitous with the term &#8220;WordPress eCommerce&#8221; is kind of a bummer. <span class=\"pullquote alignright\">It&#8217;s like we now have to start over again to see what WordPress centric product company can grow big enough to stand beside Automattic, not under it.</span></p>\n<p>I also have some fear that if Automattic rocks the boat too much with WooCommerce it will cause some big inroads WordPress has made in self-hosted eCommerce to be lost.</p>\n<p>My concerns are relatively minor. Would I have loved to see WooThemes continue to grow and dominate eCommerce alone? Yes. Am I excited by what this deal makes possible? Yes. Am I a little concerned what it will do to the WordPress economy? Yes.</p>\n<p>We must all weigh the pros and cons of any decision. For Mark, Magnus, and the WooThemes team, this is a move that is good for them during this time, and will likely be good for the company they started seven years ago.</p>\n<p>For Automattic, this is a heck of a way to round out their first decade in business. It&#8217;ll be really interesting to see what the next decade holds in store, but I bet Automattic will look a lot different then, like they do now compared to 2005.</p>\n<p>Congratulations to both teams. You can read the announcements on <a href=\"http://ma.tt/2015/05/woomattic/\">Matt&#8217;s blog</a> and <a href=\"http://www.woothemes.com/2015/05/woothemes-joins-automattic/\">WooThemes&#8217; blog</a>.</p>\n<p>Photo credit: <a href=\"https://matt.wordpress.com/2015/05/19/woo-announcement-pics/\">Matt Mullenweg</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 20 May 2015 07:15:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WPTavern: Automattic Acquires WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44023\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wptavern.com/automattic-acquires-woocommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6368:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/woomattic.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/woomattic.jpg?resize=1025%2C463\" alt=\"photo credit: Ma.tt - \" /></a>photo credit: <a href=\"https://matt.wordpress.com/2015/05/19/woo-announcement-pics/\">Ma.tt &#8211; &#8220;A Celebratory Toast</a>\n<p>Automattic CEO Matt Mullenweg announced today that the company has <a href=\"http://ma.tt/2015/05/woomattic/\" target=\"_blank\">acquired WooCommerce</a>, WordPress&#8217; most popular e-commerce platform. The <a href=\"http://www.woothemes.com/woocommerce/\" target=\"_blank\">plugin</a> recently passed seven million downloads and stats from BuiltWith show that <a href=\"http://wptavern.com/woocommerce-dominates-global-e-commerce-platforms-passes-7-million-downloads\" target=\"_blank\">WooCommerce is dominating global e-commerce platforms</a>, powering roughly 30% of all online stores.</p>\n<p>This is Automattic&#8217;s largest acquisition to date, bringing 55 new employees into the company from 16 countries for a total of 370 Automatticians. Mullenweg confirmed that the acquisition includes <a href=\"http://www.woothemes.com/\" target=\"_blank\">Woo</a>, <a href=\"http://www.woothemes.com/products/sensei/\" target=\"_blank\">Sensei</a>, and all of the other plugins and themes.</p>\n<p>Given WooCommerce&#8217;s extensive adoption on the web, Automattic will not be re-branding the newly acquired products. WooThemes and WooCommerce will continue to be sold via their dedicated websites.</p>\n<p>&#8220;We’re planning on retaining (and growing) the WooCommerce brand,&#8221; Mullenweg told the Tavern. &#8220;The plan is to keep what has been working going.&#8221;</p>\n<p>Mullenweg has spoken frequently over the years about growing Automattic&#8217;s reach into global commerce, but few could have predicted that the company would acquire Woo as opposed to building its own in-house commerce platform.</p>\n<p>&#8220;They have a full team that goes to bed every night and wakes up in the morning thinking about commerce; it’s core to their DNA,&#8221; Mullenweg said. &#8220;That’s better than starting it in-house. Also they have a ton of adoption already.&#8221;</p>\n<p>In April, WooThemes co-founder Magnus Jepson told the Tavern that <a href=\"http://wptavern.com/woocommerce-dominates-global-e-commerce-platforms-passes-7-million-downloads\" target=\"_blank\">WooCommerce accounts for over 85% of overall sales</a> and processes &#8220;several million dollars per year.” Jepson also confirmed that WooCommerce&#8217;s revenue &#8220;has been climbing steadily over the past few years, and we are regularly breaking monthly revenue records.”</p>\n<p>Automattic is not releasing the financial details of the acquisition, but <a href=\"http://recode.net/2015/05/19/wordpress-parent-automattic-buys-woocommerce-a-shopping-tool-for-web-publishers/\" target=\"_blank\">Re/code speculates</a> that it was in the range of $30 million:</p>\n<blockquote><p>Sources say Automattic will spend more than $30 million in cash and stock to buy the 55-person company. Automattic CEO Matt Mullenweg wouldn’t comment on the price but said the acquisition was the largest his company had made, &#8216;by about 6x.&#8217;</p></blockquote>\n<p>In addition to growing the current WooCommerce customer base, Automattic is looking to use the platform to add more selling options for WordPress.com customers, while retaining its existing e-commerce partnerships.</p>\n<p>&#8220;Partnerships will remain in place on WP.com, but long-term we’d like to offer Woo as an option there as well,&#8221; Mullenweg said.</p>\n<p>When asked about plans to integrate WooCommerce into Jetpack, he said, &#8220;Jetpack could definitely complement WooCommerce (and WooThemes), but not the other way around.&#8221;</p>\n<p>WooThemes founders never imagined that WooCommerce would rise to the level of popularity that it has, ultimately bringing them into the Automattic family. Co-founder Mark Forrester <a href=\"http://www.woothemes.com/2015/05/woothemes-joins-automattic/\" target=\"_blank\">writes</a>:</p>\n<blockquote><p>In 2008, as three strangers in three countries, we set out on a quest to pioneer WordPress commercial theming, never dreaming of the rocket-propelled voyage into the self-hosted eCommerce unknown that lay ahead. It’s been an incredible ride, backed by a unique community, and here we find ourselves powering over 24% of online stores with our flagship product, WooCommerce.</p></blockquote>\n<p>The acquisition affects a whole fleet of third-party designers and developers who create products for WooCommerce. They will likely have more opportunities and sales ahead of them with the power of Automattic behind the core plugin. Mullenweg confirmed that the next WooConf, scheduled to take place in Austin in November, will continue on as planned. Those who are heavily involved in the WooCommerce ecosystem will still be able to connect and build for the platform as they have done previously.</p>\n<h3>Democratizing Selling with WooCommerce</h3>\n<p>With Automattic now at the helm of the most dominant e-commerce platform on the web, it will be interesting to see if the company can make selling online just as simple as it has made publishing online. WordPress.com&#8217;s tremendous success can be partially attributed to the company&#8217;s <a href=\"http://wptavern.com/matt-mullenweg-on-ensuring-the-future-of-wordpress\" target=\"_blank\">commitment to democratizing publishing</a>.</p>\n<p><strong>&#8220;I do believe that the web needs an open, independent and easy-to-use commerce platform that you can run yourself on your own website,&#8221;</strong> Mullenweg said in his <a href=\"https://www.youtube.com/watch?v=xJOfTB8-daA\" target=\"_blank\">video announcement</a>, the first video ever to be published to Automattic&#8217;s YouTube account.</p>\n<p>Publishing products and selling them on the web is arguably a more complex endeavor than simple publishing, especially when you factor in location, tax, payment gateways, and everything needed to process transactions. The average non-developer has no concept of what it takes to set up a blog, let alone an online store. But if Automattic can play a part in democratizing the ability for regular folks to sell products online, it has the potential to globally transform e-commerce.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 19 May 2015 21:15:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Matt: Woo &amp; Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45068\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://ma.tt/2015/05/woomattic/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4529:\"<p>For years, we&#8217;ve been working on democratizing publishing, and today more people have independent sites built on open source software than ever before in the history of the web. Now, we want to make it easy for anyone to sell online independently, without being locked into closed, centralized services &#8212; to enable freedom of livelihood along with freedom of expression.</p>\n<p>It’s not a new idea: at a WordCamp a few years ago, someone stood up and asked me when we were going to make it as easy to create an online store as we’d made it to create a blog. Everyone applauded; there’s long been demand for better ecommerce functionality, but it’s been outside the scope of what Automattic could do well.</p>\n<p>That changes today &#8212; drum roll &#8212; as <a href=\"http://woocommerce.com/\">WooCommerce</a> joins the <a href=\"http://automattic.com/\">Automattic</a> team to make it easier for people to sell online. <a href=\"http://www.woothemes.com/2015/05/woothemes-joins-automattic/\">Along with Woo’s announcement</a>, here&#8217;s a short video explaining more:</p>\n<p><span class=\"embed-youtube\"></span></p>\n<p>In the past few years, WooCommerce really distinguished itself in its field. Just like WordPress as a whole, it developed a robust community around its software, and its products meet the needs of hundreds of thousands of people around the world.</p>\n<p>Woo is also a team after Automattic’s own distributed heart: WooCommerce is created and supported by 55 people in 16 countries. Added to Automattic&#8217;s 325 people in 37 countries, that’s a combined 380-person company across 42 countries &#8212; the sun never sets.* I can&#8217;t wait to meet all my new colleagues.</p>\n<p>Just like us, the vast majority of WooCommerce&#8217;s work is also open source and 100% GPL. And just like WordPress, you&#8217;ll find WooCommerce meetups popping up everywhere, from Los Angeles to London, and its global and community-focused work together to make the users’ experiences the best they can be.</p>\n<p><a href=\"http://trends.builtwith.com/shop\"><img class=\"alignright  wp-image-45072\" src=\"http://i0.wp.com/ma.tt/files/2015/05/ecomm-trends.png?resize=447%2C294\" alt=\"ecomm-trends\" /></a> The stats are impressive: the <a href=\"https://wordpress.org/plugins/woocommerce/\">WooCommerce plugin has over 7.5 million downloads and a million+ active installs</a>; BuiltWith&#8217;s <a href=\"http://trends.builtwith.com/shop\">survey of ecommerce platforms shows Woo passing up Magento in the top million</a>, with about triple the number of total sites. Even a conservative estimate that WooCommerce powers 650,000 storefronts means they’re enabling a huge number of independent sellers. They’ve added a tremendous amount to the WordPress ecosystem (alongside everyone else working in this area).</p>\n<p>WordPress currently <a href=\"http://w3techs.com/technologies/history_overview/content_management/all/y\">powers about 23% of the web</a>. As we work our way toward 51%, WooCommerce joining Automattic is a big step opening WordPress up to an entirely new audience. I can’t wait to see how much more we can build together.</p>\n<p>Automattic <em>turns ten</em> next month: another amazing milestone I couldn&#8217;t have imagined a decade ago. Today&#8217;s news is just the first of a number of announcements we have planned for the remainder of the year, so please stay tuned! There&#8217;s still so much work to do.</p>\n<p>* Want to work with us? <a href=\"http://automattic.com/work-with-us/\">We’re hiring</a>. Bonus points if you live in Antarctica, the only continent we don’t have covered.</p>\n<p>As I said in the video, please drop any questions you might have in the comments and I&#8217;ll answer them as soon as I can. Also check out the posts from <a href=\"http://www.markforrester.co.za/2015/05/19/woothemes-has-a-new-home/\">Mark</a> and <a href=\"http://jepson.no/we-are-joining-automattic/\">Magnus</a>.</p>\n<p>Read more: <a href=\"https://href.li/?http://mashable.com/2015/05/19/automattic-woocommerce-acquisition/\">Mashable</a>, <a href=\"http://recode.net/2015/05/19/wordpress-parent-automattic-buys-woocommerce-a-shopping-tool-for-web-publishers/\">Recode</a>, <a href=\"https://href.li/?http://techcrunch.com/2015/05/19/automattic-buys-woocommerce-the-popular-plugin-for-turning-wordpress-into-a-store/\">Techcrunch</a>, <a href=\"http://venturebeat.com/2015/05/19/automattic-buys-woocommerce-to-get-into-ecommerce-its-largest-acquisition-to-date/\">Venturebeat</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 19 May 2015 18:59:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: WordPress Cape Town to Host 2nd Annual Charity Hackathon in June\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43986\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wptavern.com/wordpress-cape-town-to-host-2nd-annual-charity-hackathon-in-june\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3696:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wordpress-cape-town-charity-hackathon-2015.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wordpress-cape-town-charity-hackathon-2015.jpg?resize=1025%2C529\" alt=\"wordpress-cape-town-charity-hackathon-2015\" class=\"aligncenter size-full wp-image-44002\" /></a></p>\n<p>Last August, the <a href=\"http://www.wpcapetown.co.za/\" target=\"_blank\">WordPress Cape Town</a> meetup group experimented with <a href=\"http://wptavern.com/wordpress-cape-town-to-host-charity-hackathon-in-august\" target=\"_blank\">hosting its first charity hackathon</a> to benefit local charities. The <strong>do_action( ‘wordpress-charity-hackathon’ );</strong> event was so successful in 2014 that organizers were inspired to make it an annual event. The <a href=\"http://www.wpcapetown.co.za/event/do_action-wordpress-charity-hackathon-2015/\" target=\"_blank\">2015 hackathon</a> is scheduled for June 20th from 9:00 AM &#8211; 5:00 PM.</p>\n<p>&#8220;With a team of nearly 50 volunteers from the community, we built brand new websites for nine different charitable organizations and we will be doing the same again this year,&#8221; said Hugh Lashbrooke, an organizer for the event.</p>\n<p>The concept will be the same as the previous year &#8211; volunteers will build sites for nine Capetown-based charities, giving each their own unique online presence by the end of the day.</p>\n<p>A few examples of websites built by the volunteers last year include:</p>\n<ul>\n<li><a href=\"http://feedinginaction.co.za/\" target=\"_blank\">Feeding in Action</a></li>\n<li><a href=\"http://www.stlukes.co.za/\" target=\"_blank\">St. Luke’s Hospice</a></li>\n<li><a href=\"http://www.equinoxtrust.org/\" target=\"_blank\">Equinox Trust</a></li>\n<li><a href=\"http://www.carecareers.co.za/\" target=\"_blank\">Care Career Connection</a></li>\n<li><a href=\"http://www.theup.org.za/\" target=\"_blank\">The UPliftment Porgramme</a></li>\n</ul>\n<p>&#8220;The charities this year are equally as deserving and spread across the whole spectrum of society again,&#8221; Lashbrooke said. The 2015 charities list includes organizations such as the Academy for Adults with Autism, FoodBank South Africa, and the Down Syndrome Inclusive Education Foundation NPC.</p>\n<p>Sponsors this year include <a href=\"http://hetzner.co.za/\" target=\"_blank\">Hetzner</a>, <a href=\"http://oboxthemes.com/\" target=\"_blank\">Obox</a>, and <a href=\"http://www.woothemes.com/\" target=\"_blank\">WooThemes</a>. Their generous contributions will help to provide snacks, lunch, dinner, and a prize for the team that builds the best site of the day. All attendees will also receive a ticket to <a href=\"https://capetown.wordcamp.org/2015/\" target=\"_blank\">WordCamp Cape Town 2015</a>.</p>\n<p>&#8220;We are still looking for volunteers (there are about 20 spots left at the time of writing this) and it&#8217;s important to note that we are not just looking for developers here,&#8221; he said. &#8220;This is open to Project Managers, Designers, Developers, Content Creators, and Social Media Managers, as all of those individuals are needed to bring a complete website together (especially when it is all being done in one day.)&#8221;</p>\n<p>If you&#8217;re in the Cape Town area and you&#8217;d like to be part of this event, you can select a charity team to work on and specify your role when filling out the <a href=\"http://www.wpcapetown.co.za/event/do_action-wordpress-charity-hackathon-2015/\" target=\"_blank\">volunteer application</a> form. Check out the recap video below for a closer look at attendees&#8217; experiences from last year&#8217;s event.</p>\n<p><span class=\"embed-youtube\"></span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 19 May 2015 18:49:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: Short Survey on Which WordCamp Organizer Tools to Improve First\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43992\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://wptavern.com/short-survey-on-which-wordcamp-organizer-tools-to-improve-first\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1978:\"<p>In the past several months, the <a href=\"https://make.wordpress.org/community/\">Make WordPress Community</a> team has engaged in numerous discussions with WordCamp organizers on how they can improve the tools that are available. Those discussions include:</p>\n<ul>\n<li><a href=\"https://make.wordpress.org/community/2015/03/05/improving-wordcamp-org-notes-from-the-2014-community-summit/\" rel=\"nofollow\">Notes from the Community Summit</a></li>\n<li><a href=\"https://make.wordpress.org/community/2015/03/05/improving-wordcamp-org-user-experience-of-the-css-editor/\" rel=\"nofollow\">Improving the CSS Editing Experience</a></li>\n<li><a href=\"https://make.wordpress.org/community/2015/04/09/improving-wordcamp-org-adding-more-themes-page-templates/\" rel=\"nofollow\">Adding More Themes and/or Page Templates </a></li>\n</ul>\n<p>The team has created a <a href=\"https://make.wordpress.org/community/2015/05/05/wordcamp-organizer-survey/\">six question survey</a> to gather data to determine what tools should be worked on or improved first. If you&#8217;ve worked with any of the tools available on <a href=\"https://central.wordcamp.org/\">WordCamp.org</a> within the last 18 months, you&#8217;re strongly encouraged to take the survey.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WordCampOrganizerToolSurveyQuestion.png\"><img class=\"size-full wp-image-44005\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WordCampOrganizerToolSurveyQuestion.png?resize=598%2C495\" alt=\"WordCamp Tools Survey Question\" /></a>WordCamp Tools Survey Question\n<p>The last section has two questions that are open-ended to allow for feedback that extends beyond the tools in question. This is an excellent opportunity for WordCamp organizers to voice their opinion on what direction the team should take on creating and improving the tools available to them. It&#8217;s also a way to tell the team which tools you want to see created that don&#8217;t already exist.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 19 May 2015 18:36:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"Matt: How to Get Yourself to Do Things\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45054\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://ma.tt/2015/05/how-to-get-yourself-to-do-things/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:227:\"<p><a href=\"http://www.raptitude.com/2015/03/how-to-get-yourself-to-do-things/\">How to Get Yourself to Do Things</a>. Hat tip: <a href=\"https://alexjgustafson.wordpress.com/2015/04/04/ignore-stuff-and-do-a-thing/\">Alex</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 19 May 2015 05:16:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WPTavern: A WordPress Veteran’s Take on DrupalCon LA\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43963\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wptavern.com/a-wordpress-veterans-take-on-drupalcon-la\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5746:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/MendelKurland.jpg\"><img class=\"alignright size-thumbnail wp-image-43970\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/MendelKurland.jpg?resize=150%2C150\" alt=\"Mendel Kurland\" /></a>This post was contributed by guest author <a href=\"https://mendel.me/\">Mendel Kurland</a>. Kurland is GoDaddy&#8217;s evangelist who travels to WordCamps and is the interface between various open source communities and GoDaddy.</p>\n<p>In the following post, Kurland shares his experience attending <a href=\"https://events.drupal.org/losangeles2015\">DrupalCon Los Angeles</a>, a large conference devoted to <a href=\"https://www.drupal.org/\">Drupal</a>.</p>\n<hr />\n<p>As I flew from DrupalCon Los Angeles, CA to <a href=\"https://mendel.me/events/wordcamp/wordcamp-maine-2015/\">WordCamp Maine</a>, I thought a lot about what the Drupal and WordPress communities could learn from each other. <a href=\"https://wordpress.org/\">WordPress</a> and Drupal are two community-built platforms and each community is powerful. We stand to learn a lot from each other, because<a href=\"https://mendel.me/articles/business/why-all-open-source-projects-matter/\"> all open source projects matter</a>.</p>\n<p>With an eye toward looking for the similarities, rather than the differences, both WordPress and Drupal are working to overcome similar obstacles including, brand recognition, threat mitigation, adoption, onboarding, contribution, the list goes on. So why did I go to <a href=\"https://events.drupal.org/losangeles2015\">DrupalCon LA</a>? To learn and give back to another community that’s steeped in collaborative culture.</p>\n<h2>The Experience</h2>\n<p>Thousands of people attended <a href=\"https://mendel.me/events/drupalcon/drupalcon-la/\">DrupalCon in Los Angeles</a> this year. It’s massive and the layout is similar to a large developer conference. There are sessions centered on technical, as well as business topics, and usually lively question and answer opportunities after each session. There’s a coder lounge, a contribution room, and a huge emphasis on contributing to coding sprints for the next release of Drupal, Drupal 8.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/DrupalConLA.png\"><img class=\"size-full wp-image-43971\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/DrupalConLA.png?resize=1024%2C683\" alt=\"DrupalCon LA\" /></a>Photo via <a href=\"https://mendel.me/events/drupalcon/drupalcon-la/#jp-carousel-16491\">Mendel</a>\n<h2>Leveling and Onboarding</h2>\n<p>Prior to the conference, DrupalCon had summits to help gather community members around a particular vertical or topic such as, higher education, community, business, and training sessions to help level-up skills based on experience.</p>\n<p>The theme of organizing around common interests is strong throughout the entire conference with<a href=\"https://events.drupal.org/losangeles2015/bofs/2015-05-12\"> birds of a feather sessions</a> and<a href=\"https://events.drupal.org/losangeles2015/events\"> topical social gatherings</a> with topics like,<a href=\"https://events.drupal.org/losangeles2015/women-drupal\"> women in Drupal</a> and<a href=\"https://events.drupal.org/losangeles2015/first-time-attendee-social\"> first time attendees</a>. When it comes to mobilizing around interest groups, Drupal does a brilliant job.</p>\n<h2>Comparing WordPress and Drupal</h2>\n<p>I’ve met a higher proportion of people who work on enterprise sites at DrupalCons and a higher proportion of people who work on small business sites at DrupalCamps, local conferences similar to WordCamps. There are some important lessons, however, that I took away from the Drupal community.</p>\n<h2><b>Lessons and Questions from DrupalCon</b></h2>\n<ul>\n<li>Onboarding starts with education. The Drupal community puts an emphasis on training at just about every event while only a handful of WordCamps offer a <strong>Foundation Friday</strong> or some other local onboarding event.</li>\n<li>Building community means valuing the same things and aligning along common interests. BoF (Birds of a Feather) sessions are a part of Drupal and other technical community conferences. There are certainly people with specific interests related to performance, security, women in WordPress, WP-CLI, etc. Should the WordPress community offer BoF sessions at WordCamps? Or are the existing <strong>tracks</strong> that many WordCamps offer enough?</li>\n<li>Networking with those who work in a similar vertical is important. Just as Drupal holds summits for particular verticals, the WordPress community is beginning to do the same with things like, <a href=\"https://miami.wordcamp.org/2015/announcing-buddycamp-miami-2015/\">BuddyCamp at WordCamp Miami</a>, <a href=\"http://conf.woocommerce.com/\">WooConf</a> (e-commerce), <a href=\"http://pressnomics.com/\">Pressnomics</a> (business), <a href=\"http://prestigeconf.com/\">Prestige</a> (business), <a href=\"https://loopconf.io/\">LoopConf</a> (developer). Can more be done at WordCamps?</li>\n</ul>\n<h2>It&#8217;s OK to Love Drupal Too</h2>\n<p>If you’re reading this article on the Tavern, you’re likely a WordPress loyalist. I love WordPress, and it’s also <strong>ok to love Drupal</strong>. They are both tools in an open source toolbox that we all share. The beauty of our opportunity as developers, designers, and creative professionals is our ability to create awesome things in a million different ways.</p>\n<p>In going to DrupalCon, it was refreshing for me to take a second to see the web development industry from another perspective. I’d love to hear your perspective in the comments <a href=\"https://twitter.com/ifyouwillit\">and on Twitter</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 19 May 2015 01:53:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: Community, Translation, and Wapuu: How Japan is Shaping WordPress History\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43605\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wptavern.com/community-translation-and-wapuu-how-japan-is-shaping-wordpress-history\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:16719:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wcsf-2014-japanese-community.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wcsf-2014-japanese-community.jpg?resize=1025%2C523\" alt=\"Japanese WordPress community representatives at WordCamp San Francisco 2014\" class=\"size-full wp-image-43923\" /></a>Japanese WordPress community representatives at WordCamp San Francisco 2014\n<p>Japanese WordPress users were some of the earliest to see the project&#8217;s potential and help bring the software to the non-English speaking world. At the end of 2003, just six months after Matt Mullenweg and Mike Little <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\" target=\"_blank\">decided to fork b2</a>, a Japanese version of WordPress was available.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WordPress-ME.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WordPress-ME.jpg?resize=748%2C299\" alt=\"WordPress-ME\" class=\"aligncenter size-full wp-image-43607\" /></a></p>\n<p>The version was originally called &#8220;WordPress ME&#8221; and was maintained by a user called <a href=\"https://profiles.wordpress.org/otsukare/\" target=\"_blank\">Otsukare</a>, whose <a href=\"http://web.archive.org/web/20040802092512/http://wordpress.xwd.jp/\" target=\"_blank\">translation notes</a> indicate that he believed WordPress would become &#8220;convenient and increasingly easy to use in the future.&#8221; This Japanese version corresponded with <a href=\"https://wordpress.org/news/2003/10/072-final-version-available/\" target=\"_blank\">WordPress 0.72</a>, as WordPress wouldn&#8217;t have internationalization support until version 1.2.</p>\n<p>Otsukare was instrumental in demonstrating the demand for translation for all languages with the popularity of his <a href=\"https://wordpress.org/support/topic/localization-help-needed\" target=\"_blank\">multilingual fork of WordPress</a>, which allowed easy modification via the use of a language file. It is rumored that this multilingual edition, along with discussions on the WordPress ME fourms, was influential in bringing <a href=\"https://codex.wordpress.org/Plugin_API/Filter_Reference/gettext\" target=\"_blank\">gettext</a> into WordPress.</p>\n<h2>Growing the Japanese WordPress Community Through Local Meetups</h2>\n<p>Over the past 11 years, local Japanese WordPress communities have grown steadily. <a href=\"https://profiles.wordpress.org/Nao\" target=\"_blank\">Naoko Takano</a>, who has been involved with the local community since 2003, attributes that growth to <a href=\"http://www.slideshare.net/naokomc/wordcamp-europe2013\" target=\"_blank\">consistent translation and a reliable release workflow</a>, managed by a dedicated Japanese package team.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/japanese-package-team.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/japanese-package-team.jpg?resize=625%2C247\" alt=\"japanese-package-team\" class=\"aligncenter size-full wp-image-43918\" /></a></p>\n<p>An organized system around translation and documentation were two key ingredients that helped germinate the early Japanese WordPress community, but local meetups were ultimately the catalyst for its massive growth.</p>\n<p><a href=\"https://www.flickr.com/search/?tags=wordcamptokyo2008\" target=\"_blank\">The first WordCamp Tokyo</a> was held in 2008 with 60 attendees. <a href=\"https://tokyo.wordcamp.org/\" target=\"_blank\">WordCamp Tokyo</a> today now pulls in 1200 &#8211; 1400 people, according to co-organizer <a href=\"https://profiles.wordpress.org/shinichin\" target=\"_blank\">Shinichi Nishikawa</a>. This event is larger than past editions of WordCamps Europe and San Francisco.</p>\n<p>Nishikawa reports that over the past seven years, Japan has hosted 15 WordCamps in Tokyo, Kyoto, Fukuoka, Yokohama Nagoyo, Kobe, and Osaka. <a href=\"https://kansai.wordcamp.org/2014/\" target=\"_blank\">WordCamp Kansai</a>, held in the Western part of the country, was organized by WordBench members of that area, including Shiga, Kyoto, Osaka, Hyogo, Nara and Wakayama.</p>\n<p>Regional WordPress groups in Japan are organized on <a href=\"http://WordBench.org\" target=\"_blank\">WordBench.org</a>, a site that allows users to find, join, and create a meetup. The site was <a href=\"http://wordpress.tv/2009/04/30/wordcamp-tokyo-2009-takayuki-miyoshi-introducing-wordpress-regional-community-wordbench/\" target=\"_blank\">created in 2009 by Takayuki Miyoshi</a>, the author of <a href=\"https://wordpress.org/plugins/contact-form-7/\" target=\"_blank\">Contact Form 7</a>, one of WordPress&#8217; most popular plugins. WordBench has been running on BuddyPress for the past six years and was originally built on RC1 of the plugin.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wordbench.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wordbench.png?resize=1025%2C672\" alt=\"wordbench\" class=\"aligncenter size-full wp-image-43929\" /></a></p>\n<p>The site currently lists 48 local groups throughout Japan, named for their cities, i.e. WordBench Tokyo, WordBench Osaka, WordBench Kawasaki. Members and organizers use the site to post about upcoming events and recaps of meetups recently held in various locations. The site serves to keep Japan&#8217;s local communities connected and inspired.</p>\n<h2>Japan&#8217;s Unique WordPress Meetups and the Importance of Wapuu</h2>\n<p>In addition to the regional WordBench groups, interest-based meetups are also common in the Japanese WordPress community. In this format, members meet around different interests outside of WordPress, such as cooking or photography. For example, the <a href=\"https://shashinbu.wordpress.com/\" target=\"_blank\">WordPhotoclub</a> meetup gathers together to go on walks and take photos. Members&#8217; <a href=\"http://8bitodyssey.com/archives/1547\" target=\"_blank\">photos</a> were printed and displayed at WordCamp Tokyo 2012.</p>\n<p><a href=\"http://takamorry.com/article/20130209_wordcrab.html\" target=\"_blank\">WordCrab</a> is another example of one of Japan&#8217;s unique WordPress meetups. Members from all over from Japan gather in the Fukui prefecture, where they combine WordPress sessions with a giant <a href=\"https://www.flickr.com/search/?q=wordcrab&l=commderiv&ss=0&ct=0&mt=all&w=all&adv=1\" target=\"_blank\">crab party</a> where everyone feasts upon the region&#8217;s renowned crabs.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wordcrab.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wordcrab.jpg?resize=1025%2C586\" alt=\"photo credit: WordCrab meetup\" class=\"size-full wp-image-43936\" /></a>photo credit: <a href=\"https://www.flickr.com/search/?q=wordcrab&l=commderiv&ss=0&ct=0&mt=all&w=all&adv=1\">WordCrab meetup</a>\n<p>The <a href=\"http://2014onsen.wbsendai.com/\" target=\"_blank\">Word温泉 (WordOnsen) meetup</a> is centered around the enjoyment of hot springs. Members gather in Fukushima and stay at a hotel where they have WordPress sessions and a party night.</p>\n<p>&#8220;In meetups we started doing more things than just learning WordPress,&#8221; community organizer Shinichi Nishikawa said. &#8220;We get friends together and go for a walk and eat lunch/dinner together.</p>\n<p>&#8220;I think this a really good way to make the community stronger. <span class=\"pullquote alignleft\">People are talented in different things and by doing something together, other than WordPress, people can show their talents.</span> And of course, it’s fun.&#8221;</p>\n<p>Japan&#8217;s holistic approach to meetups incorporates various aspects of life and relationships, as opposed to simply centering around improving WordPress technical skill. As a result, members become more connected and meetups are highly personalized. That&#8217;s where Wapuu enters the picture to bring special meaning to each group.</p>\n<p><a href=\"https://ja.wordpress.org/about-wp-ja/wapuu/\" target=\"_blank\">Wapuu</a>, the official mascot character of WordPress, was designed by Kazuko Kaneuchi in 2011. It&#8217;s <a href=\"https://github.com/jawordpressorg/wapuu\" target=\"_blank\">distributed under the GPLv2 or later</a> and can be modified by anyone to add more personality to the character.</p>\n<p>&#8220;Thanks to the freedom of the GPL, there have been many <a href=\"http://jawordpressorg.github.io/wapuu/\" target=\"_blank\">forked versions of Wapuu</a>,&#8221; Nishikawa said. &#8220;All local Wapuus are created by someone who belongs to each local community and they hold something that represents where they are from.&#8221;</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/local-wapuu.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/local-wapuu.jpg?resize=627%2C349\" alt=\"photo credit:  Naoko Takano - WordPress History\" class=\"size-full wp-image-43943\" /></a>photo credit:<br />Naoko Takano &#8211; <a href=\"http://www.slideshare.net/naokomc/wordpress-history-21925968/42\">WordPress History</a>\n<p>Wapuu is so well-loved that the creature ends up making its way onto <a href=\"https://www.flickr.com/photos/odysseygate/8509556933/\" target=\"_blank\">swag</a>, cakes, and nail and coffee art at Japanese WordPress events.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wapuu-everywhere.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wapuu-everywhere.jpg?resize=1025%2C703\" alt=\"photo credit:  Naoko Takano - Learnings from Growing Local WordPress Communities\" class=\"size-full wp-image-43945\" /></a>photo credit:<br />Naoko Takano &#8211; <a href=\"http://www.slideshare.net/naokomc/wordcamp-europe2013/47\">Learnings from Growing Local WordPress Communities</a>\n<p>The name &#8220;Wapuu&#8221; was given to the mascot by a users&#8217; poll. &#8220;Japanese people pronounce WordPress as &#8216;WAADOPURESU,\'&#8221; Nishikawa said. &#8220;Wapuu sounds like an abbreviation of WAADOPURESU, taking &#8216;Wa&#8217; and &#8216;Pu&#8217; from it.&#8221;</p>\n<p>Modifications of the mascot have recently started popping up at WordCamps outside of Japan. <a href=\"http://wptavern.com/scott-evans-on-designing-the-punk-wapuu-for-wordcamp-london-2015\" target=\"_blank\">WordCamp London&#8217;s wapuunk</a> was so popular that it inspired WordCamp Philly and <a href=\"http://wptavern.com/meet-wapuujlo-official-mascot-of-wordcamp-belgrade\" target=\"_blank\">WordCamp Belgrade</a> to create their own unique modifications to the character.</p>\n<p>For whatever reason, Wapuu seems to have a special power to bring people together, regardless of culture or location. WordPress has the Japanese community to thank for its unique open source contribution to meetup branding.</p>\n<h2>The Challenges of Contributing to WordPress Across the Language Barrier</h2>\n<p>Despite having a large WordPress community thriving in Japan, with many of the <a href=\"http://www.sailor.co.jp/\" target=\"_blank\">top</a> <a href=\"http://womens.marathon-festival.com/2014/\" target=\"_blank\">websites</a> <a href=\"http://tasukeaijapan.jp/\" target=\"_blank\">built</a> on the <a href=\"http://www.kurashi-no-techo.co.jp/\" target=\"_blank\">software</a>, Japanese developers have a difficult time contributing back to core.</p>\n<p>&#8220;Language is the biggest barrier,&#8221; Nishikawa told the Tavern. &#8220;There are many good developers in Japan (and in other countries) who don’t speak English. Most of them can read documentation but joining in the conversation in tickets and on Slack is a different thing.</p>\n<p>&#8220;In my opinion, there is English for native speakers and English for international people, and they are different,&#8221; he explained.</p>\n<p>&#8220;It’s difficult to say how different they are, but for us who are not native, ambiguous words, abbreviations like &#8216;FWIW,&#8217; jokes, and slang are difficult,&#8221; Nishikawa said. &#8220;Sometimes nesting a long sentence in another long sentence by using &#8216;that,&#8217; &#8216;which,&#8217; and &#8216;including&#8217; is difficult.&#8221;</p>\n<p>He explained that overcoming the language barrier is more than simply learning English; it also includes the hurdle of trying to understand the abbreviations and expressions that are infused by the culture around native English speakers.</p>\n<p>&#8220;People would say that you can understand because it’s code, but if we look at the conversations in tickets, the surrounding discussion often concerns more than just the code,&#8221; he said.</p>\n<p>&#8220;Non-English speaking developers are trying to learn English, but it would be good if people in the ticket / Slack would keep in mind that there are people who don’t share the context or culture behind the words they write,&#8221; Nishikawa suggested.</p>\n<p>&#8220;If we make the words and expressions easier to understand, someone who understands 80%  will have the opportunity to understand nearly 100%.&#8221;</p>\n<p>However, Nishikawa is unsure of whether or not it is productive to request these kinds of changes, given that communication can never really be separated from culture.</p>\n<p>&#8220;Maybe a more welcoming atmosphere needed?&#8221; he said. &#8220;On the other hand, I know that the discussions include a great deal of context and many cultural things. It’s a place for communication, too. So, I don’t know if it’s right to say that something needs to change.</p>\n<p>&#8220;Additionally, there are many talented developers who don’t understand English at all and I have no idea what can be done for them,&#8221; he said.</p>\n<p>Nishikawa said that he felt much more connected to the community after attending WordCamp San Francisco and the following summit and contributor day.</p>\n<p>&#8220;Even for developers who didn&#8217;t speak English, we had translators and discussed things, looked at the code and shared the WordPress projects they are working on,&#8221; he said. &#8220;After these face-to-face conversations, developers are more relaxed and motivated to work in the <a href=\"https://make.wordpress.org/\" target=\"_blank\">core Make project</a>. Inviting developers to meetups/camps in the English world or inviting core contributors travel and join local contribution days will be a big trigger to involve more people.&#8221;</p>\n<h2>The Future of WordPress in Japan</h2>\n<p>Nishikawa believes that WordPress has a bright future in Japan, thanks to the efforts of Otsukare, Naoko Takano, Takayuki Miyoshi and all the plugin developers, Tenpura (the author of <a href=\"https://wordpress.org/plugins/wp-multibyte-patch/\" target=\"_blank\">WP Multibyte Patch</a> plugin), bloggers, community organizers, an army of dedicated translators and more.</p>\n<p>He is hopeful that positive experiences for developers at global meetups like WCSF will help the Japanese WordPress community find ways to contribute back to core and other projects.</p>\n<p>&#8220;There have been a few people who had contributed separately, but now I feel there is a small groove of people who are more interested in contribution,&#8221; he said.</p>\n<p>&#8220;For the community, we hope that the activeness of the Japanese community will be exported to other Asian (and global) communities, especially with Wapuu or the unique &#8220;more-than-learning&#8221; style of meetups.&#8221;</p>\n<p>He also believes the future of WordPress in Japan will be brighter with the internationalization improvements that are continually being added to core.</p>\n<p>&#8220;For the users, when everything is translatable, people are happier. If WordPress can become more mobile friendly, it will be used more by young people. When the WP-API is in core, there will be more diverse apps available.&#8221;</p>\n<p>Nishikawa has had such a positive experience organizing WordPress community events in Japan that he is now active in growing the community in Thailand.</p>\n<p>&#8220;We now have meetups twice per month in Bangkok for developers/users/designers. We don’t have &#8216;session-oriented meetups&#8217; anymore but we try to have casual talks every time, where everyone can speak in their own languages. Translation is more than welcome but we don’t want to rely on someone.&#8221;</p>\n<p>As Japan&#8217;s community-oriented approach to learning has paid off with highly active meetup groups and some of the largest WordCamps on the globe, Nishikawa is hoping to bring his experience to Thailand and help organize a WordCamp Bangkok in the near future.</p>\n<p>&#8220;Community has made my life/job much more exciting and fun,&#8221; he said. &#8220;Many things will differ culture by culture but the core value of community should be the same everywhere.&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 18 May 2015 21:26:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Matt: 2 Chocolate Chip Cookies\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45056\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://ma.tt/2015/05/2-chocolate-chip-cookies/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:494:\"<blockquote><p>Sometimes, you just want 2 chocolate chip cookies. This happens to me all of the time. I want a super indulgent, rich and buttery chocolate chip cookie, but don’t want to make the whole 36 of them which I’d inevitably inhale over about the same amount of hours.</p></blockquote>\n<p><a href=\"http://www.inthiskitchen.com/2014/05/21/just-2-chocolate-chip-cookies-single-serving-recipe/\">Ever wondered a good recipe to make just 2 chocolate chip cookies</a>? Now you know.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 18 May 2015 06:35:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: Silk Road, Part 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45063\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2015/05/silk-road-part-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:435:\"<p>As <a href=\"http://ma.tt/2015/05/untold-silk-road/\">promised a few weeks ago</a>, a new installment of the Wired Silk Road story is out and I wanted to share it, <a href=\"http://www.wired.com/2015/05/silk-road-2/\">The Untold Story of Silk Road, Part 2: The Fall</a>. This one is actually a lot more normal, with some surprisingly simple breaks leading to the downfall of Ross, but there&#8217;s an interesting twist at the end.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 16 May 2015 17:14:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Matt: Memorable Musk Quotes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45046\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"http://ma.tt/2015/05/memorable-musk-quotes/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:224:\"<p><a href=\"http://www.washingtonpost.com/blogs/innovations/wp/2015/05/11/the-22-most-memorable-quotes-from-the-new-elon-musk-book-ranked/\">The 22 most memorable quotes from the new Elon Musk book, ranked</a>. Hilarious.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 16 May 2015 06:14:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Display Your Contributions to WordPress With the WP Contributions Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43823\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://wptavern.com/display-your-contributions-to-wordpress-with-the-wp-contributions-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4327:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionsFeaturedImage.png\"><img class=\"aligncenter size-full wp-image-43884\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionsFeaturedImage.png?resize=748%2C239\" alt=\"WPContributionsFeaturedImage\" /></a><a href=\"https://wordpress.org/plugins/wp-contributions/\">WP Contributions</a> is a new plugin by Dustin Filippini, Damon Cook, and WebDevStudios that displays WordPress contributions via widgets. Widgets included are:</p>\n<ul>\n<li>Contributions to the Codex</li>\n<li>WordPress Core Contributions</li>\n<li>Featured Plugin</li>\n<li>Featured Theme</li>\n</ul>\n<p>Once activated, browse to Appearance &gt; Widgets to access the new widgets. You&#8217;ll need to know your username for WordPress trac and the Codex to display your contributions. Keep in mind that the core contributions widget only list tickets that are closed and you received props for.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionsCoreWidget.png\"><img class=\"size-full wp-image-43880\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionsCoreWidget.png?resize=342%2C272\" alt=\"WP Core Contributions Widget\" /></a>WP Core Contributions Widget\n<p>The Codex contributions widget displays the most recent articles you&#8217;ve edited along with a link to see more.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionsCodexWidget.png\"><img class=\"size-full wp-image-43881\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionsCodexWidget.png?resize=330%2C296\" alt=\"Codex Contributions Widget\" /></a>Codex Contributions Widget\n<p>The theme and plugin widgets use the slug of the theme and plugin you want to feature. You can only feature one theme or plugin at a time unless you use multiple widgets. The featured plugin widget displays a thumbnail of the plugin&#8217;s header image, author name, version, description, average rating, total downloads, and when it was last updated.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionPluginWidget.png\"><img class=\"size-full wp-image-43882\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContributionPluginWidget.png?resize=331%2C438\" alt=\"WP Contribution Plugin Widget\" /></a>WP Contribution Plugin Widget\n<p>The featured theme widget displays a small preview of the theme, a short description, average rating, author, current version, total downloads, and when it was last updated.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContribThemeWidget.png\"><img class=\"size-full wp-image-43883\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/WPContribThemeWidget.png?resize=379%2C707\" alt=\"Featured Theme Widget\" /></a>Featured Theme Widget\n<p>Even though the plugin and theme widgets are meant to be used to showcase your own work, they&#8217;re great for featuring any plugin or theme you&#8217;d like people to know about. WP Contributions comes with a series of <a href=\"https://wordpress.org/plugins/wp-contributions/faq/\">template tags</a> for those who want more control over how the information is displayed.</p>\n<p>One thing I&#8217;d like to see in a future version is short code support. This way, users could create a WP Contributions page on their site with easy to use short codes. It&#8217;s not supported now, but Filippini informs me that a future version will include the ability to display badges attached to a WordPress.org user profile.</p>\n<p>As WordPress <a href=\"http://w3techs.com/\">continues to increase in marketshare</a>, the ability to show how much you&#8217;ve contributed to the project is a huge resume booster, especially if you can say your code runs on millions of sites. In early 2014, WordPress made substantial <a href=\"http://wptavern.com/wordpress-org-profile-redesign-is-live\">improvements to user profiles</a> but there&#8217;s no easy way to display those contributions to a wider audience.</p>\n<p>WP Contributions does a decent job filling the void and is available for free on the WordPress.org plugin directory. I tested <a href=\"https://wordpress.org/plugins/wp-contributions/\">WP Contributions</a> on WordPress 4.2.2 and it works without any problems.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 May 2015 23:28:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Lasso Frontend Editing Plugin for WordPress Now Available on GitHub\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43852\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://wptavern.com/lasso-frontend-editing-plugin-for-wordpress-now-available-on-github\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4698:\"<p>WordPress developer Nick Haskins is hoping to revolutionize the way users publish content with <a href=\"https://lasso.is/\" target=\"_blank\">Lasso</a>, his commercial front-end editing plugin. Lasso is sold through his storefront and is also in use on <a href=\"https://story.am/\" target=\"_blank\">Story.am</a>, the hosted platform for <a href=\"http://wptavern.com/?s=Aesop+Story+Engine\" target=\"_blank\">Aesop Story Engine</a>. Haskins recently <a href=\"http://wptavern.com/story-am-relaunches-now-100-free\" target=\"_blank\">made accounts on Story.am available for free</a> in hopes of garnering more feedback on the Lasso editing experience.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/building-with-lasso.gif\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/building-with-lasso.gif?resize=900%2C618\" alt=\"building-with-lasso\" class=\"aligncenter size-full wp-image-43867\" /></a></p>\n<p>As of today, <a href=\"https://github.com/AesopInteractive/lasso\" target=\"_blank\">Lasso is now available on GitHub</a> for developers and users to test and offer feedback/contribution.</p>\n<p>&#8220;This decision was several months in the making,&#8221; Haskins told the Tavern. &#8220;It included conversations with developers who have their commercially sold code publicly available, as well as A/B testing our presence to verify that the move would be both beneficial to the plugin, as well as the user base that it’s attracting.&#8221;</p>\n<p>Making the code public is a calculated risk, which he hopes will not damage sales of the plugin but rather increase its visibility. Haskins recently published a <a href=\"http://aesopinteractive.com/jan-april-2015-report/\" target=\"_blank\">financial transparency report</a> on his 15 month old company, which indicates that Aesop Interactive is on track to double its revenue in 2015 based on numbers from January &#8211; April. Sales of the Lasso product totaled $4,408.36.</p>\n<p>As the plugin is open source, you are free to use it anywhere, but Haskins notes that support will only be offered to customers:</p>\n<blockquote><p>If you have a suggestion, a bug report, or a patch for an issue, feel free to submit it here. We do ask, however, that if you are using the plugin on a live site that you please purchase a valid license from the website. We cannot provide support to anyone who does not hold a valid license key.</p></blockquote>\n<p>&#8220;I decided to make it public today after I was invited in to collaborate on another publicly available commercially sold plugin,&#8221; he said. &#8220;I just needed a final excuse, and that was it.&#8221;</p>\n<p>Haskins is not the first developer to make a commercial WordPress product available on GitHub for contribution. Earlier this year, the folks behind GravityView decided to <a href=\"http://wptavern.com/gravityview-is-now-public-on-github\" target=\"_blank\">make their plugin public on GitHub</a> after being inspired by a <a href=\"https://mattreport.com/interview-matt-mullenweg/\" target=\"_blank\">discussion between Matt Medeiros and Matt Mullenweg</a> on ubiquity vs. scarcity as it relates to WordPress product businesses:</p>\n<blockquote><p>The one pattern I see most right now that I think is not sustainable is, and it’s because it’s the easiest thing to do, is businesses that are built on a scarcity – the thing not being widely available. If you think about some of the coolest successes so far in WordPress, the Gravity Forms, some of the theme businesses, they are inherently predicated on the fact that you have to pay to access them.</p>\n<p>I’ve always been a fan of businesses that grow with ubiquity, that become more powerful the more ubiquitous they are, more valuable. WordPress itself is one of these. Akismet is one of these. Jetpack is certainly one of those.</p></blockquote>\n<p>This approach brings up the question of whether or not a commercial plugin developer can run a successful business while giving the code away for free on GitHub. A select few are finding that the benefits of community contribution and feedback outweigh the risk.</p>\n<p>Haskin&#8217;s frontend editing plugin is a prime candidate to explore this approach, as this type of plugin was created for users of all technical skill levels. Customers interested in this functionality are less likely to be comfortable installing and updating plugins from GitHub. If you&#8217;ve been eager to try Lasso but couldn&#8217;t get past the <a href=\"https://lasso.is/pricing/\" target=\"_blank\">$129 price tag</a>, now is your opportunity to <a href=\"https://github.com/AesopInteractive/lasso\" target=\"_blank\">download the plugin</a> and put it through the paces.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 May 2015 20:22:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: SiteGround is Organizing Bulgaria’s First PHP Conference\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43825\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wptavern.com/siteground-is-organizing-bulgarias-first-php-conference\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2868:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/bulgaria-php-conference.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/bulgaria-php-conference.jpg?resize=670%2C287\" alt=\"bulgaria-php-conference\" class=\"aligncenter size-full wp-image-43829\" /></a></p>\n<p><a href=\"https://www.siteground.com\" target=\"_blank\">SiteGround</a> is organizing the first ever <a href=\"http://www.bgphp.org/\" target=\"_blank\">Bulgaria PHP conference to be held in Sofia</a>, September 25-27, 2015. The company is headquartered in Sofia and its Head of Development, Mihail Irintchev, has been working hard to develop the local PHP community with the eventual goal of hosting a global PHP event.</p>\n<p>Irintchev was one of the founders of the Bulgaria PHP user group two years ago, which meets regularly in the SiteGround offices in Sofia. The meetups have grown steadily, inspiring him to approach the SiteGround management team about working together to host a PHP conference.</p>\n<p>&#8220;We see value in making it possible for developers from Bulgaria and the region to meet and learn from some of the most prominent minds in the global PHP community,&#8221; SiteGround representative Reneta Tsankova said. &#8220;It is also an opportunity for our region to once again be recognized as a place with strong IT potential and lots of development talent.&#8221;</p>\n<p>The speaker lineup for the event has been finalized and includes leaders in PHP community (Michelangelo van Dam, Sebastian Bergmann, Cal Evans, Adam Culp, and more), as well as some influencers from both the WordPress and Drupal communities, including Mario Peshev and Larry Garfield.</p>\n<p>Bulgaria PHP Conference will be a three day event that includes one training day and two conference days. All of the sessions will be conducted in English, as the event is pulling in speakers and attendees from Bulgaria, the Balkans, and other parts of the world.</p>\n<p><a href=\"https://automattic.com/\" target=\"_blank\">Automattic</a> is now a confirmed <a href=\"http://www.bgphp.org/sponsors/\" target=\"_blank\">sponsor</a>, along with Mandrill, Shopware, SiteGround, and others. The sponsors make it possible for organizers to keep the event accessible to as many attendees as possible with lower <a href=\"http://www.bgphp.org/tickets/\" target=\"_blank\">ticket</a> prices. The earlybird price for the conference pass is just 65 euro.</p>\n<p>Sofia hosted <a href=\"http://wptavern.com/wordpress-beyond-boundaries-a-recap-of-wordcamp-europe-2014\" target=\"_blank\">WordCamp Europe 2014</a> and the city is home to a vibrant IT community. If you&#8217;re looking to expand your PHP skills and connect with other passionate developers, the <a href=\"http://www.bgphp.org/\" target=\"_blank\">Bulgaria PHP Conference</a> is one you&#8217;ll want to consider adding to your calendar for September.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 May 2015 18:15:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Matt: Trojan Emoji\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45050\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"http://ma.tt/2015/05/trojan-emoji/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:588:\"<blockquote><p>Andrew Nacin, lead developer of WordPress, just finished a talk at Loopconf, where he talked about a series of related WordPress security fixes that spanned two years, with the final fix included into WordPress core under the guise of Emoji support.</p></blockquote>\n<p><a href=\"https://poststatus.com/the-trojan-emoji/\">Post Status has a good look at some of the really deep security work that has been going on in WordPress lately</a>. There will always be more problems, but we&#8217;re getting to the point where the problems (and the fixes) are often quite subtle.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 May 2015 06:06:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Beer Directory: A WordPress Plugin for Brewers and Beer Aficionados\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43140\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/beer-directory-a-wordpress-plugin-for-brewers-and-beer-aficionados\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4464:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/beer.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/beer.jpg?resize=869%2C415\" alt=\"beer\" class=\"aligncenter size-full wp-image-43810\" /></a></p>\n<p>Craft beer and WordPress are a magical combination. Both cultures are built on some of the same values, like sharing knowledge and open sourcing happiness. With the explosion of the craft beer scene over the past few years, many new <a href=\"http://wptavern.com/30-beautiful-brewery-websites-built-with-wordpress\" target=\"_blank\">breweries are opting to build their websites on top of WordPress</a>. When you&#8217;re bootstrapping a new brewery, the last thing you need to spend money on is proprietary software.</p>\n<p>The WordPress community has many free and open source tools that developers can use to build a beer-centered website. <a href=\"https://wordpress.org/plugins/beer-directory/\" target=\"_blank\">Beer Directory</a> is a new plugin released this year by Jami Gibbs, founder of <a href=\"https://rescuethemes.com/\" target=\"_blank\">Rescue Themes</a>. She created it to support beer listings on her commercial <a href=\"http://themeforest.net/item/brewery-a-wordpress-theme-for-beer-makers/full_screen_preview/10941216\" target=\"_blank\">Brewery</a> theme.</p>\n<p>Beer Directory gives you an easy way to enter beers and their details in the admin. It allows you to categorize and group beers, enter details, and display listings via a configurable shortcode. The post type includes fields for ABV, IBU, OG, FG, SRM/Color, Malts, Hops, and Yeast.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/beer-profile.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/beer-profile.jpg?resize=1025%2C797\" alt=\"beer-profile\" class=\"aligncenter size-full wp-image-43790\" /></a></p>\n<p>I tested the plugin by adding the details from a <a href=\"https://www.brewtoad.com/recipes/put-the-blueberries-in-the-basket\" target=\"_blank\">blueberry sour beer recipe</a>. The output for an individual listing on the frontend will look something like this, depending on your active theme:</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/beer-listing.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/beer-listing.jpg?resize=626%2C872\" alt=\"beer-listing\" class=\"aligncenter size-full wp-image-43791\" /></a></p>\n<p>The plugin includes a shortcode for listing an individual beer: <code>[beer id=\"17\"]</code> and one for displaying all listings: <code>[beer]</code>. The shortcodes can be configured by count, category, id, and any of the WordPress <a href=\"http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters\" target=\"_blank\">Order &amp; Orderby Parameters</a>. Beer posts also include support for a featured image.</p>\n<p>Be advised that this is not a beer recipe plugin, so there&#8217;s no easy way to enter your hop schedule, amounts for fermentables, temperatures, etc. Beer Directory was created purely for listing beers on the frontend with a few key details. If you need to enter beer recipes, the <a href=\"http://wptavern.com/how-to-share-beer-recipes-in-wordpress\" target=\"_blank\">BeerXML Shortcode plugin</a>, created by <a href=\"https://twitter.com/derekspringer\" target=\"_blank\">Derek Springer</a>, is a more suitable option.</p>\n<p>The Beer Directory plugin is perfect for home brewers, professional breweries, or even beer enthusiasts who want to maintain a personal library of beers they enjoy. With this data saved in a custom post type, it will be transferable no matter how many times you change your WordPress theme. In addition to keeping track of your beers, the admin listing allows you to easily search and sort your library.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/beer-in-the-admin.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/beer-in-the-admin.jpg?resize=1025%2C344\" alt=\"beer-in-the-admin\" class=\"aligncenter size-full wp-image-43807\" /></a></p>\n<p>After testing the plugin, I can confirm that it works as advertised. <a href=\"https://wordpress.org/plugins/beer-directory/\" target=\"_blank\">Beer Directory</a> is fully translatable and available for free on WordPress.org. If you want to contribute to development, the plugin can also be found on <a href=\"https://github.com/RescueThemes/beer-directory\" target=\"_blank\">GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 May 2015 01:31:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: cPanel’s Site Software Addon Disables WordPress Auto Updates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43609\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/cpanels-site-software-addon-disables-wordpress-auto-updates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8988:\"<p>A little more than two months ago, Derek Munson, who goes by the username <a href=\"https://wordpress.org/support/profile/drumology2001\">Drumology2001 </a>published a <a href=\"https://wordpress.org/support/topic/wp-updates-not-showing-latest-wp-version-available?replies=34\">thread</a> in the WordPress.org support forums. While performing maintenance on several WordPress sites on his virtual private server, Munson discovered a number of them running outdated versions. Versions ranged from 3.9 to 4.1 with at least one site using WordPress 3.9.2.</p>\n<blockquote><p>I&#8217;m used to seeing the &#8216;nag&#8217; at the top of the screen that lets me know there&#8217;s a newer version available. I am not seeing that on any of these sites which aren&#8217;t on the newest version (4.1.1). When I go to Dashboard &gt; Updates and click &#8216;Check Again&#8217; to force a manual check, it&#8217;s still acting as though everything is up to date when it&#8217;s clearly not.</p></blockquote>\n<p>Initially, Munson thought All in One WP Security and Firewall <a href=\"https://wordpress.org/support/topic/blocking-wp-core-file-updates\">was blocking update notifications</a>. <a href=\"https://wordpress.org/support/profile/mbrsolution\">Mbrsolution</a>, the plugin&#8217;s main developer, confirmed that it doesn&#8217;t block update notifications. After completing a number of troubleshooting techniques suggested by volunteers on the WordPress support forum, Munson installed <a href=\"https://wordpress.org/plugins/wordfence/\">Wordfence Security</a>, a WordPress security plugin.</p>\n<p>One of Wordfence&#8217;s noteworthy features is its scanner. It compares clean WordPress core files to those on the server and notifies the user if it detects a difference. Results of the scan shows three files had been changed.</p>\n<p><strong>wp-admin/includes/update.php</strong><br />\n<strong>wp-admin/update-core.php</strong><br />\n<strong>wp-admin/includes/class-wp-upgrader.php</strong></p>\n<p>These files were only changed on WordPress sites that were installed using cPanel&#8217;s Site Software addon.</p>\n<p><strong>WordPress&#8217;</strong> update.php file.<br />\n<code>function get_core_updates( $options = array() ) { $options = array_merge( array( \'available\' =&gt; true, \'dismissed\' =&gt; false ), $options ); $dismissed = get_site_option( \'dismissed_update_core\' );</code></p>\n<p><strong>cPanel&#8217;s</strong> update.php file.<br />\n<code>function get_core_updates( $options = array() ) { # cPanel override: Disable all core updates to prevent conflict with cPAddons. return false; $options = array_merge( array( \'available\' =&gt; true, \'dismissed\' =&gt; false ), $options );</code></p>\n<p><strong>WordPress&#8217;</strong> update-core.php file.<br />\n<code>function core_upgrade_preamble() { global $wp_version, $required_php_version, $required_mysql_version; $updates = get_core_updates();</code></p>\n<p><strong>cPanel&#8217;s</strong> update-core.php file.<br />\n<code>function core_upgrade_preamble() { # cPanel override: Do not display the current or the latest version, because we\'ve disabled updates. return; global $wp_version, $required_php_version, $required_mysql_version; $updates = get_core_updates();</code></p>\n<p><strong>WordPress&#8217;</strong> class-wp-upgrader.php file.<br />\n<code>public function is_disabled() { // Background updates are disabled if you don\'t want file changes. if ( defined( \'DISALLOW_FILE_MODS\' ) &amp;&amp; DISALLOW_FILE_MODS ) return true;</code></p>\n<p><strong>cPanel&#8217;s</strong> class-wp-upgrader.php file.<br />\n<code>public function is_disabled() { return true; // Force this functionality to disabled because it is incompatible with cPAddons. // Background updates are disabled if you don\'t want file changes. if ( defined( \'DISALLOW_FILE_MODS\' ) &amp;&amp; DISALLOW_FILE_MODS ) return true;</code></p>\n<p>The code added by cPanel disables core WordPress updates, update notifications, and automatic background updates to point releases. Once Munson restored these files to their original version, automatic updates and notifications worked properly.</p>\n<h2>cPanel and cPAddons</h2>\n<p>Those who manage dedicated servers or virtual private servers with cPanel have the ability to use cPAddons. According to <a href=\"https://documentation.cpanel.net/display/1148Docs/Install+cPAddons\">cPanel documentation</a>, &#8220;Addons are applications that work with cPanel to perform functions for your users’ websites. Examples of these applications include bulletin boards, online shopping carts, and blogs.&#8221;</p>\n<h2>Open Dialogue With cPanel</h2>\n<p>George Stephanis, a WordPress core contributor and lead developer of Jetpack publicly called out cPanel&#8217;s actions as a bad practice.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Wait, seriously? <a href=\"https://twitter.com/cPanel\">@cPanel</a> is hacking WordPress core to prevent updates? I\'m kinda dumbfounded by how bad of an idea this is. <a href=\"https://twitter.com/hashtag/donthackcore?src=hash\">#donthackcore</a></p>\n<p>&mdash; George Stephanis (@daljo628) <a href=\"https://twitter.com/daljo628/status/597794481329590272\">May 11, 2015</a></p></blockquote>\n<p></p>\n<p>A representative of cPanel saw the tweet and responded that they&#8217;d like to receive more information.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/daljo628\">@daljo628</a> re: <a href=\"https://twitter.com/cPanel\">@cPanel</a> w/ <a href=\"https://twitter.com/WordPress\">@WordPress</a> we would like to get more info from you can you provide a email? Or email into sales @ cpanel dot net^MR</p>\n<p>&mdash; cPanel Cares (@cpanelcares) <a href=\"https://twitter.com/cpanelcares/status/597886956945711107\">May 11, 2015</a></p></blockquote>\n<p></p>\n<p>Stephanis <a href=\"http://stephanis.info/2015/05/14/please-dont-hack-core/\">engaged in a lengthy conversation</a> with cPanel representatives explaining why it&#8217;s a bad idea to disable core updates. cPanel disables WordPress&#8217; native update system because it could cause conflicts with cPanel&#8217;s Site Software version of WordPress.</p>\n<blockquote><p>We generally release the latest version of WordPress within 1 to 5 days of the latest WordPress update. At a minimum, server administrators are informed each night of all Site Software applications that need updated. It is up to users to configure their notifications within cPanel to receive such updates.</p>\n<p>The way our cPAddons tool tracks software is not compatible with the way WordPress updates, hence why we disable the auto-updates so we can track it through cPAddons.</p></blockquote>\n<p>cPanel goes on to explain how updates are handled for software installed using its Site Software cPAddon.</p>\n<ul>\n<li>Whenever WP releases a maintenance build that addresses security concerns, we react very quickly to get our software updated to be available to customers.</li>\n<li>By default, we define that software managed/installed through cPAddons is automatically updated when a new update is available.</li>\n<li>Based on the above information, if the server administrator leaves the defaults enabled, once WP introduces a maintenance release that corrects security concerns and we’ve tested and updated our source for it, customers will receive the release automatically.</li>\n<li>If the server administrator decides to disable automatic software updates, the end-user and systems administrator will still receive notifications that their installation is out of date accompanied with steps on how to update their application.</li>\n</ul>\n<p>By default, software installed by cPanel is configured to update automatically but some of Munson&#8217;s sites didn&#8217;t update. He also didn&#8217;t receive update notifications for those sites. cPanel believes there is something wrong with Munson&#8217;s server configuration and pledged to contact him to find out more information.</p>\n<blockquote><p>Based upon what Drumology2001 reported on the forum, it appears something is amiss on that server. We’d love to examine that server to determine why WordPress updates were not available to the user.</p>\n<p>Based upon the fuzzy dates used on the forum and compared with our internal records, the 4.1.1 update was available to the Site Software system prior to the initial post. We’ll reach out to him to determine whether there is anything we can do there.</p></blockquote>\n<h2>Receptive to Change</h2>\n<p>The good news is that cPanel is responsive and willing to make any necessary changes to improve the update process. Considering how many webhosting companies offer customers the ability to install WordPress with a one-click installer, it&#8217;s important that sites receive updates as soon as possible.</p>\n<p>If you installed WordPress through cPanel&#8217;s one-click installer, check to make sure your site is running WordPress 4.2.2 which is the latest stable version.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 May 2015 19:45:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WPTavern: All Sessions from LoopConf Now Available on YouTube\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43528\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wptavern.com/all-sessions-from-loopconf-now-available-on-youtube\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4590:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/loopconf-2015.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/loopconf-2015.jpg?resize=1016%2C506\" alt=\"photo credit: LoopConf\" class=\"size-full wp-image-43769\" /></a>photo credit: <a href=\"https://twitter.com/loopconf/status/598233226407088128/photo/1\">LoopConf</a>\n<p><a href=\"https://loopconf.io/\" target=\"_blank\">LoopConf</a>, a new WordPress conference created for developers, was held in Las Vegas last week with a world-class lineup of speakers. The event was such a success that the organization team is already planning for 2016.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/hashtag/loopconf?src=hash\">#loopconf</a> 2016?! We’ve committed to year 2 and are already making plans! Get on the super early interest list here: <a href=\"http://t.co/23y5pL4qWv\">http://t.co/23y5pL4qWv</a></p>\n<p>&mdash; LoopConf (@loopconf) <a href=\"https://twitter.com/loopconf/status/598620705605844992\">May 13, 2015</a></p></blockquote>\n<p></p>\n<p>Attendees were impressed with the professional planning of the event, speaker selection, and the quality of the venue.</p>\n<p>&#8220;I&#8217;m going to say, with emphasis, what I think everyone is probably thinking: LoopConf is what you wish most WordCamps were,&#8221; Speaker and attendee John James Jacoby said in his <a href=\"http://jaco.by/2015/05/14/loopconf/\" target=\"_blank\">writeup</a>.</p>\n<p>&#8220;I like that WordCamps are casual and inviting, and I like that conferences like <a href=\"http://loopconf.io/\" target=\"_blank\">LoopConf</a> and the <a href=\"http://vip.wordpress.com/\" target=\"_blank\">WordPress.com VIP Workshop</a> strive to achieve something more professional. I think there will be some WordCamps that try to upgrade themselves to compete, and others that will purposely stay intimate and niche,&#8221; Jacoby predicted.</p>\n<p>The entire <a href=\"http://www.woothemes.com/2015/05/woothemes-loopconf/\" target=\"_blank\">WooCommerce development team was also in attendance at LoopConf</a> and <a href=\"https://twitter.com/BFTrick\" target=\"_blank\">Patrick Rauland</a> found interacting with other developers from the community to be the highlight.</p>\n<p>&#8220;The biggest takeaway that I got from Loop was that conferences are about people,&#8221; he said. &#8220;Not that cheesy networking where you try to meet as many people as possible. It’s about meeting people and really getting to know them.&#8221;</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/loopconf-party.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/loopconf-party.jpg?resize=1016%2C632\" alt=\"LoopConf attendees at the SiteGround party - credit: LoopConf\" class=\"size-full wp-image-43771\" /></a>LoopConf attendees at the SiteGround party &#8211; credit: <a href=\"https://twitter.com/loopconf/status/598237685518499842/photo/1\">LoopConf</a>\n<p>Those who could not attend may have missed out on the networking, but videos for all of the sessions are now <a href=\"https://www.youtube.com/channel/UCAwOVsWiMdlz6snWRF2HdSQ\" target=\"_blank\">available on YouTube</a>. One favorite session among attendees was Andrew Nacin&#8217;s presentation on <a href=\"https://www.youtube.com/watch?v=yQaRUEwEKxE\" target=\"_blank\">The Anatomy of a Critical Security Bug</a>, during which he revealed that the Emoji support added in WordPress 4.2 was also part of a larger plan to fix a <a href=\"https://poststatus.com/the-trojan-emoji/\" target=\"_blank\">two-year old security vulnerability</a>.</p>\n<p>Attendees also enjoyed <a href=\"https://ghost.org/\" target=\"_blank\">Ghost</a> founder John O&#8217;Nolan&#8217;s session on <a href=\"https://www.youtube.com/watch?v=9p3nT4ujUk8\" target=\"_blank\">The Economics of Open Source</a>, Ryan McCue&#8217;s &#8220;<a href=\"https://www.youtube.com/watch?v=DyTeLjsopC4\" target=\"_blank\">How to Build a REST API for 23 Percent of the Web</a>,&#8221; and Google engineer Ilya Grigorik&#8217;s <a href=\"https://www.youtube.com/watch?v=CceyqktMoRw\" target=\"_blank\">Performance Guide RAIL</a> keynote presentation. If you have some free time to devote to improving your development knowledge, the LoopConf videos make up a small library of advanced learning on a variety technical topics.</p>\n<p>LoopConf attracted 210 attendees as a brand new WordPress event this year. Glowing accounts of its professional handling are likely to increase attendees next year. LoopConf 2016 is already in the planning stages, but the location is yet to be decided.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 May 2015 19:05:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WPWeekly Episode 192 – Infinite Possibilities With Dan Griffiths\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=43747&preview_id=43747\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://wptavern.com/wpweekly-episode-192-infinite-possibilities-with-dan-griffiths\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3306:\"<p>In this episode of WordPress Weekly, <a href=\"http://marcuscouch.com/\">Marcus Couch</a> and I are joined by <a href=\"https://profiles.wordpress.org/section214/\">Dan Griffiths</a>, founder of <a href=\"https://section214.com/\">Section214</a>. We spend the first half of the show learning about Griffiths&#8217; interest in technology at a young age.</p>\n<p>Once out of the military, Griffiths experienced difficulties finding a job. He discovered Easy Digital Downloads and explains how working on a ticket and creating an API led to getting a job offer from <a href=\"https://pippinsplugins.com/\">Pippin Williamson</a>. Since accepting the job offer, Griffiths has <a href=\"https://profiles.wordpress.org/section214/#content-plugins\">published 22 plugins</a> to the WordPress plugin directory and has attended several WordCamps.</p>\n<p>Later in the show, we discuss <a href=\"http://wptavern.com/dan-griffiths-launches-175k-crowdfunding-campaign-to-build-hostpress\">HostPress</a>, an open-source, extensible server control panel built on top of WordPress. He describes his motivation behind the project and why he thinks webhosts need a better solution. Near the end of the interview, Griffiths shares his thoughts on the WP REST API that will eventually be added to WordPress and what it means for the project&#8217;s future.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://heropress.com/heros-are-found-in-unexpected-places/\">Heroes Are Found In Unexpected Places </a><br />\n<a href=\"http://wptavern.com/wordpress-4-3-to-focus-on-mobile-experience-admin-ui-better-passwords-and-customizer-improvements\">WordPress 4.3 to Focus on Mobile Experience, Admin UI, Better Passwords, and Customizer Improvements</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/wp-rollback/\">WP Rollback</a> lets you quickly and easily rollback any theme or plugin from WordPress.org to any previous or newer version. It works just like the plugin updater, except you&#8217;re rolling backward or forward to a specific version. Be sure to read our <a href=\"http://wptavern.com/wp-rollback-provides-basic-versioning-for-wordpress-org-plugins-and-themes\">review of WP Rollback</a> on the Tavern.</p>\n<p><a href=\"https://wordpress.org/plugins/linkedin-oauth/\">Linkedin_Oauth</a> allows users to login and register into WordPress using their LinkedIn account.</p>\n<p><a href=\"https://wordpress.org/plugins/strong-password-generator/\">Strong Password Generator</a> created by <a href=\"https://profiles.wordpress.org/fjarrett/\">Frankie Jarrett</a>, encourages the use of strong passwords by helping users generate them easily.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, May 20th 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #192:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 May 2015 07:19:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Wearable Gadgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45048\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2015/05/wearable-gadgets/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:351:\"<p><a href=\"http://www.washingtonpost.com/sf/national/2015/05/09/the-revolution-will-be-digitized/\">Wearable gadgets portend vast health, research and privacy consequences</a>, the Washington Post takes on the quantified self. I&#8217;m in the medium end of this, I track pretty much everything that&#8217;s easy, but no blood / hormone tests yet.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 May 2015 05:04:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: WP Engine Rolls Out WP-CLI Support to Select Partners for Beta Testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43693\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wptavern.com/wp-engine-rolls-out-wp-cli-support-to-select-partners-for-beta-testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3885:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/wp-engine.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/wp-engine.jpg?resize=1025%2C427\" alt=\"wp-engine\" class=\"aligncenter size-full wp-image-34106\" /></a></p>\n<p><a href=\"http://wpengine.com/\" target=\"_blank\">WP Engine</a> is currently beta testing <a href=\"http://wp-cli.org/\" target=\"_blank\">WP-CLI</a> support with approximately 200 select partners. Those who serve clients that host with the company are eager to see it rolled out to more customers, as WP-CLI has become an indispensable part of many WordPress developers&#8217; workflow.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">WP-CLI on <a href=\"https://twitter.com/wpengine\">@wpengine</a>!  From the entire WordPress Community, THANK YOU!!!!!</p>\n<p>&mdash; Brad Williams (@williamsba) <a href=\"https://twitter.com/williamsba/status/598526319253663744\">May 13, 2015</a></p></blockquote>\n<p></p>\n<p>&#8220;We find that with technical products it’s often better to roll out to development partners who we have a prior working relationship with, to get candid feedback from highly technical folks, and thus build a better product before rolling to a wider audience,&#8221; founder <a href=\"http://blog.asmartbear.com/\" target=\"_blank\">Jason Cohen</a> told the Tavern.</p>\n<p>There is no set timeframe for beta, but Cohen said that the plan is to offer WP-CLI support to all customers on all plans.</p>\n<p>&#8220;Our timeframe for exiting beta is like one of the rules of Fight Club: &#8216;The beta goes on for as long as it has to,\'&#8221; he said. &#8220;If everything is smooth and few issues arise, we can roll faster, but if we find things we want to fix, it will take longer. <span class=\"pullquote alignleft\">The main thing is to release high quality product, not to release it as quickly as possible.</span>&#8221;</p>\n<p>Many other hosting companies that cater to WordPress customers, such as Bluehost, SiteGround, and Site5, have had <a href=\"http://wptavern.com/hosting-companies-that-have-wp-cli-pre-installed\" target=\"_blank\">WP-CLI pre-installed</a> for years, which makes it curious that WP Engine has taken so long to add support for it. Cohen says that it&#8217;s trickier when you plan to offer it to all customers.</p>\n<blockquote><p>Some of our competitors offer WP-CLI only on dedicated plans, not on shared plans, whereas we offer it on all plans. An example of why it’s tricker: there are security implications (e.g. when running system commands outside of the PHP sandbox, which many WP-CLI commands do) in a multi-tenant system that are less of a concern in a dedicated system. We wanted to take the time to get all that right.</p></blockquote>\n<p>Cohen said that it wasn&#8217;t hard to come to the decision to support WP-CLI but WP Engine has been concurrently working on launching other technical tools. Most recently, the company has been focusing on polishing <a href=\"http://wptavern.com/wp-engine-partners-with-10up-to-launch-enterprise-hhvm-wordpress-hosting-platform\" target=\"_blank\">Mercury</a>, its enterprise HHVM hosting platform, which launched last year.</p>\n<p>&#8220;We’ve been building and releasing features that no one else has,&#8221; Cohen said. &#8220;So, sometimes we’re first-out with a feature, and sometimes not. That seems natural in a market with a dozen good competitors, all innovating in the space.&#8221;</p>\n<p>Development partners who have been granted access to WP-CLI during the beta period can find a <a href=\"http://wpengine.com/support/known-issues-in-wp-cli-in-user-portal/\" target=\"_blank\">list of known issues</a> in the WP Engine documentation, which includes a list of commands that are currently not supported. Documentation will be updated throughout the beta period to reflect progress on issues reported by testers.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 13 May 2015 23:51:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: WP Rollback Provides Basic Versioning for WordPress.org Plugins and Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43696\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wptavern.com/wp-rollback-provides-basic-versioning-for-wordpress-org-plugins-and-themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4615:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/undo-button.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/undo-button.jpg?resize=1025%2C506\" alt=\"The undo key from a computer keyboard\" class=\"size-full wp-image-43721\" /></a>The undo key from a computer keyboard\n<p>Despite the recent proliferation of plugins that add git-based version control to WordPress, your average user does not require a full-blown version control system as part of regular site management. Developers can certainly benefit from tools like <a href=\"http://wptavern.com/free-revisr-plugin-offers-git-management-for-wordpress\" target=\"_blank\">Revisr</a> and <a href=\"http://wptavern.com/gitium-provides-automatic-git-version-control-and-deployment-for-wordpress-plugins-and-themes\" target=\"_blank\">Gitium</a> for managing projects with Git, but the vast majority of WordPress users are more likely to benefit from a simple &#8220;undo&#8221; button for mistakes or bad updates.</p>\n<p><a href=\"https://wordpress.org/plugins/wp-rollback/\" target=\"_blank\">WP Rollback</a> is a new plugin that brings the concept of an &#8220;undo&#8221; button to updates for plugins and themes hosted on WordPress.org. It allows users to easily rollback to any previous (or newer) version without the hassle of manually downloading files.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wp-rollback.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/wp-rollback.jpg?resize=925%2C228\" alt=\"wp-rollback\" class=\"aligncenter size-full wp-image-43711\" /></a></p>\n<p>Clicking the Rollback link will take the user to a screen where he can select from a list of previous versions or update to newer ones.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/wp-rollback-versions-screen.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/wp-rollback-versions-screen.jpg?resize=576%2C437\" alt=\"wp-rollback-versions-screen\" class=\"aligncenter size-full wp-image-43712\" /></a></p>\n<p>WP Rollback uses WordPress&#8217; native plugin updater to revert to previous versions.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wp-rollback-update.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wp-rollback-update.jpg?resize=556%2C304\" alt=\"wp-rollback-update\" class=\"aligncenter size-full wp-image-43714\" /></a></p>\n<p>While using older versions of themes/plugins is not generally encouraged, there are times when it&#8217;s unavoidable. For example, some plugin authors routinely push out buggy updates, seemingly without having run any tests on them, and then rely on their users to discover and report the problems. It can sometimes be 24 &#8211; 72 hours before the author has the chance to push out a fix to the buggy update. WP Rollback allows users to quickly revert to the previous working version of the plugin.</p>\n<p>As themes hosted on WordPress.org <a href=\"http://wptavern.com/do-wordpress-org-themes-need-a-changelog\" target=\"_blank\">do not yet have change logs</a>, there may be times when a user updates to a new version of a theme where the author has made some major changes to the markup and/or styles. Without a changelog, the user has no idea what is included in the update or how it might impact a child theme or plugin&#8217;s output. WP Rollback gives you the ability to test a theme update and quickly rollback if necessary until you&#8217;ve had the chance to get your site ready.</p>\n<p>Most WordPress users do not have a development environment in place for putting software updates to the test before rolling them out. They simply expect updates to work, but there will always be those rare instances of unforeseen conflicts and bugs. Having WP Rollback in place should help users to be less wary about taking updates, since they know they can easily rollback if something goes wrong.</p>\n<p><a href=\"https://wordimpress.com/\" target=\"_blank\">WordImpress</a>, the folks behind WP Rollback as well as the new <a href=\"http://wptavern.com/give-a-new-free-donations-plugin-for-wordpress\" target=\"_blank\">Give plugin</a>, encourages users to backup their sites before performing plugin/theme updates or reverts. Ideally, you would test any changes in a development environment first to ensure that everything works as planned. <a href=\"https://wordpress.org/plugins/wp-rollback/\" target=\"_blank\">WP Rollback</a> is available for free on WordPress.org and <a href=\"https://github.com/WordImpress/WP-Rollback/wiki\" target=\"_blank\">documentation can be found on GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 13 May 2015 19:34:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Matt: Advanced Hindsight\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45039\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://ma.tt/2015/05/advanced-hindsight/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:612:\"<blockquote><p>Beginning with the 2015 academic year, the Center for Advanced Hindsight (CAH) at Duke University will invite promising startups to join its behavioral lab and leverage academic research in their business models. The Center is housed within the Social Science Research Institute at Duke University and is led by Professor Dan Ariely, Professor of Psychology and Behavioral Economics at Duke University.</p></blockquote>\n<p><a href=\"http://danariely.com/2015/05/08/announcing-cah-startup-lab/\">This is a pretty awesome opportunity for entrepreneurs</a>, I hope a reader of this blog pursues it.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 13 May 2015 04:19:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"WPTavern: Major Changes to WordPress.org Guidelines Should Have a Request for Comments Time Period\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43595\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://wptavern.com/major-wordpress-org-guideline-changes-should-have-a-request-for-comments-time-period\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7603:\"<p>For the last three years, the <a href=\"https://make.wordpress.org/themes/\">WordPress Theme Review Team</a> has tried to encourage theme authors to adopt the Theme Customizer. In April, the decision was made by the TRT to no longer encourage, but <a href=\"https://make.wordpress.org/themes/2015/04/22/details-on-the-new-theme-settings-customizer-guideline/\">require</a> all theme options to be in the customizer. Although the decision was three years in the making, the community didn&#8217;t have an opportunity to provide feedback until <strong>after</strong> the requirement was put in place.</p>\n<h2>The Timeline</h2>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/07/EstimatedReadingTimeFeaturedImage.png\"><img class=\"size-full wp-image-25719\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/07/EstimatedReadingTimeFeaturedImage.png?resize=639%2C200\" alt=\"Estimated Reading Time Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/eyesplash/8467316141/\">Eyesplash &#8211; let&#8217;s feel the heat</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a>\n<p>Those who follow the official <a href=\"https://make.wordpress.org/themes/\">TRT blog</a> likely saw the writing on the wall. With the <a href=\"https://wordpress.org/news/2012/06/green/\">release of WordPress 3.4</a> in 2012, which introduced the theme customizer, the TRT held discussions on <a href=\"https://make.wordpress.org/themes/2012/05/08/proposed-wordpress-3-4-guidelines-revisions/\">proposed changes</a> to the theme review guidelines. One of the proposed changes <strong>recommended</strong> theme options be incorporated into the theme customizer. Of particular interest is <a href=\"https://make.wordpress.org/themes/2012/05/08/proposed-wordpress-3-4-guidelines-revisions/#comment-19516\">a conversation</a> between Justin Tadlock and Chip Bennett on whether or not the customizer should be recommended so early.</p>\n<p>In November of 2014, the team <a href=\"https://make.wordpress.org/themes/2014/11/04/todays-meeting-agenda-ive-gone-back-all-comments/\">held a meeting</a> to discuss modifications to the theme review guidelines. Up until this point, theme authors were allowed to create theme options in one of three ways, Theme Customizer, Settings API, or with custom options pages using the Theme Mods API.</p>\n<p>During the meeting, <a href=\"https://wordpress.slack.com/archives/themereview/p1415124589001969\">Tadlock suggested</a> that the team should <strong>strongly recommend</strong> theme authors to use the customizer. Members in attendance agreed and the theme review guidelines changed to <a href=\"https://make.wordpress.org/themes/2014/04/03/wordpress-3-9-guidelines-revision-proposal-round-2/\">strongly recommend</a> theme options be placed into the customizer.</p>\n<p>A few days after the meeting, Tadlock published a post asking <a href=\"https://make.wordpress.org/themes/2014/11/11/how-do-we-solve-the-theme-options-problem/\">how do we solve the theme options problem</a>? He highlights the lack of educational resources on the customizer as one of the major culprits of its slow adoption.</p>\n<blockquote><p>One of the things I’ve always hoped the TRT would become is more of an educational team. I firmly believe that if we didn’t have to spend so much time dealing with theme options, we could spend more time on educating in other areas of the dev/design.</p>\n<p>I’m writing this post because I believe this to be the biggest hangup with themes today. It’s the hardest part of the review process. It’s also one of the most critical because theme options means potential security issues.</p></blockquote>\n<p>The post opened up a dialogue to discuss ways of dealing with several issues related to getting developers to adopt and use the customizer. Bennett <a href=\"https://make.wordpress.org/themes/2014/11/24/understanding-the-apis-related-to-theme-options/\">published a post a few days later</a> that explained APIs related to theme options. It was later followed up by Tadlock with a post on <a href=\"https://make.wordpress.org/themes/2014/11/26/customizer-theme-mods-api-or-settings-api/\">choosing Theme Mods API or Settings API</a>.</p>\n<h2>The Vote</h2>\n<p>Fast forward to April 2015, the team <a href=\"https://wordpress.slack.com/archives/themereview/p1429639190005379\">held a meeting</a> and unanimously agreed to require theme authors to place theme options into the customizer. A day later, <a href=\"https://make.wordpress.org/themes/2015/04/22/details-on-the-new-theme-settings-customizer-guideline/\">Tadlock explained</a> why the change was made and how the team came to its decision.</p>\n<blockquote><p>First, I want to say that the team did not take this decision lightly nor did we make it quickly. In fact, this has been an ongoing discussion for nearly 3 years (since the customizer was first introduced in core). Many of us had originally hoped that we could take a more organic approach to this and allow theme authors to naturally make the switch on their own given enough time.</p></blockquote>\n<p>The decision created a <a href=\"http://wptavern.com/wordpress-org-now-requires-theme-authors-to-use-the-customizer-to-build-theme-options#comments\">passionate, lengthy conversation</a> with several people chiming in <em>after the fact</em> on WP Tavern.</p>\n<h2>A Request for Comments Period</h2>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/03/FutureOfCommentingFeaturedImage.png\"><img class=\"size-full wp-image-18515\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/03/FutureOfCommentingFeaturedImage.png?resize=638%2C200\" alt=\"Future Of Commenting Featured Image\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/marcwathieu/2945514734/\">Marc Wathieu</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc/2.0/\">cc</a>\n<p>On the TRT blog, there are several blog posts that encourage feedback, especially on guideline proposals. In this instance however, feedback, concerns, and criticism weren&#8217;t encouraged until after the decision was made.</p>\n<p>The TRT usually <a href=\"https://make.wordpress.org/themes/2015/04/13/weekly-meeting-agenda-this-week-weve-got-our-2/\">publishes an agenda</a> that highlights what topics will be discussed during the meeting. An agenda was published for the April 14th meeting but not for the April 21st meeting. This means only those in attendance were able to voice an opinion and vote on the issue, as there was no advance notice.</p>\n<p>I understand the team has discussed this change for the last three years, but I would like to have seen a request for comments period for at least a month on the TRT blog.</p>\n<p>This way, people could comment on the decision before it was implemented. The team could have controlled the conversation, provided a more accessible way of participating in the discussion versus Slack, and heard legitimate concerns from theme developers.</p>\n<p>I hope major changes like this in the future are addressed in a way where the public can be more involved. The notion that concerned parties should have been in Slack during the meeting to voice concerns before the decision was made is unacceptable. People have things to do and while I think Slack is easier to use than IRC, a blog post with a comment form is accessible to a lot more people.</p>\n<p>An RFC period doesn&#8217;t make sense for a lot of what takes place in the world of WordPress development but a change that affects current, past, and future themes in the directory is a great example of where it does makes sense.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 12 May 2015 22:10:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"WPTavern: Customizer Theme Resizer Plugin Offers Live Previews of Your Site on Mobile Devices\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43599\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://wptavern.com/customizer-theme-resizer-plugin-offers-live-previews-of-your-site-on-mobile-devices\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3729:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/customizer-theme-resizer.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/customizer-theme-resizer.jpg?resize=650%2C300\" alt=\"customizer-theme-resizer\" class=\"aligncenter size-full wp-image-43646\" /></a></p>\n<p>Contributors on the <a href=\"http://wptavern.com/wordpress-4-3-to-focus-on-mobile-experience-admin-ui-better-passwords-and-customizer-improvements\" target=\"_blank\">upcoming WordPress 4.3 release</a> are moving full speed ahead with plans to improve the experience of using the customizer. They&#8217;re also exploring ways to re-architect it to make way for feature plugins that would bring in additional functionality.</p>\n<p>WordPress core contributors have continually demonstrated a commitment to improving the customizer to make it better for everyone, and the Theme Developer Handbook was recently <a href=\"http://wptavern.com/wordpress-theme-developer-handbook-updated-with-comprehensive-guide-to-the-customizer-api\" target=\"_blank\">updated with a comprehensive guide to using the Customizer API</a>. Plugin developers are also finding new ways to <a href=\"https://wordpress.org/plugins/tags/customizer\" target=\"_blank\">extend the customizer</a> to support the increasing number of users who depend on it for live previews.</p>\n<p><a href=\"https://wordpress.org/plugins/customizer-theme-resizer/\" target=\"_blank\">Customizer Theme Resizer</a> is a new plugin that is immensely useful for previewing your site on various mobile devices while adjusting options in the customizer. The plugin was created by Japanese web developer <a href=\"https://profiles.wordpress.org/webnist/\" target=\"_blank\">Tatsuki Ohta</a>, who has 10 other extensions listed in the official directory. It allows you to review your design for responsiveness without having to leave the customizer panel.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/customizer-theme-resizer-screenshot.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/customizer-theme-resizer-screenshot.jpg?resize=905%2C561\" alt=\"customizer-theme-resizer-screenshot\" class=\"aligncenter size-full wp-image-43648\" /></a></p>\n<p>Customizer Theme Resizer offers nine preset mobile phone/tablet display options, or you can manually add your own screen dimensions. You can also easily switch between portrait or landscape mode.</p>\n<p>The plugin works seamlessly within the customizer, so you can set it to iPhone 6, for example, and live preview any of your design choices on that device. This is especially helpful when uploading a site logo or a header image if you want to see how those images resize down for devices. It keeps you from having to go back and forth while making adjustments and testing responsiveness on your phone or simulator.</p>\n<p>I tested the plugin and found that it works as advertised. You can see a quick overview of how it works in the video below:</p>\n<p><span class=\"embed-youtube\"></span></p>\n<p>As a result of the WordPress.org Theme Review Team&#8217;s decision to <a href=\"http://wptavern.com/wordpress-org-now-requires-theme-authors-to-use-the-customizer-to-build-theme-options\" target=\"_blank\">enforce the use of the customizer for theme options</a>, more themes will be moving to support the customizer ahead of the deadline to comply. The Customizer Theme Resizer plugin is a handy tool to use in conjunction with any theme that supports the customizer. Install the <a href=\"https://wordpress.org/plugins/customizer-theme-resizer/\" target=\"_blank\">Customizer Theme Resizer</a> plugin from WordPress.org the next time you want to live preview the mobile-friendliness of your design adjustments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 12 May 2015 21:52:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: 3 Big Things that Will Happen to WordPress in the Near Future\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43611\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://wptavern.com/3-big-things-that-will-happen-to-wordpress-in-the-near-future\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6711:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/petersuhm.jpeg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/05/petersuhm.jpeg?resize=150%2C150\" alt=\"petersuhm\" class=\"alignright size-thumbnail wp-image-43613\" /></a>This opinion piece was contributed by guest author <a href=\"https://twitter.com/petersuhm\" target=\"_blank\">Peter Suhm</a>. Peter is a web developer from the Land of the Danes. He is the creator of <a href=\"https://wppusher.com/\" target=\"_blank\">WP Pusher</a> and a huge travel addict, bringing his work along with him as he goes.<br />\n&nbsp;</p>\n<hr />\n<h3>Yet another WordPress prophecy</h3>\n<p>Okay, I admit that the title of this post is a bit risky. Honestly, it should probably have been &#8220;3 Big Things That I Wholeheartedly Hope Will Happen To WordPress In The Not Too Distant Future&#8221;. That being said, I am optimistic by nature, and I actually think these three ideas are realistic scenarios. So in all modesty, and without further ado, here is my take on some of the next big things to happen in the WordPress world in the near future.</p>\n<h1>WordPress Will Have Dependency Management</h1>\n<p>There is no question about it. WordPress needs some sort of dependency management mechanism. We have seen all other fragments of the PHP community, and other languages too, adopt the use of dependency managers. Most likely, WordPress will adopt <a href=\"https://getcomposer.org/\" target=\"_blank\">Composer</a> in some form, either out-of-the-box or by configuration.</p>\n<h3>What is a dependency manager?</h3>\n<p>A dependency manager is a software tool that can resolve and manage the dependencies (other libraries) that a given library requires. In PHP we have Composer. Each PHP library that supports Composer will have a defined set of dependencies that it depends on. The role of Composer is to fetch all these dependencies and make sure they are all compatible with each other.</p>\n<h3>… and why does WordPress need one?</h3>\n<p>WordPress needs one so we do not have to reinvent the wheel every time we want to make a new plugin or theme. Every time we write code for WordPress when we could have used one of the existing PHP packages out there, we are essentially wasting our time. Allowing the use of third-party dependencies allows for much more rapid development and better security. So many security issues in WordPress plugins are the same ones showing up again and again.</p>\n<h3>What does this mean for you?</h3>\n<p>In the short run, for plugin developers, WordPress adopting a dependency manager will mean a huge opportunity for making WordPress specific plugins for all the existing PHP libraries out there. When this happens, we will see hundreds, if not thousands, of plugins that will just be WordPress wrappers around existing libraries. Some of these plugins will end up becoming very popular. So be ready if you are an upcoming plugin author!</p>\n<p>WordPress developers will probably also have to deal with some sort of frontend dependency manager, since, with the <a href=\"http://wp-api.org/\" target=\"_blank\">WP REST API</a>, a lot of things will be revolutionized on the frontend side of things. We will touch more on that in the next section.</p>\n<h1>WordPress Will Be “Just” a Backend</h1>\n<p>This is not my idea, but I am certain this is the way we are moving. With the WP REST API in core, WordPress will essentially be a backend, complete with user management and so forth, for your API-based web application. Themes are going to be JavaScript based and will communicate with WordPress through the API. Plugins will stay mainly PHP, with a dash of JavaScript, just as the backend itself will.</p>\n<p>I believe that a main reason for WordPress’ widespread success is the dashboard. It is extremely user friendly and intuitive. Add to that how simple and easy it is to add 3rd party plugins and themes and you have a winner. Extending core is also really trivial because of all the actions and filters that WordPress has built in. There is no way that the WP REST API is going to change this. It is simply adding an extra layer for frontend developers, and most likely, radically changing how we work with theming.</p>\n<p>A few years ago, I worked as a full time Ruby on Rails developer. For one project, we needed some kind of CMS to manage the content of our Rails app. One of the developers (a hardcore Ruby guy) suggested using the WordPress dashboard as a backend and just build a simple API around it. We never ended up doing that, but imagine how easy that would be to implement had the API been around at the time.</p>\n<h3>What does this mean for you?</h3>\n<p>If you are a WordPress theme developer, this means that in the future you will probably not be a WordPress developer any more. You will “just” be a theme developer. You better up those JavaScript skills before this happens.</p>\n<h1>WordPress Will Become More Decoupled</h1>\n<p>As a result of all this, WordPress will become a lot more decoupled. Obviously, the biggest cut will be between the backend (dashboard and plugins) and the front end (themes). It is also easy to imagine, with an adaptation of Composer, that core itself will become a lot more decoupled. Maybe similar to how the Laravel framework is split up into the Illuminate packages (now we will have to define what “near future” means, though).</p>\n<p>As already mentioned, the main component will be the dashboard. Plugins makes sense to keep as a part of the dashboard, but in the future, they might look more like WordPress-specific Composer packages. It makes sense to keep all this in PHP &#8211; of course with a bit of JavaScript here and there.</p>\n<p>Another thing to consider is that if Composer is adopted in the near future, that would naturally mean an upgrade of the minimum required PHP version. That will probably happen very soon, anyways. We might see some sort of frontend plugins as well, but these will be JavaScript and be managed through a frontend dependency management tool.</p>\n<h3>What does this mean for you?</h3>\n<p>This means that if you are a WordPress plugin developer, you can keep writing good old PHP code. No need to jump straight over to NodeJS, yet, but if you are a theme developer, you might want to keep an eye on what those guys are up to.</p>\n<p>It also means that WordPress is going to be much more decoupled and customizable. You will be able to pick the parts you need and skip the rest. If you need something different, you will most likely be able to find an existing PHP package that can do the job. Sounds good, right?</p>\n<p>These are my 5 cents. I am curious to hear what you think. Where is WordPress headed?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 12 May 2015 18:15:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"WPTavern: BuddyPress 2015 Survey Shows Increase in English-Speaking Communities and Commercial Theme Usage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43531\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:116:\"http://wptavern.com/buddypress-2015-survey-shows-increase-in-english-speaking-communities-and-commercial-theme-usage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6558:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/2015-bp-survey-results.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/2015-bp-survey-results.jpg?resize=1025%2C576\" alt=\"2015-bp-survey-results\" class=\"aligncenter size-full wp-image-43580\" /></a></p>\n<p>The <a href=\"https://buddypress.org/2015/05/2015-buddypress-survey-results/\" target=\"_blank\">BuddyPress 2015 survey results</a> are now available. This year&#8217;s survey did not have the same community penetration as <a href=\"http://wptavern.com/7-surprising-results-from-the-2013-buddypress-codex-survey\" target=\"_blank\">2013</a> and <a href=\"https://buddypress.org/2014/03/2014-buddypress-survey-results/\" target=\"_blank\">2014</a>, with 37.5% fewer respondents, but the information is still valuable for gauging how and where people are using the plugin. Volunteers collected feedback from 211 participants in 42 different countries.</p>\n<p>Feedback this year shows a few significant shifts from previous years, especially when it comes to languages used on BuddyPress sites. The top three languages in 2015 are English (69.23%), French (10.26%), and German (7.69%). In <a href=\"http://wptavern.com/7-surprising-results-from-the-2013-buddypress-codex-survey\" target=\"_blank\">2013</a>, language usage was fairly evenly divided between English (56%) and non-English sites.</p>\n<p>On the surface, the language results seem to indicate a shrinking international community, but it may be due to the fact that the survey lost participants from 20 countries captured the previous year.</p>\n<h3>Commercial BuddyPress Themes are on the Rise</h3>\n<p>Results indicate that 34% of community managers and developers surveyed are building BuddyPress sites with commercial WordPress themes that offer custom BP CSS and/or template modifications. That number is up from 26% the previous year, likely due to more BuddyPress themes entering the market.</p>\n<p>Accessing BuddyPress sites via mobile is also slowly on the rise with 63% of respondents reporting that they&#8217;ve used a smartphone to access their sites. It&#8217;s no surprise that the survey shows mobile responsiveness is one of the most important factors in theme selection.</p>\n<p>Other preferred BuddyPress theme features include compatibility with the latest BP version and a light/fresh design. This preference may be due to kinds of sites that users are building, which remain fairly unchanged from previous years:</p>\n<ul>\n<li>Generic (26.32%)</li>\n<li>Academic (23.31%)</li>\n<li>Artistic (12.03%)</li>\n<li>Sports (11.65%)</li>\n<li>Gaming (10.53%)</li>\n<li>Scientific (8.27%)</li>\n<li>Religious (6.77%)</li>\n<li>Travel (0.75%)</li>\n<li>Health (0.38%)</li>\n</ul>\n<h3>Extended Profiles and Activity Streams Remain the Most Used BuddyPress Components</h3>\n<p>Results show that the most used BuddyPress components are Extended Profiles (71.13%) and Activity Streams (66.49%), followed by User Groups (57.22%). Although Profiles and Activity remain dominant, they are waning slightly from the previous year while Groups are increasing in popularity.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/bp-components-usage.png\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/05/bp-components-usage.png?resize=1025%2C881\" alt=\"bp-components-usage\" class=\"aligncenter size-full wp-image-43575\" /></a></p>\n<p>Surprisingly, Friend Connections, which are often associated with social networks, rank quite low on the list of components, trailing Messaging, Notifications, and Account Settings. Site Tracking, a feature used most often with multisite, ranks dead last among components that are always activated at just 8.25%.</p>\n<p>If you take a look at the features on track for <a href=\"http://wptavern.com/buddypress-2-3-beta-1-is-ready-for-testing\" target=\"_blank\">BuddyPress 2.3</a>, the direction of development seems to be trending toward improving the components that users are mostly likely to activate. Last year&#8217;s major performance improvements <a href=\"http://wptavern.com/buddypress-2-0-ramps-up-performance-reduces-footprint-by-up-to-75\" target=\"_blank\">reduced BuddyPress&#8217; footprint by up to 75%</a> in many places, especially for sites that rely on activity and member directories.</p>\n<p>The recent additions of the <a href=\"http://wptavern.com/buddypress-2-2-spumoni-released-featuring-new-member-type-api\" target=\"_blank\">Member Types API</a> and upcoming <a href=\"http://wptavern.com/buddypress-2-3-will-improve-avatar-uploads-with-the-new-bp-attachments-api\" target=\"_blank\">Attachments API</a> greatly improve the extensibility of components that BuddyPress site administrators are most frequently using. The survey results confirm that BP core development is being shaped by community feedback and overall the software is improving for those that are actively using it.</p>\n<p>The anonymous comments on the survey provide some critical feedback that indicate it may be time for BuddyPress contributors to reconsider how the software is presented to the world. One respondent feels that the tagline &#8220;social networking in a box&#8221; is inaccurate, given recent developments in other social networking software:</p>\n<blockquote><p>BuddyPress is some distance behind the features people now expect of modern social networks. OK for school, or small intranet purposes, but to call it &#8216;social networking in a box&#8217; is slightly stretching reality.</p></blockquote>\n<p>BuddyPress also continues to be somewhat daunting for beginners. Developers can be sold on its extensibility, but your average user trying to set up a social network will have a sharp learning curve when it comes to adding features beyond what is offered in BP core. That frustration, when it comes to extending the software, seems to make its way into users&#8217; opinions of BuddyPress in general.</p>\n<blockquote><p>I&#8217;ve been trying to learn BuddyPress for about a year. Setup is super easy. Mods are always a pain. I understand this has to do with community support. Everybody wants answers. Few pitch in to help.</p></blockquote>\n<p>This year&#8217;s survey results and user feedback provide BuddyPress core contributors and volunteers with some important ideas to consider for shaping both development and community support in the future. The full results of the survey are <a href=\"https://mercime.github.io/BuddyPress-2015-survey-results/\" target=\"_blank\">available on GitHub</a> with a more detailed breakdown and charts for each question.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 11 May 2015 19:31:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Matt: New Yorker on Marc Andreessen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45044\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://ma.tt/2015/05/new-yorker-on-marc-andreessen/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:371:\"<p>Tad Friend has a <a href=\"http://www.newyorker.com/magazine/2015/05/18/tomorrows-advance-man\">great New Yorker profile of Marc Andreessen</a>, one of my favorite people to debate and talk to (though it happens all too rarely). Check out <a href=\"http://pmarcasays.golaun.ch/\">Pmarca Says</a> if you want to catch up on some of his recent thinking from tweetstorms.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 11 May 2015 15:56:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Gazette: A Free WordPress Magazine Theme from Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=43501\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wptavern.com/gazette-a-free-wordpress-magazine-theme-from-automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3367:\"<p><a href=\"https://theme.wordpress.com/themes/gazette/\" target=\"_blank\">Gazette</a> is a new WordPress magazine theme from the folks at Automattic, designed by <a href=\"http://thomasguillot.com/2015/05/07/new-theme-gazette/\" target=\"_blank\">Thomas Guillot</a>. Since the majority of themes produced for WordPress.com are well-suited to single author blogs, Gazette&#8217;s fine-tuned focus on digital publications is a welcome addition to the collection.</p>\n<p>Magazine themes are generally few and far between, because they have to be designed for a constant flow of content with a homepage that allows the reader to quickly scan multiple featured stories. Gazette takes a minimalist approach to the magazine style in that it isn&#8217;t cluttered with skinny columns of varying widths, obtrusive advertising slots, etc. It could easily be used for a personal blog or photography site.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/gazette-homepage.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/gazette-homepage.jpg?resize=1025%2C906\" alt=\"gazette-homepage\" class=\"aligncenter size-full wp-image-43507\" /></a></p>\n<p>As you scroll down the page, the sticky navigation/search bar pins the menu to the top for easy access. Gazette makes a strong impression with fullscreen featured images that display above post and page titles. The content area has been decluttered for readability with post meta pulled out into a separate column.</p>\n<p>Gazette supports image, gallery, video, and link post formats. The theme includes two optional widget areas (the right sidebar and footer), and two custom menus. With Jetpack active, Gazette adds an option to upload your site logo. The plugin also manages the featured content display, along with the related posts functionality seen in the <a href=\"https://gazettedemo.wordpress.com/\" target=\"_blank\">live demo</a>.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/gazette-author-bio.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/gazette-author-bio.jpg?resize=300%2C282\" alt=\"gazette-author-bio\" class=\"alignright size-medium wp-image-43552\" /></a>Gazette includes a handful of layout and content options in the customizer:</p>\n<ul>\n<li>Display header image on blog index only</li>\n<li>Show author bio on the sidebar of single posts</li>\n<li>Display content in the footer, i.e. basic HTML, links, et.</li>\n</ul>\n<p>Gazette is responsive and maintains its striking visual appeal and readability on mobile devices. The design is similar to popular mobile news apps that display posts with titles overlayed on featured images.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/gazette-responsive.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/gazette-responsive.jpg?resize=560%2C222\" alt=\"gazette-responsive\" class=\"aligncenter size-full wp-image-43508\" /></a></p>\n<p>Check out the <a href=\"https://gazettedemo.wordpress.com/\" target=\"_blank\">live demo</a> on WordPress.com to see Gazette in action. The theme is not yet available on WordPress.org but should be soon. In the meantime, the zip file for self-hosted sites can be downloaded from the sidebar of the <a href=\"https://theme.wordpress.com/themes/gazette/\" target=\"_blank\">Gazette theme page</a> on WordPress.com.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 11 May 2015 06:30:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 27 May 2015 20:15:31 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"244961\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Wed, 27 May 2015 20:00:18 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20150527161056\";}", "no");
INSERT INTO `wp_options` VALUES("528", "_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1432800932", "no");
INSERT INTO `wp_options` VALUES("529", "_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1432757732", "no");
INSERT INTO `wp_options` VALUES("530", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1432800932", "no");
INSERT INTO `wp_options` VALUES("531", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:117:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 May 2015 19:41:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:30:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"29832@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Wordfence Security is a free enterprise class security and performance plugin that makes your site up to 50 times faster and more secure.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2141@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"29860@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"15@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet Web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"23862@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Your WordPress, Streamlined.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"8321@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using Yoast&#039;s WordPress SEO plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"Google Analytics Dashboard for WP\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://wordpress.org/plugins/google-analytics-dashboard-for-wp/#post-50539\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 10 Mar 2013 17:07:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"50539@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Displays Google Analytics reports and real-time statistics in your WordPress Dashboard. Inserts the latest tracking code in every page of your site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Alin Marcu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"1169@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 12 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Advanced Custom Fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/advanced-custom-fields/#post-25254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Mar 2011 04:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"25254@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"Customise WordPress with powerful, professional and intuitive fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"elliotcondon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"18101@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"753@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"WP Smush\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wp-smushit/#post-7936\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Dec 2008 00:00:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"7936@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"Reduce image file sizes, improve performance and boost your SEO using the free WPMU DEV WordPress Smush API.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Alex Dunae\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Black Studio TinyMCE Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/plugins/black-studio-tinymce-widget/#post-31973\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Nov 2011 15:06:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"31973@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"The visual editor widget for Wordpress.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marco Chiesi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Duplicator\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins/duplicator/#post-26607\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 May 2011 12:15:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"26607@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"Duplicate, clone, backup, move and transfer an entire site from one location to another.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Cory Lamle\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2082@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Shortcodes Ultimate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/plugins/shortcodes-ultimate/#post-25618\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 04 Apr 2011 13:08:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"25618@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"Supercharge your WordPress theme with mega pack of shortcodes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Vladimir Anokhin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Google Analytics by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2316@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"Track your WordPress site easily with the latest tracking codes and lots added data for search result pages and error pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/wp-super-cache/#post-2572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Nov 2007 11:40:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2572@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"A very fast caching engine for WordPress that produces static html files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Donncha O Caoimh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"UpdraftPlus Backup and Restoration\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/updraftplus/#post-38058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 May 2012 15:14:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"38058@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Backup and restoration made easy. Complete backups; manual or scheduled (backup to S3, Dropbox, Google Drive, Rackspace, FTP, SFTP, email + others).\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Anderson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"132@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Arne Brachhold\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Redirection\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins/redirection/#post-2286\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Sep 2007 04:45:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2286@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"Redirection is a WordPress plugin to manage 301 redirections and keep track of 404 errors without requiring knowledge of Apache .htaccess files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"John Godley\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Ninja Forms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/ninja-forms/#post-33147\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 20 Dec 2011 18:11:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"33147@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:142:\"Forms created with a simple drag and drop interface. Contact forms, Email collection forms, or any other form you want on your WordPress site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"kstover\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Photo Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/photo-gallery/#post-63299\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 15:58:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"63299@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:143:\"Photo Gallery is an advanced plugin with a list of tools and options for adding and editing images for different views. It is fully responsive.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"webdorado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"MailChimp for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wordpress.org/plugins/mailchimp-for-wp/#post-54377\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Jun 2013 17:32:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"54377@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:138:\"The best MailChimp plugin to get more email subscribers. Easily add MailChimp sign-up forms and sign-up checkboxes to your WordPress site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Danny van Kooten\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"5468@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"Make your WordPress website mobile-friendly with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"NextScripts: Social Networks Auto-Poster\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://wordpress.org/plugins/social-networks-auto-poster-facebook-twitter-g/#post-35439\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Mar 2012 00:28:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"35439@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"Automatically re-publishes blogposts to Facebook, Twitter, Google+, Pinterest, LinkedIn, Blogger, Tumblr, Delicious, Plurk, etc profiles and/or pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"NextScripts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Page Builder by SiteOrigin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/siteorigin-panels/#post-51888\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Apr 2013 10:36:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"51888@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"Build responsive page layouts using the widgets you know and love using this simple drag and drop page builder.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Greg Priday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Responsive Lightbox by dFactory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/plugins/responsive-lightbox/#post-55352\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Jul 2013 10:58:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"55352@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:141:\"Responsive Lightbox allows users to view larger versions of images and galleries in a lightbox (overlay) effect optimized for mobile devices.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"dFactory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Breadcrumb NavXT\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://wordpress.org/plugins/breadcrumb-navxt/#post-2634\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 01 Dec 2007 00:15:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2634@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"Adds breadcrumb navigation showing the visitor&#039;s path to their current location.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"John Havlik\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google Analyticator\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/google-analyticator/#post-130\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"130@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:129:\"Easily view your Google Analytics and real-time statistics inside WordPress! Makes it super simple to add your tracking code too.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"cavemonkey50\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:46:\"https://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:12:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 27 May 2015 20:15:32 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:7:\"expires\";s:29:\"Wed, 27 May 2015 20:16:29 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Wed, 27 May 2015 19:41:29 +0000\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20150527161056\";}", "no");
INSERT INTO `wp_options` VALUES("532", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1432800932", "no");
INSERT INTO `wp_options` VALUES("533", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1432757732", "no");
INSERT INTO `wp_options` VALUES("534", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1432800932", "no");
INSERT INTO `wp_options` VALUES("535", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2015/05/wordpress-4-2-2/\'>WordPress 4.2.2 Security and Maintenance Release</a> <span class=\"rss-date\">May 7, 2015</span><div class=\"rssSummary\">WordPress 4.2.2 is now available. This is a critical security release for all previous versions and we strongly encourage you to update your sites immediately. Version 4.2.2 addresses two security issues: The Genericons icon font package, which is used in a number of popular themes and plugins, contained an HTML file vulnerable to a cross-site [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://ma.tt/2015/05/why-awe/\'>Matt: Why Awe?</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/my-struggle-to-learn-how-the-wordpress-rest-api-works\'>WPTavern: My Struggle to Learn How the WordPress REST API Works</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/replace-the-buddypress-mystery-man-with-unique-colorful-identicons\'>WPTavern: Replace the BuddyPress Mystery Man with Unique, Colorful Identicons</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'https://wordpress.org/plugins/responsive-lightbox/\' class=\'dashboard-news-plugin-link\'>Responsive Lightbox by dFactory</a>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=responsive-lightbox&amp;_wpnonce=8603f1fa6d&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Responsive Lightbox by dFactory\'>Install</a>)</span></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("537", "_transient_wpseo_sitemap_cache_post_1", "<urlset xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:image=\"http://www.google.com/schemas/sitemap-image/1.1\" xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\" xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n	<url>\n		<loc>http://demobay.info/remedy</loc>\n		<changefreq>daily</changefreq>\n		<priority>1</priority>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/tips-for-choosing-the-best-natural-remedy/</loc>\n		<lastmod>2015-05-27T20:09:06+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.6</priority>\n		<image:image>\n			<image:loc>http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/e/natural_remedies_1432757336.jpg</image:loc>\n			<image:caption><![CDATA[Tips for Choosing the Best Natural Remedy]]></image:caption>\n		</image:image>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/natural-remedies-for-skincare/</loc>\n		<lastmod>2015-05-27T20:11:33+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.6</priority>\n		<image:image>\n			<image:loc>http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/b/skincare_1432757469.png</image:loc>\n			<image:caption><![CDATA[Natural Remedies for Skincare]]></image:caption>\n		</image:image>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/natural-remedies-for-acne/</loc>\n		<lastmod>2015-05-27T20:12:53+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.6</priority>\n		<image:image>\n			<image:loc>http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/4/skin_1432757563.jpg</image:loc>\n			<image:caption><![CDATA[Natural Remedies for Acne]]></image:caption>\n		</image:image>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/natural-allergy-remedies/</loc>\n		<lastmod>2015-05-27T20:14:25+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.6</priority>\n		<image:image>\n			<image:loc>http://demobay.info/remedy/wp-content/uploads/2015/05/wpfree/2/allergies_1432757650.jpg</image:loc>\n			<image:caption><![CDATA[Natural Allergy Remedies]]></image:caption>\n		</image:image>\n	</url>\n</urlset>", "no");
INSERT INTO `wp_options` VALUES("538", "widget_smart-youtube", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("540", "_transient_wpseo_sitemap_cache_category_1", "<urlset xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\" xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n	<url>\n		<loc>http://demobay.info/remedy/category/allergies/</loc>\n		<lastmod>2015-05-27T20:14:25+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.2</priority>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/category/natural-remedies-tips/</loc>\n		<lastmod>2015-05-27T20:09:06+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.2</priority>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/category/skin-care/</loc>\n		<lastmod>2015-05-27T20:12:53+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.2</priority>\n	</url>\n</urlset>", "no");
INSERT INTO `wp_options` VALUES("541", "_transient_timeout_wpseo_sitemap_cache_page_1", "1432844298", "no");
INSERT INTO `wp_options` VALUES("542", "_transient_wpseo_sitemap_cache_page_1", "<urlset xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:image=\"http://www.google.com/schemas/sitemap-image/1.1\" xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\" xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n	<url>\n		<loc>http://demobay.info/remedy</loc>\n		<changefreq>daily</changefreq>\n		<priority>1</priority>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/privacy-policy/</loc>\n		<lastmod>2015-05-27T06:18:11+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.8</priority>\n	</url>\n	<url>\n		<loc>http://demobay.info/remedy/craft-store/</loc>\n		<lastmod>2015-05-27T14:47:39+00:00</lastmod>\n		<changefreq>weekly</changefreq>\n		<priority>0.8</priority>\n	</url>\n</urlset>", "no");
INSERT INTO `wp_options` VALUES("546", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("550", "_transient_timeout_wooframework_version_data", "1432849132", "no");
INSERT INTO `wp_options` VALUES("551", "_transient_wooframework_version_data", "a:2:{s:7:\"version\";s:5:\"6.2.0\";s:11:\"is_critical\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("552", "_transient_timeout_woo_framework_critical_update", "1433972332", "no");
INSERT INTO `wp_options` VALUES("553", "_transient_woo_framework_critical_update", "1", "no");
INSERT INTO `wp_options` VALUES("554", "_transient_timeout_woo_framework_critical_update_data", "1433972332", "no");
INSERT INTO `wp_options` VALUES("555", "_transient_woo_framework_critical_update_data", "a:4:{s:9:\"is_update\";b:1;s:7:\"version\";s:5:\"6.2.0\";s:6:\"status\";s:4:\"none\";s:11:\"is_critical\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("556", "rewrite_rules", "a:70:{s:19:\"sitemap_index\\.xml$\";s:19:\"index.php?sitemap=1\";s:31:\"([^/]+?)-sitemap([0-9]+)?\\.xml$\";s:51:\"index.php?sitemap=$matches[1]&sitemap_n=$matches[2]\";s:24:\"([a-z]+)?-?sitemap\\.xsl$\";s:25:\"index.php?xsl=$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)(/[0-9]+)?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("557", "widget_clickbank_ads_widget_version", "a:2:{i:2;a:11:{s:5:\"title\";s:14:\"Related eBooks\";s:4:\"cbid\";s:8:\"sheila57\";s:8:\"keywords\";s:0:\"\";s:15:\"keywordbytitle2\";s:5:\"Title\";s:6:\"border\";s:0:\"\";s:9:\"bordcolor\";s:6:\"CCCCCC\";s:9:\"bordstyle\";s:1:\"1\";s:9:\"linkcolor\";s:6:\"0000ff\";s:8:\"adformat\";s:1:\"3\";s:6:\"height\";s:3:\"800\";s:5:\"width\";s:4:\"100%\";}s:12:\"_multiwidget\";i:1;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("18", "11", "_wp_attached_file", "2015/05/wpfree/b/crochet_1432707395.jpg");
INSERT INTO `wp_postmeta` VALUES("19", "11", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:466;s:4:\"file\";s:39:\"2015/05/wpfree/b/crochet_1432707395.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"crochet_1432707395-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"crochet_1432707395-300x218.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:218;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:8;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:5:\"E-520\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"21\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:15:\"0.0166666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("24", "2", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("25", "2", "_wp_trash_meta_time", "1432707502");
INSERT INTO `wp_postmeta` VALUES("28", "18", "_wp_attached_file", "2015/05/wpfree/0/scrapbook_1432708590.png");
INSERT INTO `wp_postmeta` VALUES("29", "18", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:640;s:4:\"file\";s:41:\"2015/05/wpfree/0/scrapbook_1432708590.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:32:\"scrapbook_1432708590-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:32:\"scrapbook_1432708590-240x300.png\";s:5:\"width\";i:240;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("35", "21", "_wp_attached_file", "2015/05/wpfree/3/writing_1432708830.png");
INSERT INTO `wp_postmeta` VALUES("36", "21", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:629;s:4:\"file\";s:39:\"2015/05/wpfree/3/writing_1432708830.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"writing_1432708830-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"writing_1432708830-300x295.png\";s:5:\"width\";i:300;s:6:\"height\";i:295;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("37", "22", "_wp_attached_file", "2015/05/wpfree/d/writing_1432708850.png");
INSERT INTO `wp_postmeta` VALUES("38", "22", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:601;s:6:\"height\";i:640;s:4:\"file\";s:39:\"2015/05/wpfree/d/writing_1432708850.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"writing_1432708850-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"writing_1432708850-282x300.png\";s:5:\"width\";i:282;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("44", "25", "_wp_attached_file", "2015/05/wpfree/8/crafts_1432709018.jpg");
INSERT INTO `wp_postmeta` VALUES("45", "25", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:426;s:4:\"file\";s:38:\"2015/05/wpfree/8/crafts_1432709018.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"crafts_1432709018-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:29:\"crafts_1432709018-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:4;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:11:\"NIKON D5200\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"24\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:5:\"0.025\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("52", "28", "_wp_attached_file", "2015/05/wpfree/0/candles_1432709868.png");
INSERT INTO `wp_postmeta` VALUES("53", "28", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:639;s:4:\"file\";s:39:\"2015/05/wpfree/0/candles_1432709868.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"candles_1432709868-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"candles_1432709868-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("59", "31", "_wp_attached_file", "2015/05/wpfree/4/candles_1432709996.jpg");
INSERT INTO `wp_postmeta` VALUES("60", "31", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:486;s:4:\"file\";s:39:\"2015/05/wpfree/4/candles_1432709996.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"candles_1432709996-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"candles_1432709996-300x228.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:228;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:4;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:14:\"Canon EOS 500D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"28\";s:3:\"iso\";s:4:\"1600\";s:13:\"shutter_speed\";s:16:\"0.00555555555556\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("66", "34", "_wp_attached_file", "2015/05/wpfree/1/knitting_1432710128.png");
INSERT INTO `wp_postmeta` VALUES("67", "34", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:632;s:6:\"height\";i:640;s:4:\"file\";s:40:\"2015/05/wpfree/1/knitting_1432710128.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"knitting_1432710128-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"knitting_1432710128-296x300.png\";s:5:\"width\";i:296;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("73", "37", "_wp_attached_file", "2015/05/wpfree/7/grandma_knitting_1432710312.jpg");
INSERT INTO `wp_postmeta` VALUES("74", "37", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:557;s:6:\"height\";i:640;s:4:\"file\";s:48:\"2015/05/wpfree/7/grandma_knitting_1432710312.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:39:\"grandma_knitting_1432710312-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:39:\"grandma_knitting_1432710312-261x300.jpg\";s:5:\"width\";i:261;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:18;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:13:\"Canon EOS 70D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"17\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:3:\"0.1\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("81", "40", "_wp_attached_file", "2015/05/wpfree/6/christmas_cards_1432710703.jpg");
INSERT INTO `wp_postmeta` VALUES("82", "40", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:426;s:4:\"file\";s:47:\"2015/05/wpfree/6/christmas_cards_1432710703.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:38:\"christmas_cards_1432710703-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:38:\"christmas_cards_1432710703-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:8;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:13:\"Canon EOS 50D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"60\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:15:\"0.0222222222222\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("88", "43", "_wp_attached_file", "2015/05/wpfree/a/Basket_Flowers_1432710999.jpg");
INSERT INTO `wp_postmeta` VALUES("89", "43", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:475;s:4:\"file\";s:46:\"2015/05/wpfree/a/Basket_Flowers_1432710999.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:37:\"Basket_Flowers_1432710999-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:37:\"Basket_Flowers_1432710999-300x223.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:223;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:8;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:11:\"NIKON D5000\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"29\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.008\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("93", "45", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("94", "45", "_wp_page_template", "template-full-width.php");
INSERT INTO `wp_postmeta` VALUES("95", "45", "image", "");
INSERT INTO `wp_postmeta` VALUES("96", "45", "_edit_lock", "1432737973:1");
INSERT INTO `wp_postmeta` VALUES("135", "57", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("136", "57", "_edit_lock", "1432757255:1");
INSERT INTO `wp_postmeta` VALUES("137", "58", "_wp_attached_file", "2015/05/wpfree/e/natural_remedies_1432757336.jpg");
INSERT INTO `wp_postmeta` VALUES("138", "58", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:480;s:4:\"file\";s:48:\"2015/05/wpfree/e/natural_remedies_1432757336.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:39:\"natural_remedies_1432757336-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:39:\"natural_remedies_1432757336-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:5.5;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:12:\"COOLPIX L620\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"55.1\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:15:\"0.0666666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("139", "57", "_thumbnail_id", "58");
INSERT INTO `wp_postmeta` VALUES("141", "57", "image", "");
INSERT INTO `wp_postmeta` VALUES("142", "60", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("143", "60", "_edit_lock", "1432757374:1");
INSERT INTO `wp_postmeta` VALUES("144", "61", "_wp_attached_file", "2015/05/wpfree/b/skincare_1432757469.png");
INSERT INTO `wp_postmeta` VALUES("145", "61", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:482;s:6:\"height\";i:640;s:4:\"file\";s:40:\"2015/05/wpfree/b/skincare_1432757469.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"skincare_1432757469-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"skincare_1432757469-226x300.png\";s:5:\"width\";i:226;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("146", "60", "_thumbnail_id", "61");
INSERT INTO `wp_postmeta` VALUES("148", "60", "image", "");
INSERT INTO `wp_postmeta` VALUES("149", "63", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("150", "63", "_edit_lock", "1432757454:1");
INSERT INTO `wp_postmeta` VALUES("151", "64", "_wp_attached_file", "2015/05/wpfree/4/skin_1432757563.jpg");
INSERT INTO `wp_postmeta` VALUES("152", "64", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:480;s:4:\"file\";s:36:\"2015/05/wpfree/4/skin_1432757563.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"skin_1432757563-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"skin_1432757563-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("153", "63", "_thumbnail_id", "64");
INSERT INTO `wp_postmeta` VALUES("155", "63", "image", "");
INSERT INTO `wp_postmeta` VALUES("156", "66", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("157", "66", "_edit_lock", "1432757534:1");
INSERT INTO `wp_postmeta` VALUES("158", "67", "_wp_attached_file", "2015/05/wpfree/2/allergies_1432757650.jpg");
INSERT INTO `wp_postmeta` VALUES("159", "67", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:580;s:6:\"height\";i:640;s:4:\"file\";s:41:\"2015/05/wpfree/2/allergies_1432757650.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:32:\"allergies_1432757650-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:32:\"allergies_1432757650-272x300.jpg\";s:5:\"width\";i:272;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:5;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:9:\"NIKON D60\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"28\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:15:\"0.0166666666667\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("160", "66", "_thumbnail_id", "67");
INSERT INTO `wp_postmeta` VALUES("162", "66", "image", "");
INSERT INTO `wp_postmeta` VALUES("163", "69", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("164", "69", "_edit_lock", "1432757942:1");
INSERT INTO `wp_postmeta` VALUES("165", "70", "_wp_attached_file", "2015/05/wpfree/6/herbs_1432758070.jpg");
INSERT INTO `wp_postmeta` VALUES("166", "70", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:640;s:4:\"file\";s:37:\"2015/05/wpfree/6/herbs_1432758070.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"herbs_1432758070-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"herbs_1432758070-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("167", "69", "_thumbnail_id", "70");
INSERT INTO `wp_postmeta` VALUES("169", "69", "image", "");
INSERT INTO `wp_postmeta` VALUES("170", "72", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("171", "72", "_edit_lock", "1432762467:1");
INSERT INTO `wp_postmeta` VALUES("172", "73", "_wp_attached_file", "2015/05/wpfree/c/drunk_1432762591.jpg");
INSERT INTO `wp_postmeta` VALUES("173", "73", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:425;s:4:\"file\";s:37:\"2015/05/wpfree/c/drunk_1432762591.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"drunk_1432762591-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"drunk_1432762591-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:6.29999999999999982236431605997495353221893310546875;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:10:\"NIKON D700\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"55\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:5:\"0.005\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("174", "72", "_thumbnail_id", "73");
INSERT INTO `wp_postmeta` VALUES("176", "72", "image", "");
INSERT INTO `wp_postmeta` VALUES("177", "77", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("178", "77", "_edit_lock", "1432762952:1");
INSERT INTO `wp_postmeta` VALUES("179", "78", "_wp_attached_file", "2015/05/wpfree/6/remedies_1432762960.jpg");
INSERT INTO `wp_postmeta` VALUES("180", "78", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:426;s:4:\"file\";s:40:\"2015/05/wpfree/6/remedies_1432762960.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"remedies_1432762960-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"remedies_1432762960-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:5.5999999999999996447286321199499070644378662109375;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:5:\"NX300\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"55\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:4:\"0.01\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("181", "79", "_wp_attached_file", "2015/05/wpfree/b/remedies_1432762984.jpg");
INSERT INTO `wp_postmeta` VALUES("182", "79", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:426;s:4:\"file\";s:40:\"2015/05/wpfree/b/remedies_1432762984.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"remedies_1432762984-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"remedies_1432762984-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:5.5999999999999996447286321199499070644378662109375;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:5:\"NX300\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"55\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:6:\"0.0125\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("183", "77", "_thumbnail_id", "79");
INSERT INTO `wp_postmeta` VALUES("185", "77", "image", "");
INSERT INTO `wp_postmeta` VALUES("186", "81", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("187", "81", "_edit_lock", "1432763056:1");
INSERT INTO `wp_postmeta` VALUES("188", "82", "_wp_attached_file", "2015/05/wpfree/f/smile_1432763177.jpg");
INSERT INTO `wp_postmeta` VALUES("189", "82", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:426;s:4:\"file\";s:37:\"2015/05/wpfree/f/smile_1432763177.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"smile_1432763177-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"smile_1432763177-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:16;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:20:\"Canon EOS 5D Mark II\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"85\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:1;}}");
INSERT INTO `wp_postmeta` VALUES("190", "81", "_thumbnail_id", "82");
INSERT INTO `wp_postmeta` VALUES("192", "81", "image", "");
INSERT INTO `wp_postmeta` VALUES("193", "85", "_wp_attached_file", "2015/05/wpfree/9/blood_pressure_1432763291.jpg");
INSERT INTO `wp_postmeta` VALUES("194", "85", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:640;s:6:\"height\";i:450;s:4:\"file\";s:46:\"2015/05/wpfree/9/blood_pressure_1432763291.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:37:\"blood_pressure_1432763291-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:37:\"blood_pressure_1432763291-300x211.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:211;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("195", "84", "_thumbnail_id", "85");
INSERT INTO `wp_postmeta` VALUES("196", "84", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("198", "84", "image", "");
INSERT INTO `wp_postmeta` VALUES("199", "84", "_edit_lock", "1432763168:1");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("2", "1", "2015-05-14 22:21:28", "2015-05-14 22:21:28", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://demobay.info/remedy/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "trash", "open", "open", "", "sample-page", "", "", "2015-05-27 06:18:22", "2015-05-27 06:18:22", "", "0", "http://demobay.info/remedy/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2015-05-27 06:16:01", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2015-05-27 06:16:01", "0000-00-00 00:00:00", "", "0", "http://demobay.info/remedy/?p=10", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2015-05-27 06:16:35", "2015-05-27 06:16:35", "", "Crochet", "", "inherit", "closed", "closed", "", "crochet", "", "", "2015-05-27 06:16:35", "2015-05-27 06:16:35", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/crochet_1432707395.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2015-05-27 06:17:24", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2015-05-27 06:17:24", "0000-00-00 00:00:00", "", "0", "http://demobay.info/remedy/?p=13", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2015-05-27 06:18:11", "2015-05-27 06:18:11", "<!-- privacy-policy -->", "Privacy Policy", "", "publish", "closed", "closed", "", "privacy-policy", "", "", "2015-05-27 06:18:11", "2015-05-27 06:18:11", "", "0", "http://demobay.info/remedy/privacy-policy/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2015-05-27 06:18:22", "2015-05-27 06:18:22", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://demobay.info/remedy/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2015-05-27 06:18:22", "2015-05-27 06:18:22", "", "2", "http://demobay.info/remedy/2015/05/27/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2015-05-27 06:36:30", "2015-05-27 06:36:30", "", "Scrapbook", "", "inherit", "closed", "closed", "", "scrapbook", "", "", "2015-05-27 06:36:30", "2015-05-27 06:36:30", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/scrapbook_1432708590.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2015-05-27 06:40:30", "2015-05-27 06:40:30", "", "Writing", "", "inherit", "closed", "closed", "", "writing", "", "", "2015-05-27 06:40:30", "2015-05-27 06:40:30", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/writing_1432708830.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2015-05-27 06:40:50", "2015-05-27 06:40:50", "", "Writing", "", "inherit", "closed", "closed", "", "writing-2", "", "", "2015-05-27 06:40:51", "2015-05-27 06:40:51", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/writing_1432708850.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2015-05-27 06:43:38", "2015-05-27 06:43:38", "", "Crafts", "", "inherit", "closed", "closed", "", "crafts", "", "", "2015-05-27 06:43:38", "2015-05-27 06:43:38", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/crafts_1432709018.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2015-05-27 06:57:48", "2015-05-27 06:57:48", "", "Candles", "", "inherit", "closed", "closed", "", "candles", "", "", "2015-05-27 06:57:48", "2015-05-27 06:57:48", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/candles_1432709868.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2015-05-27 06:59:56", "2015-05-27 06:59:56", "", "Candles", "", "inherit", "closed", "closed", "", "candles-2", "", "", "2015-05-27 06:59:56", "2015-05-27 06:59:56", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/candles_1432709996.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2015-05-27 07:02:08", "2015-05-27 07:02:08", "", "Knitting", "", "inherit", "closed", "closed", "", "knitting", "", "", "2015-05-27 07:02:09", "2015-05-27 07:02:09", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/knitting_1432710128.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2015-05-27 07:05:12", "2015-05-27 07:05:12", "", "Grandma, Knitting", "", "inherit", "closed", "closed", "", "grandma-knitting", "", "", "2015-05-27 07:05:12", "2015-05-27 07:05:12", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/grandma_knitting_1432710312.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2015-05-27 07:11:43", "2015-05-27 07:11:43", "", "Christmas, Cards", "", "inherit", "closed", "closed", "", "christmas-cards", "", "", "2015-05-27 07:11:43", "2015-05-27 07:11:43", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/christmas_cards_1432710703.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2015-05-27 07:16:39", "2015-05-27 07:16:39", "", "Basket, Flowers", "", "inherit", "closed", "closed", "", "basket-flowers", "", "", "2015-05-27 07:16:39", "2015-05-27 07:16:39", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/Basket_Flowers_1432710999.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2015-05-27 07:19:45", "2015-05-27 07:19:45", "<iframe src=\"http://astore.amazon.com/diti0f-20\" width=\"90%\" height=\"4000\" frameborder=\"0\" scrolling=\"no\"></iframe>\r\n\r\n", "Store", "", "publish", "closed", "closed", "", "craft-store", "", "", "2015-05-27 14:47:39", "2015-05-27 14:47:39", "", "0", "http://demobay.info/remedy/?page_id=45", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2015-05-27 14:47:39", "2015-05-27 14:47:39", "<iframe src=\"http://astore.amazon.com/diti0f-20\" width=\"90%\" height=\"4000\" frameborder=\"0\" scrolling=\"no\"></iframe>\r\n\r\n", "Store", "", "inherit", "closed", "closed", "", "45-revision-v1", "", "", "2015-05-27 14:47:39", "2015-05-27 14:47:39", "", "45", "http://demobay.info/remedy/45-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("57", "1", "2015-05-27 20:09:06", "2015-05-27 20:09:06", "Are you looking to seek relief through the use of a natural remedy? If so, you are definitely not alone. Due to their many benefits, natural remedies also commonly referred to as home remedies are increasing in popularity. If this is your first time looking to try a natural remedy, you may be looking for some guidance. For example, you may be curious as to which natural remedy, say for a headache, is best for you. For tips on how you can get your answer, please continue reading on.\r\n\r\nWhen choosing a natural remedy to seek relief, it is important to first take a look at what you are trying to treat, cure, or seek pain relief from. This is important, as natural remedies vary depending on the medical issue at hand. For example, clove is natural way to relieve a toothache, as well as prevent infection; however, this approach does not prove successful when treating a headache. As for headaches, a cold compress or a cold cabbage compress works as a natural way to seek relief. The variance is why it is important to find a natural remedy that targets exactly what it is you are looking to treat, cure, or seek relief from.\r\n\r\nAnother important point to take into consideration is the ingredients. As it was previously stated, many natural remedies are also commonly referred to as home remedies. This is because many of the needed ingredients can already be found in most homes. For example, potatoes, fresh pineapples, and onions work with wart removal. Since potatoes, fresh pineapples, and onions are all commonly consumed foods, there is a good chance that you already have one of the items in your home. Also, since you will have multiple home remedies to choose from, you should choose the one that is most convenient in terms of supplies.\r\n\r\nIn keeping with convenience, it is not only important to choose a natural remedy that requires the use of items that you already have at home, but it also important to choose a natural remedy that is easy to follow. Typically, you will find that most have short and easy to follow directions, but it is still important to make sure. For example, there are around fifteen to twenty natural remedies recommended for headaches and migraines. You should choose the natural remedy that has short, but detailed directions, as well as the natural remedy that produces the quickest results.\r\n\r\nSpeaking of quickest results, it is important to note that you will see a variance. For starters, it is important to know that just because a natural remedy has proven successful for another individual, it does not mean that you will see that same results. That is one of the many reasons why many online websites and natural remedy books recommend multiple natural remedies. It is also important to make note of the length of treatment. For example, there are some natural remedies for wart removal that produce results in as few as two to three days, while other natural remedies may require months worth of treatment.\r\n\r\nThe above mentioned points are all points that you will want to take into consideration, when looking to make use of a natural remedy. As a reminder, natural remedies and home remedies are easy to find online or with the use of a natural or home remedy book. ", "Tips for Choosing the Best Natural Remedy", "", "publish", "closed", "closed", "", "tips-for-choosing-the-best-natural-remedy", "", "", "2015-05-27 20:09:06", "2015-05-27 20:09:06", "", "0", "http://demobay.info/remedy/?p=57", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("58", "1", "2015-05-27 20:08:56", "2015-05-27 20:08:56", "", "Natural, Remedies", "", "inherit", "closed", "closed", "", "natural-remedies", "", "", "2015-05-27 20:08:56", "2015-05-27 20:08:56", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/natural_remedies_1432757336.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("59", "1", "2015-05-27 20:09:06", "2015-05-27 20:09:06", "Are you looking to seek relief through the use of a natural remedy? If so, you are definitely not alone. Due to their many benefits, natural remedies also commonly referred to as home remedies are increasing in popularity. If this is your first time looking to try a natural remedy, you may be looking for some guidance. For example, you may be curious as to which natural remedy, say for a headache, is best for you. For tips on how you can get your answer, please continue reading on.\r\n\r\nWhen choosing a natural remedy to seek relief, it is important to first take a look at what you are trying to treat, cure, or seek pain relief from. This is important, as natural remedies vary depending on the medical issue at hand. For example, clove is natural way to relieve a toothache, as well as prevent infection; however, this approach does not prove successful when treating a headache. As for headaches, a cold compress or a cold cabbage compress works as a natural way to seek relief. The variance is why it is important to find a natural remedy that targets exactly what it is you are looking to treat, cure, or seek relief from.\r\n\r\nAnother important point to take into consideration is the ingredients. As it was previously stated, many natural remedies are also commonly referred to as home remedies. This is because many of the needed ingredients can already be found in most homes. For example, potatoes, fresh pineapples, and onions work with wart removal. Since potatoes, fresh pineapples, and onions are all commonly consumed foods, there is a good chance that you already have one of the items in your home. Also, since you will have multiple home remedies to choose from, you should choose the one that is most convenient in terms of supplies.\r\n\r\nIn keeping with convenience, it is not only important to choose a natural remedy that requires the use of items that you already have at home, but it also important to choose a natural remedy that is easy to follow. Typically, you will find that most have short and easy to follow directions, but it is still important to make sure. For example, there are around fifteen to twenty natural remedies recommended for headaches and migraines. You should choose the natural remedy that has short, but detailed directions, as well as the natural remedy that produces the quickest results.\r\n\r\nSpeaking of quickest results, it is important to note that you will see a variance. For starters, it is important to know that just because a natural remedy has proven successful for another individual, it does not mean that you will see that same results. That is one of the many reasons why many online websites and natural remedy books recommend multiple natural remedies. It is also important to make note of the length of treatment. For example, there are some natural remedies for wart removal that produce results in as few as two to three days, while other natural remedies may require months worth of treatment.\r\n\r\nThe above mentioned points are all points that you will want to take into consideration, when looking to make use of a natural remedy. As a reminder, natural remedies and home remedies are easy to find online or with the use of a natural or home remedy book. ", "Tips for Choosing the Best Natural Remedy", "", "inherit", "closed", "closed", "", "57-revision-v1", "", "", "2015-05-27 20:09:06", "2015-05-27 20:09:06", "", "57", "http://demobay.info/remedy/57-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2015-05-27 20:11:33", "2015-05-27 20:11:33", "Our skin plays an important role in our lives. In addition to protecting our bodies and internal organs, skin and its condition can also have an impact on appearance. For that reason, there are many men and women who are always on the lookout for ways to improve their skin or repair skin damage. Despite the fact that there are a countless number of over-the-counter skincare products that claim to provide relief and repair, there are also many natural remedies that can easily and safely produce the same results.\r\n\r\nIf you are an individual who suffers from peeling skin, you are urged to examine the vitamins that you currently consume. Whether it be through the taking of a vitamin supplement or through the consumption of vitamin rich foods, vitamins can play an important role in healthy skin. Proteins, vitamin A, vitamin B, and vitamin C can also assist with peeling skin. They do so by replenishing the skin with needed nutrients. For food consumption, fish, eggs, carrots, milk, cheese, vegetables, and citrus fruits should be consumed on a daily basis.\r\n\r\nEczema is another skin problem experienced by many. Eczema is dangerous on many different levels, as it often produces the uncontrollable urge to itch. This can result in an itchy rash, which can also increase one\'s chances of developing an infection. One of the best ways to prevent an eczema outbreak is limit exposure to trigger factors. For some individuals, a trigger factor is food, such a dairy products. For others, an eczema trigger factor is close contact with certain chemicals, such as laundry detergent. If eczema is developed, a natural remedy that can provide relief is the daily consumption of tomato juice.\r\n\r\nRazor burn is another skin problem that is experienced by men, women, as well as teenagers. The best way to prevent razor burn is by careful shaving. Warm water should be used to help soften up the skin. Soap is also advised, as it can help to move the razor along, resulting in less skin nicks and cuts. Should razor burn develop, crush a few strawberries and mix them with one spoon full sour cream. This mixture should be applied to the affected area and left on for around ten to fifteen minutes. Apply daily until the razor burn is no longer an issue.\r\n\r\nSunburn is another one of the many skin complications that many seek relief from. The good news with sunburns is that there are a number of natural remedies that can provide relief, mostly with the pain. Aloe Vera is one of the most well-known natural remedies for sunburns. Other remedies involve milk and raw cucumbers. For cucumbers, apply slices of raw cucumbers to the burned area for relief and a reduction in skin inflammation. As for milk, dip it in a paper towel or cloth and gently apply to the skin. Milk tends to have a claming affect on burned and inflamed skin.\r\n\r\nDry skin is another skin condition that many try to seek relief from. Dry skin can result in itching and it can increase one\'s chances of having an eczema outbreak. The good news, however, is that it is easy for many to naturally seek relief from dry skin. A mashed ripe banana is an ideal way to treat dry skin on the neck and face. Of course, this natural remedy can be used on other parts of the body, but it can get quite messy. Easy ways to relieve dry skin on the whole body include taking a milk bath once or twice a month or adding five drops of oat extract to warm bathwater.\r\n\r\nAs outlined above, there are a number of natural remedies and home remedies that are ideal for treating a wide range of skin complications. Where the skin is concerned, it is important to keep any open cuts or wounds covered, as the risk of infection is quite high. Should you ever suspect an infection, seek medical treatment immediately, even if you are using some of the above mentioned natural remedies. ", "Natural Remedies for Skincare", "", "publish", "closed", "closed", "", "natural-remedies-for-skincare", "", "", "2015-05-27 20:11:33", "2015-05-27 20:11:33", "", "0", "http://demobay.info/remedy/?p=60", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("61", "1", "2015-05-27 20:11:09", "2015-05-27 20:11:09", "", "Skincare", "", "inherit", "closed", "closed", "", "skincare", "", "", "2015-05-27 20:11:10", "2015-05-27 20:11:10", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/skincare_1432757469.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2015-05-27 20:11:33", "2015-05-27 20:11:33", "Our skin plays an important role in our lives. In addition to protecting our bodies and internal organs, skin and its condition can also have an impact on appearance. For that reason, there are many men and women who are always on the lookout for ways to improve their skin or repair skin damage. Despite the fact that there are a countless number of over-the-counter skincare products that claim to provide relief and repair, there are also many natural remedies that can easily and safely produce the same results.\r\n\r\nIf you are an individual who suffers from peeling skin, you are urged to examine the vitamins that you currently consume. Whether it be through the taking of a vitamin supplement or through the consumption of vitamin rich foods, vitamins can play an important role in healthy skin. Proteins, vitamin A, vitamin B, and vitamin C can also assist with peeling skin. They do so by replenishing the skin with needed nutrients. For food consumption, fish, eggs, carrots, milk, cheese, vegetables, and citrus fruits should be consumed on a daily basis.\r\n\r\nEczema is another skin problem experienced by many. Eczema is dangerous on many different levels, as it often produces the uncontrollable urge to itch. This can result in an itchy rash, which can also increase one\'s chances of developing an infection. One of the best ways to prevent an eczema outbreak is limit exposure to trigger factors. For some individuals, a trigger factor is food, such a dairy products. For others, an eczema trigger factor is close contact with certain chemicals, such as laundry detergent. If eczema is developed, a natural remedy that can provide relief is the daily consumption of tomato juice.\r\n\r\nRazor burn is another skin problem that is experienced by men, women, as well as teenagers. The best way to prevent razor burn is by careful shaving. Warm water should be used to help soften up the skin. Soap is also advised, as it can help to move the razor along, resulting in less skin nicks and cuts. Should razor burn develop, crush a few strawberries and mix them with one spoon full sour cream. This mixture should be applied to the affected area and left on for around ten to fifteen minutes. Apply daily until the razor burn is no longer an issue.\r\n\r\nSunburn is another one of the many skin complications that many seek relief from. The good news with sunburns is that there are a number of natural remedies that can provide relief, mostly with the pain. Aloe Vera is one of the most well-known natural remedies for sunburns. Other remedies involve milk and raw cucumbers. For cucumbers, apply slices of raw cucumbers to the burned area for relief and a reduction in skin inflammation. As for milk, dip it in a paper towel or cloth and gently apply to the skin. Milk tends to have a claming affect on burned and inflamed skin.\r\n\r\nDry skin is another skin condition that many try to seek relief from. Dry skin can result in itching and it can increase one\'s chances of having an eczema outbreak. The good news, however, is that it is easy for many to naturally seek relief from dry skin. A mashed ripe banana is an ideal way to treat dry skin on the neck and face. Of course, this natural remedy can be used on other parts of the body, but it can get quite messy. Easy ways to relieve dry skin on the whole body include taking a milk bath once or twice a month or adding five drops of oat extract to warm bathwater.\r\n\r\nAs outlined above, there are a number of natural remedies and home remedies that are ideal for treating a wide range of skin complications. Where the skin is concerned, it is important to keep any open cuts or wounds covered, as the risk of infection is quite high. Should you ever suspect an infection, seek medical treatment immediately, even if you are using some of the above mentioned natural remedies. ", "Natural Remedies for Skincare", "", "inherit", "closed", "closed", "", "60-revision-v1", "", "", "2015-05-27 20:11:33", "2015-05-27 20:11:33", "", "60", "http://demobay.info/remedy/60-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("63", "1", "2015-05-27 20:12:53", "2015-05-27 20:12:53", "Acne is a skin condition that millions of individuals deal with, sometimes on a daily basis. Although acne is not a life threatening condition, it can cause great stress. Acne, especially when constantly touched or picked at, can also lead to scaring or even an infection. For that reason, those suffering from acne often look for different ways to seek relief.\r\n\r\nWhen it comes to seeking relief from acne, there are a large number of over-the-counter products that claim to provide relief. In addition to simply just appearing on store shelves, a large number of over-the-counter acne medications are also appearing on our television screens and with famous celebrities standing behind the products. Of course, if you are suffering from acne you can give these over-the-counter products a try, but it is also important to know that you do have a number of different options. These options involve the use of natural remedies and home remedies, which are a safer way to treat acne, as they do not rely on the use of potentially dangerous chemicals.\r\n\r\nThere are a number of natural remedies for acne that rely on the use of food. One of those remedies is that of lettuce. Saturating lettuce in water for about an hours worth of time will result in a special mixture. This mixture should then be applied to the skin, acting as a rinse. This approach is a nice and easy way to get rid of unwanted acne.\r\n\r\nFresh lime juice and milk are another natural remedy for getting rid of acne that comes highly rated and recommend. With this natural remedy for acne, boil a half of glass of milk. Once that milk has cooled, add in about the same amount of lime juice. You can then use a cloth to apply the mixture onto your acne infected area. As an important reminder, wait until the boiled milk has cooled to an ideal level to promote comfort and prevent burns.\r\n\r\nFor a small area of acne, ripe tomatoes can be used. For this home remedy, cut a ripe tomato in half and place the inside, wet portion of the tomato on the pimple or pimples. Leave it on for about an hours worth of time and then wash off. A similar approach to this natural remedy and one that still comes highly rated and recommended involves the use of tomato paste.\r\n\r\nAs previously stated, those suffering from severe acne put themselves at risk for developing an infection or scaring. Those who are known to touch or pick at their pimples are first advised to stop. That is the best way to keep your skin healthy. With that being said, Aloe Vera can also provide relief. When applied to the affected area, Aloe Vera can help to promote healthy healing on the skin.\r\n\r\nAs outlined above, there are a number of different natural remedies and home remedies for those suffering from acne, like you. As for why these natural remedies are advised, there are a number of different reasons. If you have ever tried over-the-counter skincare products before, you likely already know that they can be costly. Imagine that cost added up overtime. It is also important to note that many over-the-counter acne treatment products have poor reviews. In fact, did you know that some products actually cause users more problems with rashes and acne than before? That is why many are now starting to rely on natural remedies instead, as they are affordable, easy to implement, and safe. ", "Natural Remedies for Acne", "", "publish", "closed", "closed", "", "natural-remedies-for-acne", "", "", "2015-05-27 20:12:53", "2015-05-27 20:12:53", "", "0", "http://demobay.info/remedy/?p=63", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2015-05-27 20:12:43", "2015-05-27 20:12:43", "", "Skin", "", "inherit", "closed", "closed", "", "skin", "", "", "2015-05-27 20:12:43", "2015-05-27 20:12:43", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/skin_1432757563.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2015-05-27 20:12:53", "2015-05-27 20:12:53", "Acne is a skin condition that millions of individuals deal with, sometimes on a daily basis. Although acne is not a life threatening condition, it can cause great stress. Acne, especially when constantly touched or picked at, can also lead to scaring or even an infection. For that reason, those suffering from acne often look for different ways to seek relief.\r\n\r\nWhen it comes to seeking relief from acne, there are a large number of over-the-counter products that claim to provide relief. In addition to simply just appearing on store shelves, a large number of over-the-counter acne medications are also appearing on our television screens and with famous celebrities standing behind the products. Of course, if you are suffering from acne you can give these over-the-counter products a try, but it is also important to know that you do have a number of different options. These options involve the use of natural remedies and home remedies, which are a safer way to treat acne, as they do not rely on the use of potentially dangerous chemicals.\r\n\r\nThere are a number of natural remedies for acne that rely on the use of food. One of those remedies is that of lettuce. Saturating lettuce in water for about an hours worth of time will result in a special mixture. This mixture should then be applied to the skin, acting as a rinse. This approach is a nice and easy way to get rid of unwanted acne.\r\n\r\nFresh lime juice and milk are another natural remedy for getting rid of acne that comes highly rated and recommend. With this natural remedy for acne, boil a half of glass of milk. Once that milk has cooled, add in about the same amount of lime juice. You can then use a cloth to apply the mixture onto your acne infected area. As an important reminder, wait until the boiled milk has cooled to an ideal level to promote comfort and prevent burns.\r\n\r\nFor a small area of acne, ripe tomatoes can be used. For this home remedy, cut a ripe tomato in half and place the inside, wet portion of the tomato on the pimple or pimples. Leave it on for about an hours worth of time and then wash off. A similar approach to this natural remedy and one that still comes highly rated and recommended involves the use of tomato paste.\r\n\r\nAs previously stated, those suffering from severe acne put themselves at risk for developing an infection or scaring. Those who are known to touch or pick at their pimples are first advised to stop. That is the best way to keep your skin healthy. With that being said, Aloe Vera can also provide relief. When applied to the affected area, Aloe Vera can help to promote healthy healing on the skin.\r\n\r\nAs outlined above, there are a number of different natural remedies and home remedies for those suffering from acne, like you. As for why these natural remedies are advised, there are a number of different reasons. If you have ever tried over-the-counter skincare products before, you likely already know that they can be costly. Imagine that cost added up overtime. It is also important to note that many over-the-counter acne treatment products have poor reviews. In fact, did you know that some products actually cause users more problems with rashes and acne than before? That is why many are now starting to rely on natural remedies instead, as they are affordable, easy to implement, and safe. ", "Natural Remedies for Acne", "", "inherit", "closed", "closed", "", "63-revision-v1", "", "", "2015-05-27 20:12:53", "2015-05-27 20:12:53", "", "63", "http://demobay.info/remedy/63-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2015-05-27 20:14:25", "2015-05-27 20:14:25", "Are you an individual who suffers from allergies? If so, you may be looking for ways to seek relief. Most individuals turn to over-the-counter medications. While these medications do work, in most cases, there are many individuals who are concerned with exactly what it is they are putting into their bodies. If you are one of those individuals, you will want to continue reading on. Below, a number of natural allergy remedies are highlighted below. In addition to being considered natural allergy remedies, many are also known as home remedies for allergies.\r\n\r\nOne natural allergy remedy that comes highly rated and recommended is that of apple cider vinegar. Often times, the only complaint that most have with apple cider vinegar is the taste. However, it is not only known as a natural remedy to treat allergies. Many also use it to assist with weight loss, high blood pressure, and high cholesterol. Most individuals using apple cider vinegar to treat allergies recommend taking two tablespoons a day. Mixing it with juice or water is also advised, which can assist with taste issues.\r\n\r\nRed clover is another natural allergy remedy. What is nice about using red clover to treat your allergy symptoms is all of the options that you have, as red clover is available in a wide range of formats. With that being said, most allergy sufferers recommend red clover tea. Red clover wine and red clover herbal supplements, which come in the format of pills, are also available for sale both on and offline.\r\n\r\nCarefully choosing the foods in which you consume is another natural way to reduce or treat the symptoms of allergies. Lime squeezed into water has been known to assist those with allergies. Vegetable juices and bananas also come highly rated and recommended.\r\n\r\nAcupuncture is also an ideal way to treat and relieve the symptoms of allergies. According to WebMD, a trusted medical website, acupuncture helped to reduce all allergy symptoms in a study performed on twenty-six patients. If you are interested in giving acupuncture a try, consider contacting your local health spas, as many offer alternative healing approaches. If acupuncture is not a service offered, you should be provided with contact information for another local practitioner.\r\n\r\nIn addition to the above mentioned natural allergy remedies, there are also steps that you can take to prevent the onset of allergies or steps that you can take to reduce these symptoms. Most of these helpful tips can still be considered natural allergy remedies, but in a different sense. Also, these additional tips, a few of which are outlined below, are for just about anyone suffering from allergies, as they are affordable and easy to implement.\r\n\r\nFor pet allergies, stay a safe distance away from pets. With that said, if you are a pet owner who cannot bear to part with your beloved pets, be sure to keep them out of your bedroom, as this is where you spend most of your time.\r\n\r\nSince mold is a common trigger factor for allergies, it is important to take steps to remove mold from your home or prevent it from growing. Limiting the humidity in your home is a great way to reduce or completely prevent mold growth. Use a bathroom fan or open a bathroom window when taking a shower, to reduce mold growth in the bathroom. If you already have mold in your home, contact a professional to inquire about a mold removal. Until that time comes, be sure to avoid areas in your home where mold is present.\r\n\r\nThe above mentioned natural allergy remedies are just a few of the many that allergy sufferers recommend, but they are a few of the most popular approaches taken. As a reminder, it is important to remember that natural remedies and home remedies work differently on different individuals. If you do not see the success that you had hoped for, not all hope is lost, as there should be another natural allergy remedy out there that can provide you with relief. ", "Natural Allergy Remedies", "", "publish", "closed", "closed", "", "natural-allergy-remedies", "", "", "2015-05-27 20:14:25", "2015-05-27 20:14:25", "", "0", "http://demobay.info/remedy/?p=66", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2015-05-27 20:14:10", "2015-05-27 20:14:10", "", "Allergies", "", "inherit", "closed", "closed", "", "allergies", "", "", "2015-05-27 20:14:10", "2015-05-27 20:14:10", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/allergies_1432757650.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2015-05-27 20:14:25", "2015-05-27 20:14:25", "Are you an individual who suffers from allergies? If so, you may be looking for ways to seek relief. Most individuals turn to over-the-counter medications. While these medications do work, in most cases, there are many individuals who are concerned with exactly what it is they are putting into their bodies. If you are one of those individuals, you will want to continue reading on. Below, a number of natural allergy remedies are highlighted below. In addition to being considered natural allergy remedies, many are also known as home remedies for allergies.\r\n\r\nOne natural allergy remedy that comes highly rated and recommended is that of apple cider vinegar. Often times, the only complaint that most have with apple cider vinegar is the taste. However, it is not only known as a natural remedy to treat allergies. Many also use it to assist with weight loss, high blood pressure, and high cholesterol. Most individuals using apple cider vinegar to treat allergies recommend taking two tablespoons a day. Mixing it with juice or water is also advised, which can assist with taste issues.\r\n\r\nRed clover is another natural allergy remedy. What is nice about using red clover to treat your allergy symptoms is all of the options that you have, as red clover is available in a wide range of formats. With that being said, most allergy sufferers recommend red clover tea. Red clover wine and red clover herbal supplements, which come in the format of pills, are also available for sale both on and offline.\r\n\r\nCarefully choosing the foods in which you consume is another natural way to reduce or treat the symptoms of allergies. Lime squeezed into water has been known to assist those with allergies. Vegetable juices and bananas also come highly rated and recommended.\r\n\r\nAcupuncture is also an ideal way to treat and relieve the symptoms of allergies. According to WebMD, a trusted medical website, acupuncture helped to reduce all allergy symptoms in a study performed on twenty-six patients. If you are interested in giving acupuncture a try, consider contacting your local health spas, as many offer alternative healing approaches. If acupuncture is not a service offered, you should be provided with contact information for another local practitioner.\r\n\r\nIn addition to the above mentioned natural allergy remedies, there are also steps that you can take to prevent the onset of allergies or steps that you can take to reduce these symptoms. Most of these helpful tips can still be considered natural allergy remedies, but in a different sense. Also, these additional tips, a few of which are outlined below, are for just about anyone suffering from allergies, as they are affordable and easy to implement.\r\n\r\nFor pet allergies, stay a safe distance away from pets. With that said, if you are a pet owner who cannot bear to part with your beloved pets, be sure to keep them out of your bedroom, as this is where you spend most of your time.\r\n\r\nSince mold is a common trigger factor for allergies, it is important to take steps to remove mold from your home or prevent it from growing. Limiting the humidity in your home is a great way to reduce or completely prevent mold growth. Use a bathroom fan or open a bathroom window when taking a shower, to reduce mold growth in the bathroom. If you already have mold in your home, contact a professional to inquire about a mold removal. Until that time comes, be sure to avoid areas in your home where mold is present.\r\n\r\nThe above mentioned natural allergy remedies are just a few of the many that allergy sufferers recommend, but they are a few of the most popular approaches taken. As a reminder, it is important to remember that natural remedies and home remedies work differently on different individuals. If you do not see the success that you had hoped for, not all hope is lost, as there should be another natural allergy remedy out there that can provide you with relief. ", "Natural Allergy Remedies", "", "inherit", "closed", "closed", "", "66-revision-v1", "", "", "2015-05-27 20:14:25", "2015-05-27 20:14:25", "", "66", "http://demobay.info/remedy/66-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2015-05-27 20:21:20", "2015-05-27 20:21:20", "Each year, millions of Americans are faced with minor medical issues. These minor medical issues can range from headaches to chicken pox to head lice to warts. Although most minor medical issues, such as the ones previously mentioned, do not require medical treatment, many individuals are still looking for relief. Although over-the-counter medications do work in most cases, did you know that there is likely a number of natural remedies that you can also use to seek relief?\r\n\r\nAs nice as it is to hear that many minor medical issues can be treated with a natural remedy, you may be curious as to why you should give it a try. After a close examination, you will find that there are a number of benefits to using natural remedies, as opposed to over-the-counter medications. A few of those benefits are highlight below for your convenience.\r\n\r\nPerhaps, the greatest reason why you should at least give natural remedies a close look is because you know what you are putting into your body. For example, the juice from grapes is known as a natural remedy for headaches. When eating grapes or simply just drinking the juice from them, you know exactly what you are putting into your body, a grape. On the other hand, over-the-counter pain relievers are filled with countless ingredients, which are not natural. In fact, over-the-counter pain relievers and other over-the-counter medications are often full of warnings. This should cause you concern if it doesn\'t already.\r\n\r\nIn addition to being known as natural remedies, many are also commonly referred to as home remedies. This is because many individuals have the ingredients required in their homes already. For example, did you know that warts can effectively be removed by applying fresh cut onions, potatoes, or even pineapples to the wart? They can be and there is a good chance that you already have at least one of these food items in your home. What does this mean for you? It means that, depending on the home remedy in question, you can seek relief from the comfort of your own home, without making an extra trip to the drug store and without spending any additional money.\r\n\r\nSpeaking of saving money with the use of natural or home remedies, you may be surprised just how much money you are able to save. For example, if you are a parent whose child has head lice, did you know that you could easily spend between $30 and $50 on over-the-counter treatments? You can, but it is also important to mention that many young children develop lice multiple times a year. This is often due in part to the fact that not all children in a classroom have their lice effectively removed and lice may still be present in the home, which makes a re-infection easy. This could result in spending hundreds of dollars on over-the-counter treatments, when vinegar and mayonnaise are known as natural ways to get rid of head lice.\r\n\r\nAnother one of the many benefits to relying on the use of natural remedies, as opposed to over-the-counter medications, is the ease of use. As previously stated, many natural and home remedies use items that you already have inside your home, saving you a trip to the store and money. Not only that, but if you are currently unfamiliar with home remedies, it is easy to research them, especially online. A standard internet search can be performed, with the phrase \"natural remedies,\" or \"home remedies.\" With that being said, there are home and natural remedy books that can be purchased for affordable prices, both on and offline.\r\n\r\nAs you can see, there are a number of benefits to relying on natural remedies to treat many minor medical issues, especially when compared to over-the-counter medications. As previously stated, it is easy to find a wide range of home remedies online, free of charge. For that reason, at least consider trying a home remedy the next time that you are looking to seek relief. You may be surprised with the results. ", "Natural Remedies: Why You Should Give Them a Try", "", "publish", "closed", "closed", "", "natural-remedies-why-you-should-give-them-a-try", "", "", "2015-05-27 20:21:20", "2015-05-27 20:21:20", "", "0", "http://demobay.info/remedy/?p=69", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2015-05-27 20:21:10", "2015-05-27 20:21:10", "", "Herbs", "", "inherit", "closed", "closed", "", "herbs", "", "", "2015-05-27 20:21:10", "2015-05-27 20:21:10", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/herbs_1432758070.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("71", "1", "2015-05-27 20:21:20", "2015-05-27 20:21:20", "Each year, millions of Americans are faced with minor medical issues. These minor medical issues can range from headaches to chicken pox to head lice to warts. Although most minor medical issues, such as the ones previously mentioned, do not require medical treatment, many individuals are still looking for relief. Although over-the-counter medications do work in most cases, did you know that there is likely a number of natural remedies that you can also use to seek relief?\r\n\r\nAs nice as it is to hear that many minor medical issues can be treated with a natural remedy, you may be curious as to why you should give it a try. After a close examination, you will find that there are a number of benefits to using natural remedies, as opposed to over-the-counter medications. A few of those benefits are highlight below for your convenience.\r\n\r\nPerhaps, the greatest reason why you should at least give natural remedies a close look is because you know what you are putting into your body. For example, the juice from grapes is known as a natural remedy for headaches. When eating grapes or simply just drinking the juice from them, you know exactly what you are putting into your body, a grape. On the other hand, over-the-counter pain relievers are filled with countless ingredients, which are not natural. In fact, over-the-counter pain relievers and other over-the-counter medications are often full of warnings. This should cause you concern if it doesn\'t already.\r\n\r\nIn addition to being known as natural remedies, many are also commonly referred to as home remedies. This is because many individuals have the ingredients required in their homes already. For example, did you know that warts can effectively be removed by applying fresh cut onions, potatoes, or even pineapples to the wart? They can be and there is a good chance that you already have at least one of these food items in your home. What does this mean for you? It means that, depending on the home remedy in question, you can seek relief from the comfort of your own home, without making an extra trip to the drug store and without spending any additional money.\r\n\r\nSpeaking of saving money with the use of natural or home remedies, you may be surprised just how much money you are able to save. For example, if you are a parent whose child has head lice, did you know that you could easily spend between $30 and $50 on over-the-counter treatments? You can, but it is also important to mention that many young children develop lice multiple times a year. This is often due in part to the fact that not all children in a classroom have their lice effectively removed and lice may still be present in the home, which makes a re-infection easy. This could result in spending hundreds of dollars on over-the-counter treatments, when vinegar and mayonnaise are known as natural ways to get rid of head lice.\r\n\r\nAnother one of the many benefits to relying on the use of natural remedies, as opposed to over-the-counter medications, is the ease of use. As previously stated, many natural and home remedies use items that you already have inside your home, saving you a trip to the store and money. Not only that, but if you are currently unfamiliar with home remedies, it is easy to research them, especially online. A standard internet search can be performed, with the phrase \"natural remedies,\" or \"home remedies.\" With that being said, there are home and natural remedy books that can be purchased for affordable prices, both on and offline.\r\n\r\nAs you can see, there are a number of benefits to relying on natural remedies to treat many minor medical issues, especially when compared to over-the-counter medications. As previously stated, it is easy to find a wide range of home remedies online, free of charge. For that reason, at least consider trying a home remedy the next time that you are looking to seek relief. You may be surprised with the results. ", "Natural Remedies: Why You Should Give Them a Try", "", "inherit", "closed", "closed", "", "69-revision-v1", "", "", "2015-05-27 20:21:20", "2015-05-27 20:21:20", "", "69", "http://demobay.info/remedy/69-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2015-05-27 21:36:44", "2015-05-27 21:36:44", "So, you had a fun night out on the town last night with your romantic partner or a few close friends. Although you may have had a great time the night before, you may be feeling a little bit \"weird,\" the next day, especially if you consumed alcohol. If alcohol was consumed, you may be experiencing the ever so dreaded hangover.\r\n\r\nAnyone who has every experienced a hangover before knows the feeling of just wanting it all to go away. Unfortunately, many individuals believe that there is no \"cure,\" for a hangover. Although cure may not be the best word used to describe seeking treatment, there are a number of natural remedies which many claim do provide hangover relief. You are looking to relieve yourself from a hangover, please continue reading on as a few of these natural remedies, as well as tips for your next alcohol drinking outing are highlighted below.\r\n\r\nWater is a natural remedy for hangovers. Before heading to sleep, after a night of drinking, drinking a lot of water can assist with your hangover the next morning. Alcohol, especially when consumed in large amounts, can impact a body\'s hydration, which can result in unpleasant feelings the next morning. That is why a glass or two of water before bed is a great idea. The next morning, as soon as you wake, start drinking even more water. In addition to helping to treat a hangover, drinking water before you starting consuming alcohol also has a number of benefits.\r\n\r\nEating can also help with a hangover from too much alcohol consumption. Eating should be done before, during, and after alcohol consumption. Most importantly, it is important not to consume large amounts of alcohol on an empty stomach. This increase a drinker\'s likelihood of becoming intoxicated or drunk, and it also increases the chances of a hangover the next morning. Eating before, during, or after alcohol consumption can slow down the rate in which alcohol is absorbed into the body and bloodstream.\r\n\r\nAs for vitamins, which many individuals turn to when looking for a natural remedy, vitamin C and B is recommended for hangover relief. It has been claimed that vitamin B helps to shorten the length of a hangover. As for vitamin C, it can help to breakdown the alcohol in your body, also assisting with a hangover, namely by preventing one, shortening its length, or reducing symptoms.\r\n\r\nWhen it comes to a headache associated with a hangover, there are many individuals who take pain relievers. Of course, this approach will work for many, but it is not natural. If you are concerned with that you are putting in your body, you may be looking for a more natural way to relieve the headaches often associated with hangovers. A natural way to relieve a headache associated with a hangover is to place a cold pack on the head; however, a ziplock bag filled with ice will also do. Depending on the activities that you have planned for the day, consider getting extra rest, preferably with an ice pack on your head or neck.\r\n\r\nAn extra tip to help reduce the likelihood of a hangover involves limiting alcohol consumption. Many professionals recommend pacing yourself with one alcoholic drink an hour, as anything else increases the chances of a hangover. As previously stated, eating before, during, and after alcohol consumption can help with hangovers, as you aren\'t drinking on an empty stomach. Eating, even just snacking, while drinking will reduce the amount of alcohol consumed, as you are doing something other than just drinking. Also, some mixed drinks, especially those that are tasty, fruity, or sugary, should be avoided, as it is hard for some drinkers to gauge the amount of alcohol they are actually consuming.\r\n\r\nThe above mentioned natural remedies are just a few of the many that you can use to relieve the symptoms of a hangover. Also, the tips mentioned above can also reduce your chances of having a hangover following the consumption of alcohol.", "Natural Remedies for Hangovers", "", "publish", "closed", "closed", "", "natural-remedies-for-hangovers", "", "", "2015-05-27 21:36:44", "2015-05-27 21:36:44", "", "0", "http://demobay.info/remedy/?p=72", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2015-05-27 21:36:31", "2015-05-27 21:36:31", "", "Drunk", "", "inherit", "closed", "closed", "", "drunk", "", "", "2015-05-27 21:36:31", "2015-05-27 21:36:31", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/drunk_1432762591.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2015-05-27 21:36:44", "2015-05-27 21:36:44", "So, you had a fun night out on the town last night with your romantic partner or a few close friends. Although you may have had a great time the night before, you may be feeling a little bit \"weird,\" the next day, especially if you consumed alcohol. If alcohol was consumed, you may be experiencing the ever so dreaded hangover.\r\n\r\nAnyone who has every experienced a hangover before knows the feeling of just wanting it all to go away. Unfortunately, many individuals believe that there is no \"cure,\" for a hangover. Although cure may not be the best word used to describe seeking treatment, there are a number of natural remedies which many claim do provide hangover relief. You are looking to relieve yourself from a hangover, please continue reading on as a few of these natural remedies, as well as tips for your next alcohol drinking outing are highlighted below.\r\n\r\nWater is a natural remedy for hangovers. Before heading to sleep, after a night of drinking, drinking a lot of water can assist with your hangover the next morning. Alcohol, especially when consumed in large amounts, can impact a body\'s hydration, which can result in unpleasant feelings the next morning. That is why a glass or two of water before bed is a great idea. The next morning, as soon as you wake, start drinking even more water. In addition to helping to treat a hangover, drinking water before you starting consuming alcohol also has a number of benefits.\r\n\r\nEating can also help with a hangover from too much alcohol consumption. Eating should be done before, during, and after alcohol consumption. Most importantly, it is important not to consume large amounts of alcohol on an empty stomach. This increase a drinker\'s likelihood of becoming intoxicated or drunk, and it also increases the chances of a hangover the next morning. Eating before, during, or after alcohol consumption can slow down the rate in which alcohol is absorbed into the body and bloodstream.\r\n\r\nAs for vitamins, which many individuals turn to when looking for a natural remedy, vitamin C and B is recommended for hangover relief. It has been claimed that vitamin B helps to shorten the length of a hangover. As for vitamin C, it can help to breakdown the alcohol in your body, also assisting with a hangover, namely by preventing one, shortening its length, or reducing symptoms.\r\n\r\nWhen it comes to a headache associated with a hangover, there are many individuals who take pain relievers. Of course, this approach will work for many, but it is not natural. If you are concerned with that you are putting in your body, you may be looking for a more natural way to relieve the headaches often associated with hangovers. A natural way to relieve a headache associated with a hangover is to place a cold pack on the head; however, a ziplock bag filled with ice will also do. Depending on the activities that you have planned for the day, consider getting extra rest, preferably with an ice pack on your head or neck.\r\n\r\nAn extra tip to help reduce the likelihood of a hangover involves limiting alcohol consumption. Many professionals recommend pacing yourself with one alcoholic drink an hour, as anything else increases the chances of a hangover. As previously stated, eating before, during, and after alcohol consumption can help with hangovers, as you aren\'t drinking on an empty stomach. Eating, even just snacking, while drinking will reduce the amount of alcohol consumed, as you are doing something other than just drinking. Also, some mixed drinks, especially those that are tasty, fruity, or sugary, should be avoided, as it is hard for some drinkers to gauge the amount of alcohol they are actually consuming.\r\n\r\nThe above mentioned natural remedies are just a few of the many that you can use to relieve the symptoms of a hangover. Also, the tips mentioned above can also reduce your chances of having a hangover following the consumption of alcohol.", "Natural Remedies for Hangovers", "", "inherit", "closed", "closed", "", "72-revision-v1", "", "", "2015-05-27 21:36:44", "2015-05-27 21:36:44", "", "72", "http://demobay.info/remedy/72-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2015-05-27 21:38:52", "0000-00-00 00:00:00", "", "Woo Logo", "", "draft", "closed", "closed", "", "woo-wf-woo_logo", "", "", "2015-05-27 21:38:52", "0000-00-00 00:00:00", "", "0", "http://demobay.info/remedy/?post_type=wooframework&p=75", "0", "wooframework", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2015-05-27 21:38:52", "0000-00-00 00:00:00", "", "Woo Custom Favicon", "", "draft", "closed", "closed", "", "woo-wf-woo_custom_favicon", "", "", "2015-05-27 21:38:52", "0000-00-00 00:00:00", "", "0", "http://demobay.info/remedy/?post_type=wooframework&p=76", "0", "wooframework", "", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2015-05-27 21:43:19", "2015-05-27 21:43:19", "Are you a parent? If you are, there may come a point in time where your child may be faced with a minor medical issue. This minor medical issue can include something such as head lice, the chicken pox, a severe headache, or a toothache. While many parents wouldn\'t think twice about taking their child to a professional in the medical field, you may want to do so. Did you know that there are a large number of natural remedies that can be used to treat a wide range of minor medical problems, such as headaches, toothaches, head lice, or the chicken pox?\r\n\r\nAs nice as it is to hear that there are a number of natural remedies that may be perfect for children suffering from minor medical problems, many parents are still unsure. After all, parents want what is best for their children. That is why many parents, especially those who are unfamiliar with home remedies and natural remedies, are a little bit leery. Of course, natural remedies have their advantages and disadvantages, but so does just about everything else in the world. With that being said, you may still be wondering if natural remedies are right for your child. To help you come up with the conclusive answer that is best for your own family, please continue reading on.\r\n\r\nAs previously stated, natural remedies have their own sets of advantages and disadvantages. For the advantages, you will find that there are a large number of them. For example, natural remedies are safe. In fact, they are much safer than most over-the-counter products, as these products are often stocked full of chemicals that many of us cannot even pronounce.\r\n\r\nThe ease of use and implementation is another advantage or plus side to using natural remedies as a way to treat minor medical problems in a child. One of the reasons why natural remedies are also commonly referred to as home remedies is because many of the needed ingredients can already be found inside most homes. This makes treating a child with home remedies easy and convenient. It is also important to mention the saved time and money. Home remedies eliminate travel and costly trips to the doctor\'s office or drug store.\r\n\r\nAlthough most home and natural remedies are regarded as being safe, there are still a number of steps that you will want to take when using a home remedy on your child. For starters, be sure to follow all directions. Next, never give your child a home remedy that has an ingredient that they may be allergic to or have a reaction with, such as dairy foods. It is also important to discuss the process with your child. For example, if you are using mayonnaise to kill head lice, be sure to tell your child not to touch the mayonnaise, let alone eat it. Generally speaking, using your best judgment as a parent is one of the easiest ways for you and your child to see success with a home remedy.\r\n\r\nIf you are interested in examining what all of your options are, in terms of natural remedies, you can perform a standard internet search online. When doing so, it may be best to search for the specific home remedy that you are looking for. For example, if you are interested in getting rid of your child\'s head lice, search with the phrase \"natural head lice remedy.\" In addition to using the internet to your advantage, you can also purchase your own printed natural remedy manual, many of which are available for sale both on and offline.\r\n\r\nAs you can see, there are number of advantages to using home remedies and natural remedies as a way to treat your child when they are dealing with a minor medical problem, such as head lice, the chicken pox, a headache, or a toothache. Whether your family is uninsured or if your child just has a fear of the doctors office, consider giving a natural remedy a try first. Both you and your child may be pleased with the results.", "Natural Remedies and Children", "", "publish", "closed", "closed", "", "natural-remedies-and-children", "", "", "2015-05-27 21:43:19", "2015-05-27 21:43:19", "", "0", "http://demobay.info/remedy/?p=77", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2015-05-27 21:42:40", "2015-05-27 21:42:40", "", "Remedies", "", "inherit", "closed", "closed", "", "remedies", "", "", "2015-05-27 21:42:40", "2015-05-27 21:42:40", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/remedies_1432762960.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("79", "1", "2015-05-27 21:43:04", "2015-05-27 21:43:04", "", "Remedies", "", "inherit", "closed", "closed", "", "remedies-2", "", "", "2015-05-27 21:43:04", "2015-05-27 21:43:04", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/remedies_1432762984.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2015-05-27 21:43:19", "2015-05-27 21:43:19", "Are you a parent? If you are, there may come a point in time where your child may be faced with a minor medical issue. This minor medical issue can include something such as head lice, the chicken pox, a severe headache, or a toothache. While many parents wouldn\'t think twice about taking their child to a professional in the medical field, you may want to do so. Did you know that there are a large number of natural remedies that can be used to treat a wide range of minor medical problems, such as headaches, toothaches, head lice, or the chicken pox?\r\n\r\nAs nice as it is to hear that there are a number of natural remedies that may be perfect for children suffering from minor medical problems, many parents are still unsure. After all, parents want what is best for their children. That is why many parents, especially those who are unfamiliar with home remedies and natural remedies, are a little bit leery. Of course, natural remedies have their advantages and disadvantages, but so does just about everything else in the world. With that being said, you may still be wondering if natural remedies are right for your child. To help you come up with the conclusive answer that is best for your own family, please continue reading on.\r\n\r\nAs previously stated, natural remedies have their own sets of advantages and disadvantages. For the advantages, you will find that there are a large number of them. For example, natural remedies are safe. In fact, they are much safer than most over-the-counter products, as these products are often stocked full of chemicals that many of us cannot even pronounce.\r\n\r\nThe ease of use and implementation is another advantage or plus side to using natural remedies as a way to treat minor medical problems in a child. One of the reasons why natural remedies are also commonly referred to as home remedies is because many of the needed ingredients can already be found inside most homes. This makes treating a child with home remedies easy and convenient. It is also important to mention the saved time and money. Home remedies eliminate travel and costly trips to the doctor\'s office or drug store.\r\n\r\nAlthough most home and natural remedies are regarded as being safe, there are still a number of steps that you will want to take when using a home remedy on your child. For starters, be sure to follow all directions. Next, never give your child a home remedy that has an ingredient that they may be allergic to or have a reaction with, such as dairy foods. It is also important to discuss the process with your child. For example, if you are using mayonnaise to kill head lice, be sure to tell your child not to touch the mayonnaise, let alone eat it. Generally speaking, using your best judgment as a parent is one of the easiest ways for you and your child to see success with a home remedy.\r\n\r\nIf you are interested in examining what all of your options are, in terms of natural remedies, you can perform a standard internet search online. When doing so, it may be best to search for the specific home remedy that you are looking for. For example, if you are interested in getting rid of your child\'s head lice, search with the phrase \"natural head lice remedy.\" In addition to using the internet to your advantage, you can also purchase your own printed natural remedy manual, many of which are available for sale both on and offline.\r\n\r\nAs you can see, there are number of advantages to using home remedies and natural remedies as a way to treat your child when they are dealing with a minor medical problem, such as head lice, the chicken pox, a headache, or a toothache. Whether your family is uninsured or if your child just has a fear of the doctors office, consider giving a natural remedy a try first. Both you and your child may be pleased with the results.", "Natural Remedies and Children", "", "inherit", "closed", "closed", "", "77-revision-v1", "", "", "2015-05-27 21:43:19", "2015-05-27 21:43:19", "", "77", "http://demobay.info/remedy/77-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("81", "1", "2015-05-27 21:46:32", "2015-05-27 21:46:32", "Have years of smoking made your teeth yellow and darkened the color of your lips? Here are some home remedies that can help you retain teeth and lip color.\r\n\r\nWhiter Teeth\r\n\r\nThese home remedies will lighten the stains caused by smoking with the use of natural products. All the ingredients used are inexpensive and will save you many expensive trips to the dentist.\r\n\r\nStrawberries.\r\n\r\nTake three to six ripe strawberries, two teaspoons of baking soda, one teaspoon of cream of tartar and a cup of water. Puree the strawberries and make a paste. Apply to your teeth overnight for a week and dazzle everybody with your bright new smile.\r\n\r\nSugarless Gum.\r\n\r\nMunch on a piece of sugarless gum after you’ve had your coffee and cigarette. Doing so will produce more saliva to swish away the darkening liquids before they have a chance to stain your teeth.\r\n\r\nWater.\r\n\r\nSip on water or rinse you mouth every time you eat or drink a stain-producing food or beverage and after you light up. This will help cleanse your teeth and prevent stains from accumulating.\r\n\r\nBicarbonate of Soda.\r\n\r\nBrush your teeth with bicarbonate of soda and then brush with your normal toothpaste. Repeat this routine every 15 days.\r\n\r\nDon’t rush when you brush.\r\n\r\nConcentrate on brushing your teeth slowly with circular movements using a soft bristled toothbrush. Take your time and ensure that you get to those hard to reach areas.\r\n\r\nLighter Lips\r\n\r\nSmokers have darker lips than normal due to nicotine stains. Here are some methods which you can use to lighten your lips a shade.\r\n\r\nVaseline.\r\n\r\nApply Vaseline to your lips regularly. This keeps lips moisturized and helps prevent staining of your lips.\r\n\r\nLemon and Glycerin.\r\n\r\nScrubbing your lips gently with lemon daily should help remove the discoloration, but this may be harsh on your lips, so make sure you apply glycerin to your lips first. Leave the lemon and glycerin on for at least ten minutes before washing off. You could also do the same at night, and sleep with lemon on your lips.\r\n\r\nAlmond Oil.\r\n\r\nApply almond oil with a dab of cream on your lips. This will ensure that your lips are moisturized and the layer of oil will help prevent build up of nicotine stains on your lips. You can also apply almond oil or cream of milk daily on the lips.\r\n\r\nThe most important remedy to reduce staining on your lips and teeth is to quit smoking. The efficiency of these home remedies is dramatically increased if you do not add to the nicotine staining every day.\r\n\r\nWarning: The reader of this article should exercise all precautionary measures while following instructions on the home remedies from this article. Avoid using any of these products if you are allergic to it. The responsibility lies with the reader and not with the site or the writer.\r\n<div>\r\n<div id=\"new_selection_block0.685390603826351\">\r\n\r\n</div>\r\n</div>", "Home Remedies To Retain Teeth And Lip Color", "", "publish", "closed", "closed", "", "home-remedies-to-retain-teeth-and-lip-color", "", "", "2015-05-27 21:46:32", "2015-05-27 21:46:32", "", "0", "http://demobay.info/remedy/?p=81", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2015-05-27 21:46:17", "2015-05-27 21:46:17", "", "Smile", "", "inherit", "closed", "closed", "", "smile", "", "", "2015-05-27 21:46:17", "2015-05-27 21:46:17", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/smile_1432763177.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2015-05-27 21:46:32", "2015-05-27 21:46:32", "Have years of smoking made your teeth yellow and darkened the color of your lips? Here are some home remedies that can help you retain teeth and lip color.\r\n\r\nWhiter Teeth\r\n\r\nThese home remedies will lighten the stains caused by smoking with the use of natural products. All the ingredients used are inexpensive and will save you many expensive trips to the dentist.\r\n\r\nStrawberries.\r\n\r\nTake three to six ripe strawberries, two teaspoons of baking soda, one teaspoon of cream of tartar and a cup of water. Puree the strawberries and make a paste. Apply to your teeth overnight for a week and dazzle everybody with your bright new smile.\r\n\r\nSugarless Gum.\r\n\r\nMunch on a piece of sugarless gum after you’ve had your coffee and cigarette. Doing so will produce more saliva to swish away the darkening liquids before they have a chance to stain your teeth.\r\n\r\nWater.\r\n\r\nSip on water or rinse you mouth every time you eat or drink a stain-producing food or beverage and after you light up. This will help cleanse your teeth and prevent stains from accumulating.\r\n\r\nBicarbonate of Soda.\r\n\r\nBrush your teeth with bicarbonate of soda and then brush with your normal toothpaste. Repeat this routine every 15 days.\r\n\r\nDon’t rush when you brush.\r\n\r\nConcentrate on brushing your teeth slowly with circular movements using a soft bristled toothbrush. Take your time and ensure that you get to those hard to reach areas.\r\n\r\nLighter Lips\r\n\r\nSmokers have darker lips than normal due to nicotine stains. Here are some methods which you can use to lighten your lips a shade.\r\n\r\nVaseline.\r\n\r\nApply Vaseline to your lips regularly. This keeps lips moisturized and helps prevent staining of your lips.\r\n\r\nLemon and Glycerin.\r\n\r\nScrubbing your lips gently with lemon daily should help remove the discoloration, but this may be harsh on your lips, so make sure you apply glycerin to your lips first. Leave the lemon and glycerin on for at least ten minutes before washing off. You could also do the same at night, and sleep with lemon on your lips.\r\n\r\nAlmond Oil.\r\n\r\nApply almond oil with a dab of cream on your lips. This will ensure that your lips are moisturized and the layer of oil will help prevent build up of nicotine stains on your lips. You can also apply almond oil or cream of milk daily on the lips.\r\n\r\nThe most important remedy to reduce staining on your lips and teeth is to quit smoking. The efficiency of these home remedies is dramatically increased if you do not add to the nicotine staining every day.\r\n\r\nWarning: The reader of this article should exercise all precautionary measures while following instructions on the home remedies from this article. Avoid using any of these products if you are allergic to it. The responsibility lies with the reader and not with the site or the writer.\r\n<div>\r\n<div id=\"new_selection_block0.685390603826351\">\r\n\r\n</div>\r\n</div>", "Home Remedies To Retain Teeth And Lip Color", "", "inherit", "closed", "closed", "", "81-revision-v1", "", "", "2015-05-27 21:46:32", "2015-05-27 21:46:32", "", "81", "http://demobay.info/remedy/81-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2015-05-27 21:48:26", "2015-05-27 21:48:26", "A healthy lifestyle can help people with various disorders and diseases better control them, gaining a better quality of life. High blood pressure is one the diseases that can be better controlled with a healthy lifestyle. In some people, a healthy lifestyle can prevent high blood pressure from developing.\r\n\r\nMany of us have heard over and over to “lose weight and get more exercise” because it will help a person to maintain better health. Maintaining a healthy weight and exercising regularly can do a lot to help prevent and control high blood pressure.\r\n\r\nHigh blood pressure and a high weight are closely related. Being overweight significantly raises a person’s risk of developing high blood pressure. An overweight person raises their risk by as much as six times. But, as a person starts to take the extra pounds off, their blood pressure typically goes down too.\r\n\r\nTry to eat more fruits, vegetables, whole grains, low-fat dairy products, and lean protein.\r\n\r\n\r\n\r\nExercise is another important factor in preventing and controlling high blood pressure (http://www.gothypertension.com/managing/highbloodpressureandexercise). Exercising makes the heart stronger and enables it to pump blood throughout the body with less effort. The easier it is for the heart to pump blood, the easier it is on the arteries.\r\n\r\nRegular physical activity helps a person reach and maintain a healthy weight. The latest federal guidelines suggest a person engage in moderate physical activity 30-60 minutes a day, 5-7 days a week. Walking is a good physical activity, especially for people just starting an exercise routine. Swimming, biking, and jogging are also great forms of exercise. In addition, federal guidelines suggest a person engage in vigorous physical activities, such as strength training, three times a week for at least 20 minutes each time.\r\n\r\n\r\n\r\nSmoking is hard on the heart and nicotine cases the blood vessels to constrict, narrowing the blood vessels and making the heart work harder to pump blood through the body. Smoking also interferes with some blood pressure medications, making them much less effective. Quitting smoking reduces the risk for high blood pressure, will help to control existing high blood pressure, and will also reduce a person’s risk of developing lung cancer, heart disease, and having a stroke. Quitting smoking is very difficult, possibly the hardest thing a person will ever do, but doing so goes a long way towards improving a person’s health.\r\n\r\n\r\n\r\nAvoiding excessive sodium is suggested to help control and prevent high blood pressure, although there has been controversy in recent years about whether or not reducing sodium intake will have much of an effect on blood pressure. It may not have a big impact, but even a small reduction in sodium can have a positive effect on a person’s health.\r\n\r\nTake any prescribed high blood pressure medications as directed – don’t skip doses or quit taking it entirely. If, after being on medication for a period of time blood pressure returns to normal levels, it does not mean that person’s blood pressure has become normal. It means the medication is doing its job and is controlling the blood pressure. Blood pressure medication needs to be taking indefinitely, often for life.\r\n\r\nAvoid excessive alcohol consumption. Not only can it cause high blood pressure, it’s also bad for the liver and kidneys.\r\n\r\nAlthough studies have not proven whether or not caffeine affects high blood pressure, some studies have shown that people who regularly consume caffeine each day have higher blood pressure than people who don’t. On the other hand, some studies have shown that people eventually develop a tolerance to caffeine and that it then no longer affects their blood pressure. As a precautionary measure, physicians will usually advice patients with high blood pressure to limit their caffeine intake.\r\n<div>\r\n<div id=\"new_selection_block0.8165016598557201\">\r\n\r\n</div>\r\n</div>", "Controlling High Blood Pressure", "", "publish", "closed", "closed", "", "controlling-high-blood-pressure", "", "", "2015-05-27 21:48:26", "2015-05-27 21:48:26", "", "0", "http://demobay.info/remedy/?p=84", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2015-05-27 21:48:11", "2015-05-27 21:48:11", "", "Blood, Pressure", "", "inherit", "closed", "closed", "", "blood-pressure", "", "", "2015-05-27 21:48:11", "2015-05-27 21:48:11", "", "0", "http://demobay.info/remedy/wp-content/uploads/2015/05/blood_pressure_1432763291.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2015-05-27 21:48:26", "2015-05-27 21:48:26", "A healthy lifestyle can help people with various disorders and diseases better control them, gaining a better quality of life. High blood pressure is one the diseases that can be better controlled with a healthy lifestyle. In some people, a healthy lifestyle can prevent high blood pressure from developing.\r\n\r\nMany of us have heard over and over to “lose weight and get more exercise” because it will help a person to maintain better health. Maintaining a healthy weight and exercising regularly can do a lot to help prevent and control high blood pressure.\r\n\r\nHigh blood pressure and a high weight are closely related. Being overweight significantly raises a person’s risk of developing high blood pressure. An overweight person raises their risk by as much as six times. But, as a person starts to take the extra pounds off, their blood pressure typically goes down too.\r\n\r\nTry to eat more fruits, vegetables, whole grains, low-fat dairy products, and lean protein.\r\n\r\n\r\n\r\nExercise is another important factor in preventing and controlling high blood pressure (http://www.gothypertension.com/managing/highbloodpressureandexercise). Exercising makes the heart stronger and enables it to pump blood throughout the body with less effort. The easier it is for the heart to pump blood, the easier it is on the arteries.\r\n\r\nRegular physical activity helps a person reach and maintain a healthy weight. The latest federal guidelines suggest a person engage in moderate physical activity 30-60 minutes a day, 5-7 days a week. Walking is a good physical activity, especially for people just starting an exercise routine. Swimming, biking, and jogging are also great forms of exercise. In addition, federal guidelines suggest a person engage in vigorous physical activities, such as strength training, three times a week for at least 20 minutes each time.\r\n\r\n\r\n\r\nSmoking is hard on the heart and nicotine cases the blood vessels to constrict, narrowing the blood vessels and making the heart work harder to pump blood through the body. Smoking also interferes with some blood pressure medications, making them much less effective. Quitting smoking reduces the risk for high blood pressure, will help to control existing high blood pressure, and will also reduce a person’s risk of developing lung cancer, heart disease, and having a stroke. Quitting smoking is very difficult, possibly the hardest thing a person will ever do, but doing so goes a long way towards improving a person’s health.\r\n\r\n\r\n\r\nAvoiding excessive sodium is suggested to help control and prevent high blood pressure, although there has been controversy in recent years about whether or not reducing sodium intake will have much of an effect on blood pressure. It may not have a big impact, but even a small reduction in sodium can have a positive effect on a person’s health.\r\n\r\nTake any prescribed high blood pressure medications as directed – don’t skip doses or quit taking it entirely. If, after being on medication for a period of time blood pressure returns to normal levels, it does not mean that person’s blood pressure has become normal. It means the medication is doing its job and is controlling the blood pressure. Blood pressure medication needs to be taking indefinitely, often for life.\r\n\r\nAvoid excessive alcohol consumption. Not only can it cause high blood pressure, it’s also bad for the liver and kidneys.\r\n\r\nAlthough studies have not proven whether or not caffeine affects high blood pressure, some studies have shown that people who regularly consume caffeine each day have higher blood pressure than people who don’t. On the other hand, some studies have shown that people eventually develop a tolerance to caffeine and that it then no longer affects their blood pressure. As a precautionary measure, physicians will usually advice patients with high blood pressure to limit their caffeine intake.\r\n<div>\r\n<div id=\"new_selection_block0.8165016598557201\">\r\n\r\n</div>\r\n</div>", "Controlling High Blood Pressure", "", "inherit", "closed", "closed", "", "84-revision-v1", "", "", "2015-05-27 21:48:26", "2015-05-27 21:48:26", "", "84", "http://demobay.info/remedy/84-revision-v1/", "0", "revision", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("57", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("63", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("69", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("72", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("77", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "1", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "category", "", "0", "2");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Natural Remedies Tips", "natural-remedies-tips", "0");
INSERT INTO `wp_terms` VALUES("6", "Skin Care", "skin-care", "0");
INSERT INTO `wp_terms` VALUES("7", "Allergies", "allergies", "0");
INSERT INTO `wp_terms` VALUES("8", "About Natural Remedies", "about-natural-remedies", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "x");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "x");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp360_locks,wp390_widgets,wp410_dfw");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_dashboard_quick_press_last_post_id", "13");
INSERT INTO `wp_usermeta` VALUES("16", "1", "session_tokens", "a:4:{s:64:\"5641abbe4d54124176b47a15ff88c5e494f4cd7cab1e66ea180b8ba43a7082ff\";a:4:{s:10:\"expiration\";i:1433890642;s:2:\"ip\";s:14:\"188.31.149.155\";s:2:\"ua\";s:72:\"Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0\";s:5:\"login\";i:1432681042;}s:64:\"6e13d50a55cedc57930adcd6f41bfbedce39613d63281616d319b87e5433b01e\";a:4:{s:10:\"expiration\";i:1432910086;s:2:\"ip\";s:15:\"151.224.113.241\";s:2:\"ua\";s:72:\"Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0\";s:5:\"login\";i:1432737286;}s:64:\"2c473c211e8201db16588b4460813a9904b5b70ea6ea9ca1caaf5f8fab38e796\";a:4:{s:10:\"expiration\";i:1432915886;s:2:\"ip\";s:15:\"151.224.113.241\";s:2:\"ua\";s:72:\"Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0\";s:5:\"login\";i:1432743086;}s:64:\"3e32912c99e96589b8c3ede1516d65a74fb3ab9cbeb8085bbf245c387fa2742d\";a:4:{s:10:\"expiration\";i:1433965803;s:2:\"ip\";s:13:\"188.30.144.42\";s:2:\"ua\";s:72:\"Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0\";s:5:\"login\";i:1432756203;}}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_user-settings", "editor=tinymce&libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("18", "1", "wp_user-settings-time", "1432762600");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$BGDtfs4p7WytuRcC4t3pljE4ZGEcvJ0", "admin", "mail@yourmail.com", "", "2015-05-14 22:21:27", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2015-05-27 21:49:39*/
/* DUPLICATOR_MYSQLDUMP_EOF */
